2026-04-26  Dmitry V. Levin  <ldv@strace.io>

	Prepare for 7.0 release.
	* NEWS: Update for 7.0 release.

	Update copyright headers.
	Headers updated automatically using maint/update_copyright_years.sh
	script.

2026-04-24  Dmitry V. Levin  <ldv@strace.io>
	    Cursor AI  <auto@cursor.ai>

	Implement decoding of rseq_slice_yield syscall.
	This new syscall was introduced by Linux kernel commit
	v7.0-rc1~191^2~27.

	* src/linux/generic/syscallent-common.h [BASE_NR + 471]: Wire up
	rseq_slice_yield.
	* src/syscall_dummy.h (sys_rseq_slice_yield): New entry.
	* tests/rseq_slice_yield.c: New file.
	* tests/gen_tests.in (rseq_slice_yield): New test.
	* tests/pure_executables.list: Add rseq_slice_yield.
	* tests/.gitignore: Likewise.
	* NEWS: Mention this change.

2026-04-23  Dmitry V. Levin  <ldv@strace.io>
	    Cursor AI  <auto@cursor.ai>

	statmount: decode flags argument.
	Implement decoding of STATMOUNT_BY_FD bit in flags argument
	introduced by Linux kernel commit v7.0-rc1~236^2~2^2~1.

	* src/xlat/statmount_flags.in: New file.
	* src/statmount.c: Include "xlat/statmount_flags.h".
	(SYS_FUNC(statmount)): Decode flags argument with statmount_flags
	using printflags.
	* tests/statmount.c: Check it.
	* NEWS: Mention this change.

2026-04-23  Dmitry V. Levin  <ldv@strace.io>
	    Cursor AI  <auto@cursor.ai>

	xlat: update V4L2_* constants.
	* src/xlat/v4l2_control_ids.in (V4L2_CID_FLASH_DURATION): New constant
	introduced by Linux kernel commit v7.0-rc1~149^2~73.
	(V4L2_CID_FLASH_STROBE_OE): New constant introduced by Linux kernel
	commit v7.0-rc1~149^2~72.
	* src/xlat/v4l2_control_types.in (V4L2_CTRL_TYPE_HEVC_EXT_SPS_ST_RPS,
	V4L2_CTRL_TYPE_HEVC_EXT_SPS_LT_RPS): New constants introduced by Linux
	kernel commit v7.0-rc1~149^2~19.
	* src/xlat/v4l2_pix_fmts.in (V4L2_PIX_FMT_AV1): New constant introduced
	by Linux kernel commit v7.0-rc1~149^2~218.
	* NEWS: Mention this change.

	xlat: update PR_* constants.
	* src/xlat/prctl_options.in (PR_RSEQ_SLICE_EXTENSION): New constant
	introduced by Linux kernel commit v7.0-rc1~191^2~28.
	(PR_GET_CFI, PR_SET_CFI): New constants introduced by Linux kernel
	commit v7.0~15^2.
	* tests/prctl-no-args.c (options_unknown): Update.
	* NEWS: Mention this change.

	xlat: update OPEN_TREE_* constants.
	* src/xlat/open_tree_flags.in (OPEN_TREE_NAMESPACE): New constant
	introduced by Linux kernel commit v7.0-rc1~236^2^2~1.
	* tests/open_tree.c (main): Update expected output.
	* tests/open_tree_attr.c (main): Likewise.
	* NEWS: Mention this change.

	xlat: update *_MAGIC constants.
	* src/xlat/fsmagic.in (NULL_FS_MAGIC): New constant introduced
	by Linux kernel commit v7.0-rc1~238^2~1^2~1.
	* NEWS: Mention this change.

	xlat: update KVM_EXIT_* constants.
	* src/xlat/kvm_exit_reason.in (KVM_EXIT_ARM_LDST64B): New constant
	introduced by Linux kernel commit v7.0-rc1~210^2~10^2~7.
	(KVM_EXIT_SNP_REQ_CERTS): New constant introduced by Linux kernel
	commit v7.0-rc1~103^2~6^2~1.
	* NEWS: Mention this change.

	xlat: update KVM_CAP_* constants.
	* src/xlat/kvm_cap.in (KVM_CAP_S390_KEYOP): New constant introduced
	by Linux kernel commit v7.0-rc1~103^2^2~7.
	* NEWS: Mention this change.

	xlat: update IORING_SETUP_* constants.
	* src/xlat/uring_setup_flags.in (IORING_SETUP_SQ_REWIND): New constant
	introduced by Linux kernel commit v7.0-rc1~223^2~10.
	* tests/io_uring_setup.c (main): Update expected output.
	* NEWS: Mention this change.

	xlat: update IORING_REGISTER_* constants.
	* src/xlat/uring_register_opcodes.in (IORING_REGISTER_BPF_FILTER): New
	constant introduced by Linux kernel commit v7.0-rc1~222^2~6.
	* tests/io_uring_register.c (main): Update expected output.
	* NEWS: Mention this change.

	xlat: update KEY_* constants.
	* src/xlat/evdev_keycode.in (KEY_ACTION_ON_SELECTION,
	KEY_CONTEXTUAL_INSERT, KEY_CONTEXTUAL_QUERY): New constants introduced
	by Linux kernel commit v7.0~30^2.
	* NEWS: Mention this change.

	xlat: update FS_XFLAG_* constants.
	* src/xlat/fs_xflags.in (FS_XFLAG_VERITY): New constant introduced
	by Linux kernel commit v7.0-rc1~70^2~4^2~1.
	* tests/test_fs_xflags.h: Update the FS_XFLAGS test macros.
	* NEWS: Mention this change.

	xlat: update NT_* constants.
	* src/xlat/nt_descriptor_types.in (NT_RISCV_USER_CFI): New constant
	introduced by Linux kernel commit v7.0-rc1~107^2~21.
	* NEWS: Mention this change.

2026-04-23  Dmitry V. Levin  <ldv@strace.io>

	xlat: update BTRFS_* constants.
	* src/xlat/btrfs_features_incompat.in
	(BTRFS_FEATURE_INCOMPAT_REMAP_TREE): New constant introduced by Linux
	kernel commit v7.0-rc1~232^2~86.
	* src/xlat/btrfs_key_types.in (BTRFS_IDENTITY_REMAP_KEY,
	BTRFS_REMAP_KEY, BTRFS_REMAP_BACKREF_KEY): New constants
	introduced by Linux kernel commit v7.0-rc1~232^2~86.
	* src/xlat/btrfs_space_info_flags.in (BTRFS_BLOCK_GROUP_RAID1C3): New
	constant introduced by Linux kernel commit v5.5-rc1~195^2~19.
	(BTRFS_BLOCK_GROUP_RAID1C4): New constant introduced by Linux kernel
	commit v5.5-rc1~195^2~18.
	(BTRFS_BLOCK_GROUP_REMAPPED): New constant introduced by Linux kernel
	commit v7.0-rc1~232^2~86.
	(BTRFS_BLOCK_GROUP_METADATA_REMAP): New constant introduced by Linux
	kernel commit v7.0-rc1~232^2~85.
	* src/xlat/btrfs_tree_objectids.in (BTRFS_REMAP_TREE_OBJECTID): New
	constant introduced by Linux kernel commit v7.0-rc1~232^2~86.
	* NEWS: Mention this change.

2026-04-22  Dmitry V. Levin  <ldv@strace.io>
	    Cursor AI  <auto@cursor.ai>

	xlat: update BPF_* constants.
	* src/xlat/bpf_map_lookup_elem_flags.in (BPF_F_CPU, BPF_F_ALL_CPUS):
	New constants introduced by Linux kernel commit v7.0-rc1~196^2~80^2~6.
	* src/xlat/bpf_map_update_elem_flags.in: Likewise.
	* tests/bpf.c: Check it.
	* NEWS: Mention this change.

2026-04-21  Dmitry V. Levin  <ldv@strace.io>

	bpf: Fix decoding of BPF_MAP_*_ELEM flags.
	Make sure that flags are always printed as flags, but the value 0
	is printed as BPF_ANY.

	* src/xlat/bpf_map_lookup_elem_flags.in: Change order so that flag bits
	with higher value go first.
	* src/xlat/bpf_map_update_elem_flags.in: Likewise.
	(#value_indexed): Remove.
	* src/bpf.c (print_bpf_map_xxx_flags): New function.
	(BPF_MAP_LOOKUP_ELEM, BPF_MAP_UPDATE_ELEM): Use it to print attr.flags.
	BPF_MAP_LOOKUP_BATCH, BPF_MAP_UPDATE_BATCH, BPF_MAP_DELETE_BATCH): Use
	it to print attr.elem_flags.
	(BPF_MAP_UPDATE_BATCH): Use bpf_map_update_elem_flags instead of
	bpf_map_lookup_elem_flags to print attr.elem_flags.
	* tests/bpf.c: Check it.

2026-04-21  Dmitry V. Levin  <ldv@strace.io>
	    Cursor AI  <auto@cursor.ai>

	bpf: implement decoding of BPF_TRACE_FSESSION attach type.
	* src/xlat/bpf_attach_type.in (BPF_TRACE_FSESSION): New constant introduced
	by Linux kernel commit v7.0-rc1~196^2~34^2~12.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_LINK_CREATE)): Add BPF_TRACE_FSESSION
	to the tracing case.
	* tests/bpf.c (BPF_PROG_QUERY_checks): Expect unknown attach type 59.
	(special_attach_types): Skip 58 in BPF_LINK_CREATE attach type iteration.
	(BPF_LINK_CREATE_checks): Cover BPF_TRACE_FSESSION; renumber following
	checks.
	* NEWS: Mention this change.

	bpf: implement decoding of BPF_PROG_ASSOC_STRUCT_OPS command.
	* src/xlat/bpf_commands.in (BPF_PROG_ASSOC_STRUCT_OPS): New constant
	introduced by Linux kernel commit v7.0-rc1~196^2~109^2~4.
	* src/bpf_attr.h (bpf_prog_assoc_struct_ops,
	BPF_PROG_ASSOC_STRUCT_OPS_struct): New structures.
	* src/bpf.c (print_prog_assoc_struct_ops): New function.
	(BEGIN_BPF_CMD_DECODER(BPF_PROG_ASSOC_STRUCT_OPS)): Likewise.
	(SYS_FUNC(bpf)) <bpf_cmd_decoders[]>: Use it.
	* tests/bpf.c (union bpf_attr_data): Add
	BPF_ATTR_DATA_FIELD(BPF_PROG_ASSOC_STRUCT_OPS).
	(BPF_PROG_ASSOC_STRUCT_OPS_checks): New checks array.
	(main) <checks>: Add CHK(BPF_PROG_ASSOC_STRUCT_OPS).
	* NEWS: Mention this change.

2026-04-21  Dmitry V. Levin  <ldv@strace.io>

	tests: fix rseq test on big-endian architectures.
	* tests/rseq.c (main): Set struct rseq_cs.flags explicitly.

	Resolves: https://github.com/strace/strace/issues/389

2026-04-16  Dmitry V. Levin  <ldv@strace.io>

	tests: robustify strace--color-tty.test.
	* tests/strace--color-tty.test: Skip the test when `script`
	does not work.

2026-04-16  Barnabás Pőcze  <pobrn@protonmail.com>

	v4l2: implement decoding of VIDIOC_QUERYMENU ioctl command.
	Decode the `VIDIOC_QUERYMENU` ioctl, which is used for both string and
	integer menu controls.  Unfortunately, without querying the type of the
	control it is not possible to know if it is a string or integer, so
	print both.

	Integer menus:

	  ioctl(3, VIDIOC_QUERYMENU, {id=V4L2_CTRL_CLASS_USER+0xf907, index=2} => {name="\2", value=2}) = 0

	String menus:

	  ioctl(3, VIDIOC_QUERYMENU, {id=V4L2_CTRL_CLASS_USER+0xf904, index=1} => {name="Menu Item 1", value=7310548498887107917}) = 0

	* src/v4l2.c (print_v4l2_querymenu): New function.
	(v4l2_ioctl) <VIDIOC_QUERYMENU>: Use it.
	* tests/ioctl_v4l2.c (main): Remove `VIDIOC_QUERYMENU` from the list
	of unsupported ioctls, and add some tests for it.
	* tests/ioctl_v4l2-success.c (main): Add some `VIDIOC_QUERYMENU` tests.
	* NEWS: Mention this change.

2026-04-15  Dmitry V. Levin  <ldv@strace.io>
	    Cursor AI  <cursor@cursor.com>

	tests: check decoding of rseq syscall.
	* tests/rseq.c: New file.
	* tests/gen_tests.in (rseq): New test.
	* tests/pure_executables.list: Add rseq.
	* tests/.gitignore: Likewise.

2026-04-15  Jiri Slaby  <jirislaby@gmail.com>
	    Dmitry V. Levin  <ldv@strace.io>
	    Cursor AI  <cursor@cursor.com>

	Implement decoding of rseq syscall.
	Decode all arguments of the Linux rseq(2) syscall.

	* src/rseq.c: New file.
	* src/Makefile.am (libstrace_a_SOURCES): Add rseq.c.
	* src/syscall_dummy.h (sys_rseq): Remove.
	* src/xlat/rseq_flags.in: New file.
	* src/xlat/rseq_cs_flags.in: Likewise.
	* NEWS: Mention this change.

2026-04-14  Dmitry V. Levin  <ldv@strace.io>

	bundled: add uapi/linux/rseq.h.
	* bundled/linux/include/uapi/linux/rseq.h: New file, imported from
	headers_install'ed Linux kernel v7.0.
	* bundled/Makefile.am (EXTRA_DIST): Add linux/include/uapi/linux/rseq.h.

2026-04-13  Gleb Fotengauer-Malinovskiy  <glebfm@altlinux.org>

	Update ioctl entries from linux v7.0 and fix affected test.
	* src/linux/32/ioctls_inc_align16.h: Update from linux v7.0 using
	ioctls_gen.sh.
	* src/linux/32/ioctls_inc_align32.h: Likewise.
	* src/linux/32/ioctls_inc_align64.h: Likewise.
	* src/linux/64/ioctls_inc.h: Likewise.
	* src/linux/x32/ioctls_inc0.h: Likewise.
	* src/linux/s390/ioctls_arch0.h: Likewise.
	* src/linux/s390x/ioctls_arch0.h: Likewise.
	* NEWS: Mention this change.
	* tests/ioctl_kd.c: Update unknown ioctl numbers to skip now known
	AMDKFD_IOC_CREATE_PROCESS.

	maint: update for linux v7.0.
	* maint/ioctls_sym.sh (process_file): Add a workaround definition
	of __force.

2026-04-13  Dmitry V. Levin  <ldv@strace.io>

	bundled: update linux UAPI headers to v7.0.
	* bundled/linux/include/uapi/linux/input-event-codes.h: Update to
	headers_install'ed Linux kernel v7.0.
	* bundled/linux/include/uapi/linux/prctl.h: Likewise.

2026-04-12  Weixie Cui  <cuiweixie@gmail.com>

	socketutils: remove redundant check.
	* src/socketutils.c (get_sockaddr_by_inode_cached): `e` is always not NULL
	because `cache` is static.

2026-04-07  Dmitry V. Levin  <ldv@strace.io>

	tests: pass $prog_args to run_prog() in run_strace_match_diff()
	QUIRK:PROG-ARGS extends the program argv; the silent baseline run must
	use the same arguments as run_strace(), otherwise there is a risk that
	match_diff() compares inconsistent runs.

	* tests/init-once.sh (run_strace_match_diff): Pass prog_args to run_prog.

2026-04-06  Dmitry V. Levin  <ldv@strace.io>

	tests: generalize errno2name()
	errno2name() used to read the global errno, so callers had to assign
	errno before calling it.  Take the error number as an argument so errno
	names can be printed without changing errno.

	* tests/errno2name.c (errno2name): Take errnum argument instead of
	global errno.
	* tests/tests.h (errno2name): Update prototype.
	* tests/modify_ldt.c (printrc): Call errno2name(err).
	* tests/qual_fault.c (main): Likewise.
	* tests/move_pages.c (print_status_array): Call errno2name(-status[i]).
	* tests/sprintrc.c: Include <errno.h>.
	(sprintrc_ex): Call errno2name(errno).

2026-04-05  Jonas Jelten  <jj@sft.lol>
	    Dmitry V. Levin  <ldv@strace.io>

	Implement optional colorized trace output.
	When the trace output stream is a terminal (stderr by default, or the
	file passed to -o), trace lines can use ANSI colors for syscall names,
	field names and values, punctuation, return values, errors, and decoded
	constants.  Auto mode follows NO_COLOR, skips coloring when using -ff,
	for non-tty output and for terminals that support less than 8 colors.
	STRACE_COLORS customizes roles with SGR parameter lists restricted to
	digits and semicolons.

	* configure.ac: Check for termcap.h and tgetnum, define HAVE_TGETNUM
	and set termcap_LIBS when available.
	* src/color.c: New file.
	* src/color.h: Likewise.
	* src/Makefile.am (libstrace_a_SOURCES): Add color.c and color.h.
	(strace_LDADD): Link with $(termcap_LIBS).
	* src/defs.h (tprints_string_uncol): New prototype.
	* src/print_fields.h: Emit color sequences around structured printing
	and field names when coloring is enabled.
	* src/strace.c (tprints_string_uncol): New function.
	(tprints_string): Call it and update curcol on success.
	(init): Parse --color=auto|always|never.  Call color_init after the log
	stream is configured.
	* src/syscall.c (syscall_entering_trace): Emit reset after printing
	syscall arguments.
	* src/xlat.c (printflags_ex, print_xlat_ex, printxvals_ex): Color
	symbolic names outside verbose comments.
	* doc/strace.1.in: Document --color, NO_COLOR, and STRACE_COLORS
	* tests/options-syntax.test: Check invalid --color syntax.
	* tests/strace--color-no-tty.test: New test.
	* tests/strace--color-tty.test: Likewise.
	* tests/Makefile.am (MISC_TESTS): Add strace--color-no-tty.test
	and strace--color-tty.test.
	* NEWS: Mention this change.

	Resolves: https://github.com/strace/strace/issues/39

2026-04-05  Dmitry V. Levin  <ldv@strace.io>

	strace: use tprint_arg_end and tprint_space instead of open-coding them.
	* src/strace.c (print_event_exit): Use tprint_arg_end and tprint_space.

2026-04-02  Dmitry V. Levin  <ldv@strace.io>

	xlat: optimize XLAT_STYLE_VERBOSE handling in printflags_ex.
	* src/xlat.c (printflags_ex): Cache the result in const need_comment,
	merge it with the non-zero flags guard before print_xlat_val, and drop
	redundant xlat_verbose comparisons.

2026-04-01  dependabot[bot]  <49699333+dependabot[bot]@users.noreply.github.com>

	build(deps): bump actions/upload-artifact from 6.0.0 to 7.0.0.
	Bumps [actions/upload-artifact](https://github.com/actions/upload-artifact) from 6.0.0 to 7.0.0.
	- [Release notes](https://github.com/actions/upload-artifact/releases)
	- [Commits](https://github.com/actions/upload-artifact/compare/b7c566a772e6b6bfb58ed0dc250532a479d7789f...bbbca2ddaa5d8feaa63e36b76fdaad77386f024f)

	---
	updated-dependencies:
	- dependency-name: actions/upload-artifact
	  dependency-version: 7.0.0
	  dependency-type: direct:production
	  update-type: version-update:semver-major
	...

2026-03-23  Barnabás Pőcze  <pobrn@protonmail.com>

	tests: check decoding of UDMABUF_* ioctl commands.
	* tests/ioctl_udmabuf.c: New file.
	* tests/gen_tests.in (ioctl_udmabuf): New test.
	* tests/pure_executables.list: Add ioctl_udmabuf.
	* tests/.gitignore: Likewise.

2026-03-23  Barnabás Pőcze  <pobrn@protonmail.com>

	ioctl: implement decoding of UDMABUF_* ioctls.
	Decode the two currently supported udmabuf ioctls introduced by Linux kernel
	commit v4.20-rc1~81^2~30^2~33: UDMABUF_CREATE and UDMABUF_CREATE_LIST.

	* src/defs.h (DECL_IOCTL(udmabuf)): New declaration.
	* src/ioctl.c (ioctl_decode) <case 'u'>: Call udmabuf_ioctl.
	* src/udmabuf.c: New file.
	* src/xlat/udmabuf_flags.in: Likewise.
	* src/Makefile.am (libstrace_a_SOURCES): Add udmabuf.c.
	* NEWS: Mention this change.

2026-03-23  Dmitry V. Levin  <ldv@strace.io>

	bundled: add uapi/linux/udmabuf.h.
	* bundled/linux/include/uapi/linux/udmabuf.h: New file, imported from
	headers_install'ed Linux kernel v7.0-rc4.
	* bundled/Makefile.am (EXTRA_DIST): Add
	linux/include/uapi/linux/udmabuf.h.

2026-03-12  Dmitry V. Levin  <ldv@strace.io>

	.github/workflows/ci.yml: switch coverage job from ubuntu-24.04 to ubuntu-latest
	Since this job uses default gcc version, let's use default ubuntu
	version as well.  Even though ubuntu-latest is currently ubuntu-24.04,
	this is going to change in the future.

2026-03-11  Weixie Cui  <cuiweixie@gmail.com>

	count: use uint64_t for tmp variables to match struct call_counts types.

2026-03-11  Jonas Jelten  <jj@sft.lol>

	tests: fix missing vdso explicit syscall filtering.
	The fix in b2f55b6a137855ce399cdcf8b362cdfb6efb13ad was not enough,
	we need to apply it to more test helper functions, but more importantly,
	we have to change the regex to allow matching for:

	  clock_gettime64(CLOCK_MONOTONIC, {tv_sec=1330, tv_nsec=507731034}) = 0

	which contains a =, so we can't match for [^=].

	Complements: v6.19~54 "tests: workaround issues with recent glibc on platforms lacking vDSO"

2026-03-11  Dmitry V. Levin  <ldv@strace.io>

	bundled: update linux/io_uring/query.h to v7.0-rc3.
	* bundled/linux/include/uapi/linux/io_uring/query.h: Update to
	headers_install'ed Linux kernel v7.0-rc3.
	* src/io_uring.c (print_io_uring_query_zcrx): Follow the rename
	of "__resv1" field of struct io_uring_query_zcrx to "features".
	* tests/io_uring_register.c (test_IORING_REGISTER_QUERY): Update
	expected output.

2026-03-10  Dmitry V. Levin  <ldv@strace.io>

	bundled: update linux/io_uring.h to v7.0-rc3.
	* bundled/linux/include/uapi/linux/io_uring.h: Update to
	headers_install'ed Linux kernel v7.0-rc3.
	* src/io_uring.c (print_io_uring_zcrx_ifq_reg): Follow the rename
	of __resv2 field of struct io_uring_zcrx_ifq_reg to rx_buf_len.
	* tests/io_uring_register.c (test_IORING_REGISTER_ZCRX_IFQ): Update
	expected output.

2026-03-09  Dmitry V. Levin  <ldv@strace.io>

	bundled: update linux UAPI headers to v7.0-rc3.
	The update of linux/io_uring.h is delayed because the change in
	struct io_uring_zcrx_ifq_reg requires a synchronous update of
	the header, the parser and the test.

	The update of linux/io_uring/query.h is delayed because the change in
	struct io_uring_query_zcrx requires a synchronous update of the header,
	the parser and the test.

	* bundled/linux/include/uapi/linux/typelimits.h: New file.
	* bundled/Makefile.am (EXTRA_DIST): Add
	linux/include/uapi/linux/typelimits.h.
	* bundled/linux/include/uapi/linux/blkzoned.h: Update to
	headers_install'ed Linux kernel v7.0-rc3.
	* bundled/linux/include/uapi/linux/btrfs.h: Likewise.
	* bundled/linux/include/uapi/linux/btrfs_tree.h: Likewise.
	* bundled/linux/include/uapi/linux/ethtool.h: Likewise.
	* bundled/linux/include/uapi/linux/fs.h: Likewise.
	* bundled/linux/include/uapi/linux/if_alg.h: Likewise.
	* bundled/linux/include/uapi/linux/if_link.h: Likewise.
	* bundled/linux/include/uapi/linux/landlock.h: Likewise.
	* bundled/linux/include/uapi/linux/mount.h: Likewise.
	* bundled/linux/include/uapi/linux/mptcp_pm.h: Likewise.
	* bundled/linux/include/uapi/linux/nl80211.h: Likewise.
	* bundled/linux/include/uapi/linux/perf_event.h: Likewise.
	* bundled/linux/include/uapi/linux/pkt_sched.h: Likewise.
	* bundled/linux/include/uapi/linux/prctl.h: Likewise.
	* bundled/linux/include/uapi/linux/taskstats.h: Likewise.
	* bundled/linux/include/uapi/linux/tcp.h: Likewise.
	* bundled/linux/include/uapi/linux/v4l2-controls.h: Likewise.
	* bundled/linux/include/uapi/linux/version.h: Likewise.
	* bundled/linux/include/uapi/linux/videodev2.h: Likewise.

2026-03-05  Dmitry V. Levin  <ldv@strace.io>

	Assume linux/if_alg.h is bundled.
	* configure.ac (AC_CHECK_HEADERS): Remove linux/if_alg.h.
	(AC_CHECK_TYPES): Remove struct sockaddr_alg_new.
	* tests/sockaddr_xlat.c: Include <linux/if_alg.h> unconditionally.
	[!HAVE_LINUX_IF_ALG_H, !HAVE_STRUCT_SOCKADDR_ALG_NEW]: Remove.

	Complements: v5.15~55 "sockaddr: implement decoding of AF_ALG socket addresses"

2026-03-04  Dmitry V. Levin  <ldv@strace.io>

	Assume linux/nfc.h is bundled.
	* configure.ac (AC_CHECK_HEADERS): Remove linux/if_nfc.h.
	* tests/sockaddr_xlat.c: Include <linux/nfc.h> unconditionally.
	(struct sockaddr_nfc): Remove fallback definition.

	Complements: v5.15~56 "sockaddr: implement decoding of AF_NFC socket addresses"

2026-03-03  Dmitry V. Levin  <ldv@strace.io>

	Assume linux/if_alg.h is bundled.
	* configure.ac (AC_CHECK_HEADERS): Remove linux/vm_sockets.h
	(AC_CHECK_MEMBERS): Remove struct sockaddr_vm.svm_flags.
	* tests/sockaddr_xlat.c: Include <linux/vm_sockets.h> unconditionally.
	[!HAVE_STRUCT_SOCKADDR_VM, !HAVE_STRUCT_SOCKADDR_VM_SVM_FLAGS]: Remove.

	Complements: v5.15~57 "sockaddr: implement decoding of AF_VSOCK socket addresses"

2026-03-02  Dmitry V. Levin  <ldv@strace.io>

	Assume linux/qrtr.h is bundled.
	* configure.ac (AC_CHECK_HEADERS): Remove linux/qrtr.h.
	* tests/sockaddr_xlat.c: Include <linux/qrtr.h> unconditionally.
	[!HAVE_LINUX_QRTR_H]: Remove.

	Complements: v5.15~58 "sockaddr: implement decoding of AF_QIPCRTR socket addresses"

2026-03-01  Dmitry V. Levin  <ldv@strace.io>

	Assume linux/if_xdp.h is bundled.
	* configure.ac (AC_CHECK_HEADERS): Remove linux/if_xdp.h.
	(AC_CHECK_TYPES): Remove struct sockaddr_xdp.
	* tests/sockaddr_xlat.c: Include <linux/if_xdp.h> unconditionally.
	[!HAVE_STRUCT_SOCKADDR_XDP]: Remove.

	Complements: v5.15~59 "sockaddr: implement decoding of AF_XDP socket addresses"

2026-02-19  Eugene Syromyatnikov  <evgsyr@gmail.com>

	sched: switch to using bundled Linux sched.h.
	* src/sched.c: Change <sched.h> include to <linux/sched.h>.
	(print_sched_param) <param>: Change the type to struct
	strace_sched_param, provide a type definition.

	tests/sched_getscheduler-success: include fallback schedulers definitions from xlat
	* tests/sched_getscheduler-success.c: Include "xlat/schedulers.h" under
	XLAT_MACROS_ONLY.
	(main): Remove ifdefs.

2026-02-19  Eugene Syromyatnikov  <evgsyr@gmail.com>

	tests/sched_xetscheduler: add a guard check for schedulers.
	Add a guard check for the first undefined scheduler value, so the test
	is to be updated and reviewed upon addition of a new value.

	* tests/sched_xetscheduler.c [!SCHED_EXT] (SCHED_EXT): Provide a
	fallback definition.
	(scheduler_str): Remove SCHED_EXT guard around the relevant switch case.
	(main): Change the invalid memory check to use the last defined
	scheduler, add a check for the first undefined one.

2026-02-19  Eugene Syromyatnikov  <evgsyr@gmail.com>

	xlat/schedulers: add fallback values.
	Provide fallback values to the scheduler policy macro constants,
	especially to SCHED_OTHER and SCHED_ISO, as those are defined
	in glibc headers, but not in Linux UAPI ones.

	* src/xlat/schedulers.in: Provide fallback definitions, add comments
	for SCHED_OTHER and SCHED_ISO.

2026-02-17  Dmitry V. Levin  <ldv@strace.io>

	.github/workflows/ci.yml: use one-line syntax for the matrix strategy.

2026-02-15  Eugene Syromyatnikov  <evgsyr@gmail.com>

	sched: print param argument as a structure.
	While de-facto being identical to a pointer to an integer, it is defined
	in POSIX as a structure containing a sing int field, and is handled
	in the kernel as such, so it only makes sense to print it accordingly,
	which also improves readability a bit, albeit at the cost of being less
	laconic.

	* src/sched.c (print_sched_param): New function.
	(sched_setscheduler, sched_getparam, sched_setparam): Use it to print
	param argument.
	* tests/sched_xetparam.c: Update expected output.
	* tests/sched_xetscheduler.c: Likewise.

2026-02-15  Eugene Syromyatnikov  <evgsyr@gmail.com>

	sched: print return value of sched_getscheduler as hexadecimal.
	All currently expected values are within 0..9 range, so it should not
	decrease readability in these cases, and it increases readability
	when SCHED_RESET_ON_FORK flag is set.

	* src/sched.c (sched_getscheduler): Return RVAL_HEX in addition
	to RVAL_STR on exiting.
	* tests/sched_getscheduler-success.c: Update expected output.
	* tests/sched_xetscheduler.c: Likewise.

2026-02-15  Eugene Syromyatnikov  <evgsyr@gmail.com>

	bootstrap: avoid simlinking object and archive files into mpers tests dirs
	Otherwise it symlinks them if the build is in-tree and is dirty.
	It probably should rely on "git ls-files" to determine which files
	should actually be linked, but that might as well be an unnecessary
	complication.

	* bootstrap: Skip *.[oa] files during tests files processing.

2026-02-15  Eugene Syromyatnikov  <evgsyr@gmail.com>

	sched: implement decoding of SCHED_RESET_ON_FORK for sched_[gs]etscheduler
	* src/sched.c (sprint_policy, print_policy): New functions.
	(sched_getscheduler): Use sprint_policy to generate auxstr.
	(sched_setscheduler): Use print_policy to print policy argument.
	* tests/Makefile.am (check_PROGRAMS): Add sched_getscheduler-success,
	sched_xetscheduler--pidns-translation-Xabbrev,
	sched_xetscheduler--pidns-translation-Xraw,
	and sched_xetscheduler--pidns-translation-Xverbose.
	* tests/gen_tests.in (sched_getscheduler-success,
	sched_xetscheduler-Xabbrev, sched_xetscheduler-Xraw,
	sched_xetscheduler-Xverbose,
	sched_xetscheduler--pidns-translation-Xabbrev,
	sched_xetscheduler--pidns-translation-Xraw,
	sched_xetscheduler--pidns-translation-Xverbose): New tests.
	* tests/pure_executables.list: Add sched_xetscheduler-Xabbrev,
	sched_xetscheduler-Xraw, and sched_xetscheduler-Xverbose.
	* tests/sched.in: Likewise.
	* tests/sched_getscheduler-success.c: New file.
	* tests/sched_xetscheduler--pidns-translation-Xabbrev.c: Likewise.
	* tests/sched_xetscheduler--pidns-translation-Xraw.c: Likewise.
	* tests/sched_xetscheduler--pidns-translation-Xverbose.c: Likewise.
	* tests/sched_xetscheduler-Xabbrev.c: Likewise.
	* tests/sched_xetscheduler-Xraw.c: Likewise.
	* tests/sched_xetscheduler-Xverbose.c: Likewise.
	* tests/sched_xetscheduler.c: Update expected output, add new checks.
	* tests/.gitignore: Add sched_getscheduler-success,
	sched_xetscheduler-Xabbrev, sched_xetscheduler-Xraw,
	sched_xetscheduler-Xverbose.
	sched_xetscheduler--pidns-translation-Xabbrev,
	sched_xetscheduler--pidns-translation-Xraw, and
	sched_xetscheduler--pidns-translation-Xverbose.

	Resolves: https://github.com/strace/strace/issues/376

2026-02-15  Eugene Syromyatnikov  <evgsyr@gmail.com>

	tests: add syscall-success.sh.
	Add a simple wrapper for injecting a set of values, similarly
	to prctl-success.sh, but for an arbitrary syscall.

	* tests/syscall-success.sh: New file.
	* tests/Makeile.am (check_SCRIPTS): Add it.

2026-02-12  Dmitry V. Levin  <ldv@strace.io>

	.github/dependabot.yml: set open pull requests limit to 2.

2026-02-11  Dmitry V. Levin  <ldv@strace.io>

	.github/workflows/ci.yml: add clang-19 jobs to the build matrix.

2026-02-11  Dmitry V. Levin  <ldv@strace.io>

	.github/dependabot.yml: set cooldown period.
	Set Dependabot cooldown period to 7 days.

	Link: https://docs.zizmor.sh/audits/#dependabot-cooldown

2026-02-11  Dmitry V. Levin  <ldv@strace.io>

	.github/workflows: pin latest versions by their commit hash.
	Pin latest versions of actions/checkout, actions/upload-artifact,
	codecov/codecov-action, and
	redhat-plumbers-in-action/differential-shellcheck by their commit hash.

	Link: https://docs.zizmor.sh/audits/#unpinned-uses

2026-02-11  Dmitry V. Levin  <ldv@strace.io>

	.github/workflows: disable persisting credentials for actions/checkout.
	Set `persist-credentials: false` for actions/checkout.

	Link: https://docs.zizmor.sh/audits/#artipacked

2026-02-11  Dmitry V. Levin  <ldv@strace.io>

	.github/workflows: add job names.
	Link: https://docs.zizmor.sh/audits/#anonymous-definition

2026-02-11  Dmitry V. Levin  <ldv@strace.io>

	.github/workflows: set concurrency limits.
	When a new CI run is started, any in-progress CI runs for the same PR,
	branch, or tag are canceled:

	Link: https://docs.zizmor.sh/audits/#concurrency-limits

2026-02-11  Dmitry V. Levin  <ldv@strace.io>

	.github/workflows/ci.yml: remove excessive permissions.
	Set `permissions: {}` at the workflow level to prevent unnecessarily
	granting overly broad default permissions to jobs.

	Link: https://docs.zizmor.sh/audits/#excessive-permissions

2026-02-11  Dmitry V. Levin  <ldv@strace.io>

	.github/workflows/ci.yml: use matrix strategy to avoid code duplication.

	Post-release administrivia.
	* NEWS: Add a header line for the next release.
	* debian/changelog.in: Add a changelog entry for 6.19-1.
	* strace.spec.in: Likewise.

2026-02-10  Dmitry V. Levin  <ldv@strace.io>

	Prepare for 6.19 release.
	* NEWS: Update for 6.19 release.

	Update copyright headers.
	Headers updated automatically using maint/update_copyright_years.sh
	script.

	Update copyright year number range.
	* COPYING: Update copyright year number range.
	* tests/COPYING: Likewise.
	* debian/copyright: Likewise.

2026-02-10  Dmitry V. Levin  <ldv@strace.io>

	Fix preprocessor indentation.
	Indent the C preprocessor directives to reflect their nesting
	using the following script:

	$ cppi -l $(git grep -El '^[[:space:]]*#[[:space:]]*(if|ifdef|ifndef|elif|else|endif|define|pragma)[[:space:]]' src tests |grep -Ev '\.(md|sh|test)$') |while read f; do
		cppi < "$f" > "$f".cppi; mv "$f".cppi "$f"
	done

2026-02-09  Dmitry V. Levin  <ldv@strace.io>

	tests: fix printing of btf_log_true_size field of BPF_BTF_LOAD command.
	When printing expected value of btf_log_true_size, do not assume it
	remains unchanged after initialization, print the actual value instead.

	* tests/bpf.c (print_BPF_BTF_LOAD_attr2): New function.
	(BPF_BTF_LOAD_checks[]): Use it.

	Fixes: v6.18~12 "bpf: decode btf_log_true_size field of BPF_BTF_LOAD command"
	Resolves: https://github.com/strace/strace/issues/370

2026-02-09  Dmitry V. Levin  <ldv@strace.io>

	tests: workaround glibc 2.43+ failures on aarch64.
	Starting with glibc 2.43, support for 2MB transparent huge pages
	has been enabled by default in malloc on aarch64.

	Disable it to avoid unexpected madvise() and close() invocations
	that break tests.

	* tests/init-once.sh (GLIBC_TUNABLES): Set glibc.malloc.hugetlb=0.

2026-02-08  Dmitry V. Levin  <ldv@strace.io>

	tests: workaround --secontext=mismatch failures on F44+
	Starting with F44, linkat--secontext_mismatch and
	linkat--secontext_full_mismatch tests fail with the following
	diagnostics:

	  FAIL: linkat--secontext_mismatch.gen
	  linkat.c:200: Context mismatch not detected: [default_t]

	  FAIL: linkat--secontext_full_mismatch.gen
	  linkat.c:200: Context mismatch not detected: [system_u:object_r:default_t:s0]

	Workaround this issue by resetting secontext on the current working
	directory.

	* tests/linkat.c (main): Call reset_secontext_file() on the current
	working directory before calling mangle_secontext_field() on it.

	Resolves: https://github.com/strace/strace/issues/354
	Resolves: https://bugzilla.redhat.com/2435125

2026-02-08  Dmitry V. Levin  <ldv@strace.io>

	tests: fix secontext mismatch diagnostics.
	* tests/linkat.c (main): Use error_msg_and_fail() instead of
	perror_msg_and_fail() to print context mismatch diagnostics.

2026-02-03  Andrea Bolognani  <abologna@redhat.com>

	tests: Skip legacy_syscall_info on riscv64 with kernel 6.6.49+ too.
	Back in late 2024, strace commit ba41bc0da4b841d9 made it so that
	this test is skipped when running on kernel 6.11+, which is the
	first release containing kernel commit 61119394631f219e ("riscv:
	entry: always initialize regs->a0 to -ENOSYS"), the one that
	broke the legacy API on riscv64.

	What I failed to realize at the time is that the change had also
	been backported to the 6.6 tree as kernel commit 84557cd61182edf7,
	part of 6.6.49 stable kernel release. So we need to update our
	check to take that into account too, otherwise machines running
	an up-to-date LTS kernel will be unable to successfully build
	strace.

	This theoretically makes us lose coverage for the 6.7 - 6.10
	kernel range, but in reality 99% of riscv64 machines are running
	either the latest upstream kernel or a vendor kernel based on 6.6,
	so nothing really changes in practice.

2026-01-29  Gleb Fotengauer-Malinovskiy  <glebfm@altlinux.org>

	ptp: add support for PTP_SYS_OFFSET_{PRECISE, EXTENDED}_CYCLES commands.
	* src/ptp.c (ptp_ioctl): Handle PTP_SYS_OFFSET_PRECISE_CYCLES and
	PTP_SYS_OFFSET_EXTENDED_CYCLES.
	* tests/ioctl_ptp.c (test_no_device): Add PTP_SYS_OFFSET_PRECISE_CYCLES
	and PTP_SYS_OFFSET_EXTENDED_CYCLES to expected ioctl tables.

	Update ioctl entries from linux v6.19.
	* src/linux/32/ioctls_inc_align16.h: Update from linux v6.19-rc7 using
	ioctls_gen.sh.
	* src/linux/32/ioctls_inc_align32.h: Likewise.
	* src/linux/32/ioctls_inc_align64.h: Likewise.
	* src/linux/64/ioctls_inc.h: Likewise.
	* src/linux/x32/ioctls_inc0.h: Likewise.
	* NEWS: Mention this change.

	maint: update for linux v6.19-rc7.
	* maint/ioctls_sym.sh (process_file): Add a workaround for the
	linux/gpib_ioctl.h header.

	Update ioctl entries from linux v6.18 and fix affected tests.
	* src/linux/32/ioctls_inc_align16.h: Update from linux v6.18 using
	ioctls_gen.sh.
	* src/linux/32/ioctls_inc_align32.h: Likewise.
	* src/linux/32/ioctls_inc_align64.h: Likewise.
	* src/linux/64/ioctls_inc.h: Likewise.
	* src/linux/x32/ioctls_inc0.h: Likewise.
	* src/linux/powerpc/ioctls_arch0.h: Likewise.
	* tests/ioctl_tee.c (main): Print TEE_IOC_SHM_REGISTER_FD instead of
	raw _IOC value in expected output.
	* tests/ioctl_ptp.c (test_no_device): Update unknown ioctl numbers.

	maint: update for linux v6.18.
	* maint/ioctls_sym.sh (process_file): Bypass asm/cpufeature-macros.h
	on riscv architectures.

2026-01-20  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring_register: decode SOCKET_URING_OP_* for socket descriptors.
	Implement decoding of socket operations introduced by Linux kernel
	commit v6.6-rc1~152^2~38.

	* src/xlat/uring_socket_ops.in: New file.
	* src/io_uring.c: Include "xlat/uring_socket_ops.h".
	(is_op_cmd_sqe, print_io_uring_sqe_off): New functions.
	(print_io_uring_sqe): Use them to decode "off" field as a socket
	operation.
	* tests/io_uring_register.c (test_IORING_REGISTER_SEND_MSG_RING): Check
	it.
	* NEWS: Mention this change.

2026-01-20  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring_register: implement 128-byte SQE support.
	Implement decoding of 128-byte SQEs introduced by Linux kernel commit
	v5.19-rc1~247^2~21.  The decoder detects 128-byte SQEs based on opcode
	(IORING_OP_NOP128, IORING_OP_URING_CMD128) and decodes the additional
	cmd[] array.

	* src/io_uring.c (is_128_byte_sqe): New helper function to detect
	128-byte SQEs based on opcode.
	(print_io_uring_sqe): Use it to decode cmd[] array for 128-byte SQEs.
	* tests/io_uring_register.c (test_IORING_REGISTER_SEND_MSG_RING):
	Check decoding of IORING_OP_NOP128 and IORING_OP_URING_CMD128 opcodes
	with cmd[] array data.
	* NEWS: Mention this change.

2026-01-20  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring_register: decode ioprio as flags for send/recv opcodes.
	Extend print_io_uring_sqe_ioprio to decode ioprio as flags
	introduced by Linux kernel commit v5.19-rc1~251^2~39 for
	send and recv opcodes.

	* src/xlat/uring_recvsend_flags.in: New file.
	* src/io_uring.c: Include "xlat/uring_recvsend_flags.h".
	(print_io_uring_sqe_ioprio): Handle send/recv opcodes.
	* tests/io_uring_register.c (test_IORING_REGISTER_SEND_MSG_RING):
	Add tests for SEND and RECV with flags in ioprio.

2026-01-20  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring_register: decode ioprio as flags for ACCEPT opcode.
	Extend print_io_uring_sqe_ioprio to decode ioprio as flags introduced
	by Linux kernel commit v5.19-rc1~251^2~14 for IORING_OP_ACCEPT opcode.

	* src/xlat/uring_accept_flags.in: New file.
	* src/io_uring.c: Include "xlat/uring_accept_flags.h".
	(print_io_uring_sqe_ioprio): Handle IORING_OP_ACCEPT.
	* tests/io_uring_register.c (test_IORING_REGISTER_SEND_MSG_RING):
	Add test for ACCEPT with flags in ioprio.
	* NEWS: Mention this change.

2026-01-20  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring_register: introduce print_io_uring_sqe_ioprio helper.
	Refactor ioprio field printing in print_io_uring_sqe into a separate
	helper function to prepare for opcode-specific ioprio decoding.

	* src/io_uring.c (print_io_uring_sqe_ioprio): New function.
	(print_io_uring_sqe): Use it to print ioprio field of
	struct io_uring_sqe.

2026-01-20  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring_register: decode install_fd_flags for IORING_OP_FIXED_FD_INSTALL opcode
	Extend print_io_uring_sqe_flags_union to decode install_fd_flags
	introduced by Linux kernel commit v6.8-rc1~120^2~6 for
	IORING_OP_FIXED_FD_INSTALL opcode.  Also add PIPE opcode to the switch
	statement with ATTRIBUTE_FALLTHROUGH to default since no flags are
	currently defined for it.

	* src/xlat/uring_fixed_fd_flags.in: New file.
	* src/io_uring.c: Include "xlat/uring_fixed_fd_flags.h".
	(print_io_uring_sqe_flags_union): Handle IORING_OP_FIXED_FD_INSTALL,
	add IORING_OP_PIPE with ATTRIBUTE_FALLTHROUGH to default.
	* tests/io_uring_register.c (test_IORING_REGISTER_SEND_MSG_RING):
	Add test for FIXED_FD_INSTALL with flags.

2026-01-20  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring_register: decode nop_flags for IORING_OP_NOP* opcodes.
	Extend print_io_uring_sqe_flags_union to decode nop_flags introduced
	by Linux kernel commit v6.10-rc1~220^2 for IORING_OP_NOP and
	IORING_OP_NOP128 opcodes.

	* src/xlat/uring_nop_flags.in: New file.
	* src/io_uring.c: Include "xlat/uring_nop_flags.h".
	(print_io_uring_sqe_flags_union): Handle IORING_OP_NOP and
	IORING_OP_NOP128.
	* tests/io_uring_register.c (test_IORING_REGISTER_SEND_MSG_RING):
	Update existing NOP test to expect nop_flags decoding, add new test
	for NOP with flags.
	* NEWS: Mention this change.

2026-01-20  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring_register: introduce print_io_uring_sqe_flags_union helper.
	Refactor flags union decoding in print_io_uring_sqe into a separate
	helper function to prepare for opcode-specific flag decoding.

	* src/io_uring.c (print_io_uring_sqe_flags_union): New function.
	(print_io_uring_sqe): Use it to decode flags union of
	struct io_uring_sqe.

2026-01-15  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring_register: implement decoding of attr_ptr and attr_type_mask.
	The io_uring_sqe structure contains a union that starting with linux
	kernel commit v6.14-rc1~201^2~32 can also be interpreted as attr_ptr and
	attr_type_mask.  When IORING_RW_ATTR_FLAG_PI is set in attr_type_mask,
	the attr_ptr field points to an io_uring_attr_pi structure that should
	be decoded for RW operations (read/write/send/recv) that actually use
	__io_prep_rw.

	* src/xlat/uring_rw_attr_flags.in: New file.
	* src/io_uring.c: Include "xlat/uring_rw_attr_flags.h".
	(print_io_uring_attr_pi, print_io_uring_attr_ptr): New functions.
	(print_io_uring_sqe): Use them to conditionally decode attr_ptr and
	attr_type_mask.
	* tests/io_uring_register.c (test_IORING_REGISTER_SEND_MSG_RING): Check
	it.
	* NEWS: Mention this change.

2026-01-14  Dmitry V. Levin  <ldv@strace.io>

	tests/prctl-sched-core: remove unused definition.
	* tests/prctl-sched-core.c (struct op_str): Remove.

	tests/syslog: use struct strval32 instead of open-coding it.
	* tests/syslog.c (main): Define no_args[], two_args[], and levels[]
	as arrays of struct strval32.

2026-01-13  Dmitry V. Levin  <ldv@strace.io>

	tests/fcntl-common: use struct strval64 instead of open-coding it.
	* tests/fcntl-common.c (test_rw_hint_pair): Define hints[] as an array
	of struct strval64.

	Fixes: v6.18-25-gad96b2d04 "fcntl: implement decoders for F_*_RW_HINT commands"

2026-01-13  Dmitry V. Levin  <ldv@strace.io>

	tests: workaround fcntl kernel bug.
	Linux kernel used to silently truncate invalid arguments of
	F_SET_RW_HINT command.  This was fixed by Linux kernel commit
	v6.9-rc1~12^2~16.

	* tests/fcntl-common.c (test_rw_hint_pair): If F_SET_* succeeded
	due to argument truncation, skip the corresponding F_GET_* invocation.

2026-01-12  Dmitry V. Levin  <ldv@strace.io>

	tests/time_enjoyment.h: fix compilation warning.
	Workaround the following warning generated by gcc 16:

	  time_enjoyment.h: In function 'enjoy_time':
	  time_enjoyment.h:27:22: error: variable 'dummy' set but not used [-Werror=unused-but-set-variable=]
	     27 |         volatile int dummy = 0;
	        |                      ^~~~~

	* tests/time_enjoyment.h (enjoy_time): Use value of variable 'dummy'.

2026-01-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	Implement decoding of listns syscall.
	This new syscall was introduced by Linux kernel commits
	v6.19-rc1~248^2~6^2~53 and v6.19-rc1~248^2~6^2~52.

	* src/xlat/ns_type.in: New file.
	* src/xlat/listns_user_ns_id.in: Likewise.
	* src/listns.c: New file.
	* src/Makefile.am (libstrace_a_SOURCES): Add listns.c.
	* src/linux/generic/syscallent-common.h [BASE_NR + 470]: Wire up listns.
	* tests/listns.c: New file.
	* tests/listns-success.c: Likewise.
	* tests/pure_executables.list: Add listns and listns-success.
	* tests/.gitignore: Likewise.
	* tests/gen_tests.in (listns, listns-success): New tests.
	* NEWS: Mention this change.

2026-01-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	doc: add a guide for adding new syscall support.
	Add a comprehensive howto document for implementing decoding of new
	Linux syscalls in strace.  The guide documents the complete process
	based on analysis of 28 recent implementation commits, including
	wiring up syscalls, implementing decoding functions, creating xlat
	files, adding path tracing support, writing tests, and handling
	special cases like two-phase decoding, array printing, and reusable
	helper functions.

	* doc/HOWTO_ADD_SYSCALL.md: New file.

2026-01-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring_enter: implement decoding of extended argument structures.
	The io_uring_enter syscall supports extended argument structures when
	IORING_ENTER_EXT_ARG or IORING_ENTER_EXT_ARG_REG flags are set.  When
	IORING_ENTER_EXT_ARG is set, the sigset argument is actually a pointer
	to struct io_uring_getevents_arg containing sigmask, timespec, and
	minimum wait time.  When IORING_ENTER_EXT_ARG_REG is set, the sigset
	argument is a byte offset into a registered wait region in kernel
	memory.

	* src/io_uring.c (print_io_uring_getevents_arg): New function to
	decode struct io_uring_getevents_arg.
	(SYS_FUNC(io_uring_enter)): Conditionally decode arguments 4 and 5
	based on IORING_ENTER_EXT_ARG and IORING_ENTER_EXT_ARG_REG flags.
	When IORING_ENTER_EXT_ARG is set, decode as io_uring_getevents_arg
	structure.  When IORING_ENTER_EXT_ARG_REG is set, print the byte
	offset value.  When neither flag is set or both are set (invalid
	case), use traditional sigset decoding for backward compatibility.
	* tests/io_uring_enter.c: Include "kernel_timespec.h",
	"kernel_time_types.h", and <linux/io_uring.h>.
	(main): Check decoding of IORING_ENTER_EXT_ARG and
	IORING_ENTER_EXT_ARG_REG flags.
	* NEWS: Mention this change.

2026-01-09  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring: decode IORING_REGISTER_ZCRX_CTRL.
	Implement decoder for the IORING_REGISTER_ZCRX_CTRL opcode introduced
	by Linux kernel commit d663976dad68d
	("io_uring/zcrx: introduce IORING_REGISTER_ZCRX_CTRL").

	This opcode allows auxiliary configuration of zero-copy receive (ZCRX)
	functionality, providing control operations for managing ZCRX resources
	such as flushing refill queues and exporting ZCRX resources.

	* src/xlat/uring_zcrx_ctrl_ops.in: New file with ZCRX_CTRL_* constants
	introduced by Linux kernel commits v6.19-rc1~169^2~6^2~5 and
	v6.19-rc1~169^2~6^2~2.
	* src/io_uring.c: Include "xlat/uring_zcrx_ctrl_ops.h".
	(print_zcrx_ctrl_flush_rq): New function to decode struct
	zcrx_ctrl_flush_rq.
	(print_zcrx_ctrl_export): New function to decode struct
	zcrx_ctrl_export.
	(print_io_uring_zcrx_ctrl): New function to decode struct zcrx_ctrl.
	(print_ioring_register_zcrx_ctrl): New wrapper function.
	(SYS_FUNC(io_uring_register)): Add case handler for
	IORING_REGISTER_ZCRX_CTRL opcode introduced by Linux kernel commit
	v6.19-rc1~169^2~6^2~6.
	* tests/io_uring_register.c (test_IORING_REGISTER_ZCRX_CTRL): New
	function to test decoding of the IORING_REGISTER_ZCRX_CTRL opcode.
	(main): Use it.
	* NEWS: Mention this change.

2026-01-08  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	tests: refactor io_uring_register.c to have separate test function for each opcode
	Extract test logic for each IORING_REGISTER_* opcode into dedicated
	functions following the naming convention test_IORING_REGISTER_OPCODE.
	This improves code organization and maintainability.

	* tests/io_uring_register.c (test_IORING_REGISTER_BUFFERS,
	test_IORING_REGISTER_FILES, test_IORING_REGISTER_FILES_UPDATE,
	test_IORING_REGISTER_PROBE, test_IORING_REGISTER_RESTRICTIONS,
	test_IORING_REGISTER_FILES2_BUFFERS2,
	test_IORING_REGISTER_FILES_UPDATE2_BUFFERS_UPDATE,
	test_IORING_REGISTER_IOWQ_AFF, test_IORING_REGISTER_IOWQ_MAX_WORKERS,
	test_IORING_REGISTER_RING_FDS, test_IORING_REGISTER_PBUF_RING,
	test_IORING_REGISTER_SYNC_CANCEL, test_IORING_REGISTER_FILE_ALLOC_RANGE,
	test_IORING_REGISTER_PBUF_STATUS, test_IORING_REGISTER_NAPI,
	test_IORING_REGISTER_CLOCK, test_IORING_REGISTER_CLONE_BUFFERS,
	test_IORING_REGISTER_SEND_MSG_RING, test_IORING_REGISTER_ZCRX_IFQ,
	test_IORING_REGISTER_RESIZE_RINGS, test_IORING_REGISTER_MEM_REGION):
	New functions.
	(main): Use them.

2026-01-07  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring: decode IORING_REGISTER_QUERY.
	Implement decoder for the IORING_REGISTER_QUERY opcode introduced in
	Linux commit c265ae75f900 ("io_uring: introduce io_uring querying").

	This opcode allows querying various aspects of io_uring, such as
	supported opcodes, flags, and ring sizes.  It uses a linked list
	structure where each entry contains a header and query-specific data.

	* src/xlat/uring_query_ops.in: New file with IO_URING_QUERY_*
	operation type constants introduced by Linux kernel commits
	v6.18-rc1~137^2~32, v6.19-rc1~169^2~7^2~1, and v6.19-rc1~169^2~7^2.
	* src/io_uring.c: Include <linux/io_uring/query.h> and
	"xlat/uring_query_ops.h".
	(print_io_uring_query_opcode): New function to decode struct
	io_uring_query_opcode.
	(print_io_uring_query_zcrx): New function to decode struct
	io_uring_query_zcrx.
	(print_io_uring_query_scq): New function to decode struct
	io_uring_query_scq.
	(print_io_uring_query_list): New function to decode linked list
	of query headers.
	(print_ioring_register_query): New wrapper function.
	(SYS_FUNC(io_uring_register)): Add case handler for
	IORING_REGISTER_QUERY opcode introduced by Linux kernel commit
	v6.18-rc1~137^2~32.
	* tests/io_uring_register.c (test_IORING_REGISTER_QUERY): New function
	to test decoding of the IORING_REGISTER_QUERY opcode.
	(main): Use it.
	* NEWS: Mention this change.

2026-01-07  Dmitry V. Levin  <ldv@strace.io>

	bundled: add uapi/linux/io_uring/query.h.
	* bundled/linux/include/uapi/linux/io_uring/query.h: New file,
	imported from headers_install'ed Linux kernel v6.19-rc4.
	* bundled/Makefile.am (EXTRA_DIST): Add
	linux/include/uapi/linux/io_uring/query.h.

2026-01-06  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring: decode IORING_REGISTER_MEM_REGION.
	Implement decoder for the IORING_REGISTER_MEM_REGION opcode introduced
	in Linux commit 93238e661855 ("io_uring: add memory region
	registration").

	This opcode registers a memory region with io_uring.  It takes a pointer
	to a single struct io_uring_mem_region_reg as the argument.

	* src/xlat/uring_mem_region_reg_flags.in: New file with
	IORING_MEM_REGION_REG_* flag constants introduced by Linux kernel
	commit v6.13-rc1~210^2~2.
	* src/io_uring.c: Include "xlat/uring_mem_region_reg_flags.h".
	(print_io_uring_mem_region_reg): New function to decode struct
	io_uring_mem_region_reg.
	(print_ioring_register_mem_region): New wrapper function.
	(SYS_FUNC(io_uring_register)): Add case handler for
	IORING_REGISTER_MEM_REGION.
	* tests/io_uring_register.c (main): Add test cases for
	IORING_REGISTER_MEM_REGION opcode.
	* NEWS: Mention this change.

2026-01-05  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring: decode IORING_REGISTER_RESIZE_RINGS.
	Implement decoder for the IORING_REGISTER_RESIZE_RINGS opcode
	introduced in Linux commit 79cfe9e59c2a ("io_uring/register: add
	IORING_REGISTER_RESIZE_RINGS").

	This opcode allows resizing the CQ and SQ rings after creation.  It
	takes a pointer to a single struct io_uring_params as the argument,
	similar to io_uring_setup, but only the input fields (sq_entries,
	cq_entries, flags, etc.) are relevant.

	* src/io_uring.c (print_io_uring_params_input): New helper function
	to decode input fields of struct io_uring_params.
	(print_ioring_register_resize_rings): New wrapper function.
	(SYS_FUNC(io_uring_register)): Add case handler for
	IORING_REGISTER_RESIZE_RINGS.
	* tests/io_uring_register.c (main): Add test cases for
	IORING_REGISTER_RESIZE_RINGS opcode.
	* NEWS: Mention this change.

2026-01-05  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring: decode IORING_REGISTER_ZCRX_IFQ.
	Implement decoder for the IORING_REGISTER_ZCRX_IFQ opcode introduced
	in Linux commit 6f377873cb23 ("io_uring/zcrx: add interface queue and
	refill queue").

	This opcode registers a zero-copy receive/transmit interface queue.
	It takes a pointer to a single struct io_uring_zcrx_ifq_reg as the
	argument.

	* src/xlat/uring_zcrx_reg_flags.in: New file with ZCRX_REG_* flag
	constants introduced by Linux kernel commit v6.15-rc1~124^2~16.
	* src/xlat/uring_zcrx_area_flags.in: New file with IORING_ZCRX_AREA_*
	flag constants introduced by Linux kernel commit v6.15-rc1~124^2~16.
	* src/io_uring.c (print_io_uring_zcrx_offsets): New helper function.
	(print_io_uring_zcrx_ifq_reg): New function to decode struct
	io_uring_zcrx_ifq_reg.
	(print_ioring_register_zcrx_ifq): New wrapper function.
	(SYS_FUNC(io_uring_register)): Add case handler for
	IORING_REGISTER_ZCRX_IFQ.
	* tests/io_uring_register.c (main): Add test cases for
	IORING_REGISTER_ZCRX_IFQ opcode.
	* NEWS: Mention this change.

2026-01-05  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	io_uring: decode IORING_REGISTER_SEND_MSG_RING.
	Implement decoder for the IORING_REGISTER_SEND_MSG_RING opcode
	introduced in Linux commit a377132154ab ("io_uring/msg_ring: add support
	for sending a sync message").

	This opcode allows sending a MSG_RING message without having a source
	ring. It takes a pointer to a single struct io_uring_sqe as the argument.

	* src/xlat/uring_msg_ring_flags.in: New file with IORING_MSG_RING_*
	flag constants introduced by Linux kernel commit v6.13-rc1~210^2~71.
	* src/io_uring.c: Include "xlat/uring_msg_ring_flags.h".
	(print_io_uring_sqe, print_ioring_register_send_msg_ring): New functions
	to decode and print struct io_uring_sqe for
	IORING_REGISTER_SEND_MSG_RING.
	(SYS_FUNC(io_uring_register)): Add case handler for
	IORING_REGISTER_SEND_MSG_RING.
	* tests/io_uring_register.c (main): Check decoding of
	IORING_REGISTER_SEND_MSG_RING opcode.
	* NEWS: Mention this change.

2026-01-05  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	fcntl: implement decoders for F_GETDELEG and F_SETDELEG commands.
	Implement decoders for F_GETDELEG and F_SETDELEG fcntl commands
	introduced in Linux commit 1602bad16d7df ("vfs: expose delegation
	support to userland").

	* src/xlat/fcntlcmds.in (F_GETDELEG, F_SETDELEG): New constants
	introduced by Linux kernel commit v6.19-rc1~241^2~2^2.
	* src/fcntl.c (print_delegation): New helper function to decode and
	print struct delegation.
	(print_fcntl): Use it to decode F_GETDELEG and F_SETDELEG commands.
	* tests/fcntl-common.c (test_delegation_invalid_pointers,
	test_delegation_fields, test_delegation): New functions to test decoding
	of F_GETDELEG and F_SETDELEG commands.
	(main): Use test_delegation.
	* NEWS: Mention this change.

2026-01-05  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	fcntl: implement decoders for F_*_RW_HINT commands.
	Implement decoders for F_GET_RW_HINT, F_SET_RW_HINT, F_GET_FILE_RW_HINT,
	and F_SET_FILE_RW_HINT fcntl commands introduced in Linux commit
	c75b1d9421f80 ("fs: add fcntl() interface for setting/getting write life
	time hints").

	* src/xlat/fcntlcmds.in (F_GET_RW_HINT, F_SET_RW_HINT,
	F_GET_FILE_RW_HINT, F_SET_FILE_RW_HINT): New constant introduced by
	Linux kernel commit v4.13-rc1~212^2~51.
	* src/xlat/rwh_write_life_hints.in: New xlat file for write life hint
	values (RWH_WRITE_LIFE_*).
	* src/fcntl.c: Include "xlat/rwh_write_life_hints.h".
	(print_rw_hint): New helper function to decode and print write life
	hint values.
	(print_fcntl): Use it to decode F_*_RW_HINT commands.
	* tests/fcntl-common.c (test_rw_hint_invalid_pointers,
	test_rw_hint_pair, test_rw_hints): New functions to tests decoding
	of F_*_RW_HINT commands.
	(main): Use test_rw_hints.
	* NEWS: Mention this change.

2026-01-05  Dmitry V. Levin  <ldv@strace.io>

	xlat: update PERF_ATTR_SIZE_* constants.
	* src/xlat/perf_attr_size.in (PERF_ATTR_SIZE_VER8): New constant
	introduced by Linux kernel commit v6.16-rc1~196^2~1.
	(PERF_ATTR_SIZE_VER9): New constant introduced by Linux kernel commit
	v6.19-rc1~205^2~4.
	* tests/perf_event_open.c (main): Check it.
	* NEWS: Mention this change.

	xlat: update V4L2_* constants.
	* src/xlat/v4l2_meta_fmts.in (V4L2_META_FMT_MALI_C55_PARAMS):
	New constant introduced by Linux kernel commit v6.19-rc1~159^2~19.

	xlat: update ABS_* constants.
	* src/xlat/evdev_abs.in (ABS_SND_PROFILE): New constant introduced
	by Linux kernel commit v6.19-rc2~2^2~2.
	* NEWS: Mention this change.

	bundled: update linux UAPI headers to v6.19-rc4.
	* bundled/linux/include/uapi/linux/input-event-codes.h: Update to
	headers_install'ed Linux kernel v6.19-rc4.
	* bundled/linux/include/uapi/linux/mptcp.h: Likewise.

2026-01-04  Dmitry V. Levin  <ldv@strace.io>

	xlat: update V4L2_* constants.
	* src/xlat/v4l2_control_id_bases.in (V4L2_CID_USER_MALI_C55_BASE):
	New constant introduced by Linux kernel commit v6.19-rc1~159^2~27.
	* src/xlat/v4l2_meta_fmts.in (V4L2_META_FMT_MALI_C55_STATS):
	New constant introduced by Linux kernel commit v6.19-rc1~159^2~23.
	* NEWS: Mention this change.

	xlat: update TLS_* constants.
	* src/xlat/sock_tls_options.in (TLS_TX_ZEROCOPY_RO): New constant
	introduced by Linux kernel commit v5.19-rc2~25^2~3.
	(TLS_RX_EXPECT_NO_PAD): New constant introduced by Linux kernel commit
	v6.0-rc1~141^2~193^2~2.
	(TLS_TX_MAX_PAYLOAD_LEN): New constant introduced by Linux kernel commit
	v6.19-rc1~170^2~312.
	* src/xlat/inet_diag_ulp_info_tls_attrs.in (TLS_INFO_TX_MAX_PAYLOAD_LEN):
	New constant introduced by Linux kernel commit v6.19-rc1~170^2~312.
	* tests/nlattr_inet_diag_msg.c (main): Update expected output.
	* NEWS: Mention this change.

	xlat: update KVM_EXIT_* constants.
	* src/xlat/kvm_exit_reason.in (KVM_EXIT_TDX): New constant introduced
	by Linux kernel commit v6.16-rc3~7^2~1.
	(KVM_EXIT_ARM_SEA): New constant introduced by Linux kernel commit
	v6.19-rc1~103^2~1^2~2^2~2.
	* NEWS: Mention this change.

	xlat: update KVM_CAP_* constants.
	* src/xlat/kvm_cap.in (KVM_CAP_ARM_SEA_TO_USER): New constant
	introduced by Linux kernel commit v6.19-rc1~103^2~1^2~2^2~2.
	(KVM_CAP_S390_USER_OPEREXEC): New constant introduced by Linux kernel
	commits v6.19-rc1~103^2^2~4 and v6.19-rc1~103^2.
	* NEWS: Mention this change.

	xlat: update IORING_SETUP_* constants.
	* src/xlat/uring_setup_flags.in (IORING_SETUP_SQE_MIXED): New constant
	introduced by Linux kernel commit v6.19-rc1~169^2~48.
	* tests/io_uring_setup.c (main): Update expected output.

	xlat: update IORING_REGISTER_* constants.
	* src/xlat/uring_register_opcodes.in (IORING_REGISTER_ZCRX_CTRL): New
	constant introduced by Linux kernel commit v6.19-rc1~169^2~6^2~6.
	* tests/io_uring_register.c (main): Update expected output.
	* NEWS: Mention this change.

	xlat: update *_MAGIC constants.
	* src/xlat/fsmagic.in (GUEST_MEMFD_MAGIC): New constant introduced
	by Linux kernel commit v6.19-rc1~103^2~10^2~11.
	* NEWS: Mention this change.

	xlat: update ETH_P_* constants.
	* src/xlat/ethernet_protocols.in (ETH_P_MXLGSW): New constant introduced
	by Linux kernel commit v6.19-rc1~170^2~42.
	(ETH_P_YT921X): New constant introduced by Linux kernel commit
	v6.19-rc1~170^2~338^2~2.
	* NEWS: Mention this change.

	xlat: update ETHTOOL_MSG_* constants.
	* src/xlat/genl_ethtool_msg_recv.in (ETHTOOL_MSG_MSE_GET_REPLY): New
	constant introduced by Linux kernel commit v6.19-rc1~170^2~251^2~2.
	* src/xlat/genl_ethtool_msg_send.in (ETHTOOL_MSG_MSE_GET): Likewise.
	introduced by Linux kernel commit v6.17-rc1~126^2~84^2~10.
	* tests/netlink_nlctrl.c (test_nla_ops_family): Check it.
	* NEWS: Mention this change.

2026-01-02  Dmitry V. Levin  <ldv@strace.io>

	tests: workaround issues with recent glibc on platforms lacking vDSO.
	When running the testsuite on platforms lacking vDSO support, the glibc
	malloc implementation might issue some clock_gettime64(CLOCK_MONOTONIC)
	calls.  Since those calls cannot be distinguished from expected calls,
	workaround the issue by sanitizing the whole lot.

	* tests/init-once.sh (test_pure_prog_set) [SIZEOF_LONG == 4]: When
	the test execuable doesn't have linux-vdso.so.1 loaded, filter out
	clock_gettime64(CLOCK_MONOTONIC) calls.

	Resolves: https://github.com/strace/strace/issues/355
	Resolves: https://github.com/strace/strace/issues/372

2026-01-01  dependabot[bot]  <49699333+dependabot[bot]@users.noreply.github.com>

	build(deps): bump actions/upload-artifact from 5 to 6.
	Bumps [actions/upload-artifact](https://github.com/actions/upload-artifact) from 5 to 6.
	- [Release notes](https://github.com/actions/upload-artifact/releases)
	- [Commits](https://github.com/actions/upload-artifact/compare/v5...v6)

	---
	updated-dependencies:
	- dependency-name: actions/upload-artifact
	  dependency-version: '6'
	  dependency-type: direct:production
	  update-type: version-update:semver-major
	...

2025-12-24  Dmitry V. Levin  <ldv@strace.io>

	xlat: workaround SCM_DEVMEM_* kernel change on hppa.
	* src/xlat/scmvals.in [__hppa__] (SCM_DEVMEM_LINEAR, SCM_DEVMEM_DMABUF):
	Redefine to new values introduced by Linux kernel commit
	v6.15-rc1~160^2^2~4.

	Resolves: https://github.com/strace/strace/issues/371

2025-12-17  Dmitry V. Levin  <ldv@strace.io>

	mount_setattr: fix return value type.
	The mount_setattr syscall has a regular return value semantics.

	* src/mount_setattr.c (SYS_FUNC(mount_setattr)): Do not add RVAL_FD flag
	to the return value.

	Resolves: https://github.com/strace/strace/issues/368

2025-12-17  Dmitry V. Levin  <ldv@strace.io>

	xlat: update BPF_* constants.
	* src/xlat/bpf_file_flags.in (BPF_F_RB_OVERWRITE): New constant
	introduced by Linux kernel commit v6.19-rc1~171^2~73.
	* src/xlat/bpf_map_types.in (BPF_MAP_TYPE_ARENA): New constant
	introduced by Linux kernel commit v6.19-rc1~171^2~52^2~11.
	* tests/bpf.c: Check it.
	* NEWS: Mention this change.

2025-12-16  Dmitry V. Levin  <ldv@strace.io>

	Update decoding of struct perf_event_attr.
	* bundled/linux/include/uapi/linux/perf_event.h: Update to
	headers_install'ed Linux kernel v6.19-rc1.
	* src/perf_event_struct.h (struct perf_event_attr): Add config4 field
	introduced by Linux kernel commit v6.19-rc1~205^2~4.
	* src/perf.c (print_perf_event_attr): Print it.
	* tests/perf_event_open.c (print_event_attr): Check it.
	* NEWS: Mention this change.

2025-12-15  Dmitry V. Levin  <ldv@strace.io>

	xlat: update IORING_OP_* constants.
	* bundled/linux/include/uapi/linux/io_uring.h: Update to
	headers_install'ed Linux kernel v6.19-rc1.
	* src/xlat/uring_ops.in (IORING_OP_NOP128, IORING_OP_URING_CMD128): New
	constants introduced by Linux kernel commit v6.19-rc1~169^2~48.
	* tests/io_uring_register.c (main): Update expected output.
	* NEWS: Mention this change.

2025-12-14  Dmitry V. Levin  <ldv@strace.io>

	bundled: update linux UAPI headers to v6.19-rc1.
	The update of linux/io_uring.h is delayed because the change
	in enum io_uring_op requires a synchronous update of the header,
	the parser and the test.

	Likewise, the update of linux/perf_event.h is delayed because the change
	in struct perf_event_attr requires a synchronous update of the header,
	the parser and the test.

	* bundled/linux/include/uapi/linux/blktrace_api.h: Update
	to headers_install'ed Linux kernel v6.19-rc1.
	* bundled/linux/include/uapi/linux/blkzoned.h: Likewise.
	* bundled/linux/include/uapi/linux/btrfs.h: Likewise.
	* bundled/linux/include/uapi/linux/devlink.h: Likewise.
	* bundled/linux/include/uapi/linux/ethtool.h: Likewise.
	* bundled/linux/include/uapi/linux/ethtool_netlink_generated.h: Likewise.
	* bundled/linux/include/uapi/linux/fcntl.h: Likewise.
	* bundled/linux/include/uapi/linux/fs.h: Likewise.
	* bundled/linux/include/uapi/linux/if_ether.h: Likewise.
	* bundled/linux/include/uapi/linux/mptcp.h: Likewise.
	* bundled/linux/include/uapi/linux/mptcp_pm.h: Likewise.
	* bundled/linux/include/uapi/linux/netdev.h: Likewise.
	* bundled/linux/include/uapi/linux/netfilter/nf_tables.h: Likewise.
	* bundled/linux/include/uapi/linux/nsfs.h: Likewise.
	* bundled/linux/include/uapi/linux/tee.h: Likewise.
	* bundled/linux/include/uapi/linux/tls.h: Likewise.
	* bundled/linux/include/uapi/linux/v4l2-controls.h: Likewise.
	* bundled/linux/include/uapi/linux/version.h: Likewise.
	* bundled/linux/include/uapi/linux/videodev2.h: Likewise.

2025-12-10  Dmitry V. Levin  <ldv@strace.io>

	Update decoding of struct mnt_id_req.
	* bundled/linux/include/uapi/linux/mount.h: Update to headers_install'ed
	Linux kernel v6.18.
	* src/listmount.c (print_mnt_id_req): Print struct mnt_id_req.mnt_ns_fd
	field introduced by Linux kernel commit v6.18-rc7~32^2~2.
	* src/statmount.c (print_mnt_id_req): Likewise.
	* tests/listmount.c (main): Check it.
	* tests/statmount.c (test_req): Likewise.
	* NEWS: Mention this change.

2025-12-09  Dmitry V. Levin  <ldv@strace.io>

	bundled: update linux/input-event-codes.h to v6.18.
	* bundled/linux/include/uapi/linux/input-event-codes.h: Update
	to headers_install'ed Linux kernel v6.18.
	* src/xlat/evdev_prop.in (INPUT_PROP_HAPTIC_TOUCHPAD): Rename
	to INPUT_PROP_PRESSUREPAD.

2025-12-08  Dmitry V. Levin  <ldv@strace.io>

	Post-release administrivia.
	* NEWS: Add a header line for the next release.
	* debian/changelog.in: Add a changelog entry for 6.18-1.
	* strace.spec.in: Likewise.

2025-12-07  Dmitry V. Levin  <ldv@strace.io>

	Prepare for 6.18 release.
	* NEWS: Update for 6.18 release.

2025-12-04  Dmitry V. Levin  <ldv@strace.io>

	GPG-KEY: add the key that is going to be used for signing releases.

	Update copyright headers.
	Headers updated automatically using maint/update_copyright_years.sh
	script.

2025-12-03  Dmitry V. Levin  <ldv@strace.io>

	tests/errno2name: provide fallback definitions for internal linux constants
	Linux include/linux/errno.h claims that errno constants starting with
	512 should never be seen by user programs, but here you are:

	    commit d90ad28e8aa482e397150e22f3762173d918a724
	    Author: Andrey Albershteyn <aalbersh@redhat.com>
	    Date:   Wed Oct 8 14:44:18 2025 +0200

	        fs: return EOPNOTSUPP from file_setattr/file_getattr syscalls

	        These syscalls call to vfs_fileattr_get/set functions which return
	        ENOIOCTLCMD if filesystem doesn't support setting file attribute on an
	        inode. For syscalls EOPNOTSUPP would be more appropriate return error.

	* tests/errno2name.c: Provide fallback definitions for internal linux
	constants.

2025-12-03  Dmitry V. Levin  <ldv@strace.io>

	tests: update BPF_PROG_LOAD expected output in bpf-obj_get_info_by_fd.
	* tests/bpf-obj_get_info_by_fd.c (print_prog_load): Update expected
	output.

	Fixes: v6.17-111-g76b8b33b9 "bpf: decode core_relo* fields of BPF_PROG_LOAD command"
	Fixes: v6.17-112-g5d819ac1d "bpf: decode log_true_size field of BPF_PROG_LOAD command"
	Fixes: v6.17-113-gba767105a "bpf: decode prog_token_fd field of BPF_PROG_LOAD command"
	Fixes: v6.17-114-g7aa3ee241 "bpf: decode fd_array_cnt field of BPF_PROG_LOAD command"
	Fixes: v6.17-115-ga4d65215f "bpf: decode signature* fields of BPF_PROG_LOAD command"

2025-12-03  Dmitry V. Levin  <ldv@strace.io>

	tests: update BPF_MAP_CREATE expected output in bpf-obj_get_info_by_fd.
	* tests/bpf-obj_get_info_by_fd.c (print_map_create): Update expected
	output.

	Fixes: v6.17-108-g0c0df8e3b "bpf: decode value_type_btf_obj_fd field of BPF_MAP_CREATE command"
	Fixes: v6.17-109-g169fd03b0 "bpf: decode map_token_fd field of BPF_MAP_CREATE command"
	Fixes: v6.17-110-g3e4ddc088 "bpf: decode excl_prog_hash fields of BPF_MAP_CREATE command"

2025-12-02  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	bpf: decode hash and hash_size fields of bpf_map_info.
	* src/bpf_attr.h (bpf_map_info_struct): Add hash and hash_size fields
	introduced by Linux commit v6.18-rc1~175^2~31.
	(bpf_map_info_struct_size, expected_bpf_map_info_struct_size): Update.
	* src/bpf.c (print_bpf_map_info): Decode hash and hash_size fields.
	* tests/bpf-obj_get_info_by_fd.c (main): Update expected output.
	* NEWS: Mention this change.

	bpf: decode btf_vmlinux_id field of bpf_map_info.
	* src/bpf_attr.h (bpf_map_info_struct): Rename pad to btf_vmlinux_id
	introduced by Linux commit v6.9-rc1~159^2~423^2~10^2~8.
	* src/bpf.c (print_bpf_map_info): Decode btf_vmlinux_id field.
	* tests/bpf-obj_get_info_by_fd.c (main): Update expected output.

	bpf: decode attach_btf_obj_id and attach_btf_id fields of bpf_prog_info.
	* src/bpf_attr.h (bpf_prog_info_struct): Add attach_btf_obj_id and
	attach_btf_id fields introduced by Linux commit
	v6.0-rc1~141^2~163^2~30^2~6.
	(bpf_prog_info_struct_size, expected_bpf_prog_info_struct_size): Update.
	* src/bpf.c (print_bpf_prog_info): Decode attach_btf_obj_id and
	attach_btf_id fields.
	* tests/bpf-obj_get_info_by_fd.c (main): Update expected output.
	* NEWS: Mention this change.

	bpf: decode map_extra field of bpf_map_info.
	* src/bpf.c (print_bpf_map_info): Decode map_extra field introduced
	by Linux commit v5.16-rc1~159^2~2^2~20^2~4.
	* tests/bpf-obj_get_info_by_fd.c (main): Update expected output.

2025-12-01  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	bpf: implement decoding of BPF_PROG_STREAM_READ_BY_FD command.
	* src/bpf_attr.h (BPF_PROG_STREAM_READ_BY_FD_struct): New structure
	introduced by Linux kernel commit v6.17-rc1~125^2~36^2~10.
	(BPF_PROG_STREAM_READ_BY_FD_struct_size,
	expected_BPF_PROG_STREAM_READ_BY_FD_struct_size): New macros.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_PROG_STREAM_READ_BY_FD)): New
	function.
	(SYS_FUNC(bpf)) <bpf_cmd_decoders[]>: Use it.
	* tests/bpf.c (union bpf_attr_data): Add
	BPF_ATTR_DATA_FIELD(BPF_PROG_STREAM_READ_BY_FD).
	(init_BPF_PROG_STREAM_READ_BY_FD_attr): New function.
	(BPF_PROG_STREAM_READ_BY_FD_checks): New checks array.
	(main) <checks>: Add CHK(BPF_PROG_STREAM_READ_BY_FD).
	* NEWS: Mention this change.

	bpf: decode btf_flags and btf_token_fd fields of BPF_BTF_LOAD command.
	* src/bpf_attr.h (struct BPF_BTF_LOAD_struct): Add btf_flags and
	btf_token_fd fields introduced by Linux kernel commit
	v6.9-rc1~159^2~423^2~4^2~25.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_BTF_LOAD)): Decode btf_flags
	and btf_token_fd fields.
	* tests/bpf.c (BPF_BTF_LOAD_checks): Check decoding of btf_flags
	and btf_token_fd fields.

	bpf: decode btf_log_true_size field of BPF_BTF_LOAD command.
	* src/bpf_attr.h (struct BPF_BTF_LOAD_struct): Add btf_log_true_size
	field introduced by Linux kernel commit v6.4-rc1~132^2~87^2~19^2~7.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_BTF_LOAD)): Decode
	btf_log_true_size field.
	* tests/bpf.c (BPF_BTF_LOAD_checks): Check decoding of
	btf_log_true_size field.
	* NEWS: Mention this change.

	bpf: decode struct cgroup of BPF_LINK_CREATE command.
	* src/bpf_attr.h (struct BPF_LINK_CREATE_struct): Add struct cgroup
	member introduced by Linux kernel commit v6.17-rc1~125^2~101^2~3.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_LINK_CREATE)): Decode struct
	cgroup for BPF_CGROUP_* attach types.
	tests/bpf.c (BPF_LINK_CREATE_checks): Add tests for decoding of
	struct cgroup.
	(special_attach_types): Update.

	bpf: decode struct netkit of BPF_LINK_CREATE command.
	* src/bpf_attr.h (struct BPF_LINK_CREATE_struct): Add struct netkit
	member introduced by Linux kernel commit v6.7-rc1~160^2~22^2~6^2~6.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_LINK_CREATE)): Decode struct
	netkit for BPF_NETKIT_PRIMARY and BPF_NETKIT_PEER attach types.
	tests/bpf.c (BPF_LINK_CREATE_checks): Add tests for decoding of
	struct netkit.
	(special_attach_types): Update.

2025-12-01  dependabot[bot]  <49699333+dependabot[bot]@users.noreply.github.com>

	build(deps): bump actions/checkout from 5 to 6.
	Bumps [actions/checkout](https://github.com/actions/checkout) from 5 to 6.
	- [Release notes](https://github.com/actions/checkout/releases)
	- [Changelog](https://github.com/actions/checkout/blob/main/CHANGELOG.md)
	- [Commits](https://github.com/actions/checkout/compare/v5...v6)

	---
	updated-dependencies:
	- dependency-name: actions/checkout
	  dependency-version: '6'
	  dependency-type: direct:production
	  update-type: version-update:semver-major
	...

2025-11-26  Dmitry V. Levin  <ldv@strace.io>

	ioctl: fix C23 const correctness issue.
	* src/ioctl.c (ioctl_lookup): Add const qualifier to the structure
	pointed by the variable that holds the result returned by bsearch.

	Reported-by: Frédéric Bérat <fberat@redhat.com>
	Reported-by: Florian Weimer <fweimer@redhat.com>
	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=2416774

2025-11-25  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	bpf: decode uprobe_multi struct of BPF_LINK_CREATE command.
	* src/xlat/bpf_link_create_uprobe_multi_flags.in: New file.
	* src/bpf_attr.h (struct BPF_LINK_CREATE_struct): Add struct
	uprobe_multi member introduced by Linux kernel commits
	v6.6-rc1~10^2~4^2~16^2~25, v6.6-rc1~10^2~4^2~16^2~24, and
	v6.6-rc1~10^2~4^2~16^2~23.
	* src/bpf.c: Include "xlat/bpf_link_create_uprobe_multi_flags.h".
	(BEGIN_BPF_CMD_DECODER(BPF_LINK_CREATE)): Decode struct uprobe_multi
	for BPF_TRACE_UPROBE_MULTI attach type.
	* tests/bpf.c (BPF_LINK_CREATE_checks): Add tests for decoding of
	struct uprobe_multi.
	(special_attach_types): Update.

2025-11-25  Dmitry V. Levin  <ldv@strace.io>

	bpf: print flags field of BPF_LINK_CREATE command as bpf_attach_flags.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_LINK_CREATE)): Print attr.flags
	using as bpf_attach_flags.
	* tests/bpf.c (print_BPF_LINK_CREATE_attr1, print_BPF_LINK_CREATE_attr2,
	BPF_LINK_CREATE_checks): Update expected output.

2025-11-25  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	bpf: decode struct tcx of BPF_LINK_CREATE command.
	* src/bpf_attr.h (struct BPF_LINK_CREATE_struct): Add struct tcx member.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_LINK_CREATE)): Decode struct tcx
	for BPF_TCX_INGRESS and BPF_TCX_EGRESS attach types.
	tests/bpf.c (BPF_LINK_CREATE_checks): Add tests for decoding of
	struct tcx.
	(special_attach_types): Update.

2025-11-24  Dmitry V. Levin  <ldv@strace.io>

	m4/gen_bpf_attr_m4.awk: support nameless unions inside structs.
	* m4/gen_bpf_attr_m4.awk: Do not allow names containing '}'.

	bpf: decode target_ifindex field of BPF_LINK_CREATE command.
	* src/bpf_attr.h (struct BPF_LINK_CREATE_struct): Add target_ifindex
	union member introduced by Linux kernel commit
	v6.6-rc1~162^2~371^2~2^2~6.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_LINK_CREATE)): Print target_fd or
	target_ifindex based on attach_type using bpf_attach_type_is_ifindex
	helper.
	tests/bpf.c (attach_type_is_ifindex): New helper.
	(print_BPF_LINK_CREATE_attr1, print_BPF_LINK_CREATE_attr2): Use it to
	update expected output.

2025-11-23  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	bpf: decode netfilter struct of BPF_LINK_CREATE command.
	* src/bpf_attr.h (struct BPF_LINK_CREATE_struct): Add struct netfilter
	member introduced by Linux kernel commit v6.4-rc1~132^2~25^2~22^2~6.
	* src/xlat/bpf_link_create_netfilter_flags.in: New file.
	* src/bpf.c: Include "xlat/bpf_link_create_netfilter_flags.h".
	(BEGIN_BPF_CMD_DECODER(BPF_LINK_CREATE)): Decode struct netfilter
	for BPF_NETFILTER attach type introduced by Linux kernel commit
	v6.4-rc6~18^2~5^2~2.
	tests/bpf.c (BPF_LINK_CREATE_checks): Add tests for decoding of
	struct netfilter.
	(special_attach_types): Update.

2025-11-20  Dmitry V. Levin  <ldv@strace.io>

	tests/bpf: introduce skip_special_attach_types.
	* tests/bpf.c (skip_special_attach_types): New function.
	(init_BPF_LINK_CREATE_attr2, print_BPF_LINK_CREATE_attr2): Use it.

2025-11-20  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	bpf: decode struct tracing of BPF_LINK_CREATE command.
	* src/bpf_attr.h (struct BPF_LINK_CREATE_struct): Add struct tracing
	member introduced by Linux kernel commit v5.19-rc1~159^2~4^2~37^2~2.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_LINK_CREATE)): Decode struct
	tracing for BPF_TRACE_FENTRY, BPF_TRACE_FEXIT, BPF_MODIFY_RETURN,
	and BPF_LSM_MAC attach types.
	* tests/bpf.c (BPF_LINK_CREATE_checks): Add tests for decoding
	struct tracing.
	(special_attach_types): Update.

2025-11-19  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	bpf: print signature field content in BPF_PROG_LOAD command.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_PROG_LOAD)): Print the actual
	signature data in addition to the address, using printstr_ex with
	QUOTE_FORCE_HEX to show the binary content as a hex-escaped string.
	* tests/bpf.c (signature_data, signature_ptr): New variables.
	(init_BPF_PROG_LOAD_attr_signature, print_BPF_PROG_LOAD_attr_signature):
	New functions.
	(BPF_PROG_LOAD_checks): Add a test case with signature data.

	bpf: decode new fields of BPF_PROG_QUERY command.
	* src/bpf_attr.h (struct BPF_PROG_QUERY_struct): Add target_ifindex
	union member to the union with target_fd.  Add link_ids,
	link_attach_flags, and revision fields.
	(BPF_PROG_QUERY_struct_size, expected_BPF_PROG_QUERY_struct_size):
	Update.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_PROG_QUERY)): Decode
	target_ifindex, link_ids, link_attach_flags, and revision fields
	introduced by Linux kernel commit v6.6-rc1~162^2~371^2~2^2~7.
	* tests/bpf.c (BPF_PROG_QUERY_checks): Add a test case for decoding
	new fields.

	bpf: decode prog_attach_flags field of BPF_PROG_QUERY command.
	* src/bpf_attr.h (struct BPF_PROG_QUERY_struct): Add dummy and
	prog_attach_flags fields, update expected size to 40.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_PROG_QUERY)): Decode
	prog_attach_flags field introduced by Linux kernel commit
	v6.0-rc1~141^2~163^2~30^2~6.
	* tests/bpf.c (BPF_PROG_QUERY_checks): Add a test case for
	decoding prog_attach_flags field.
	* NEWS: Mention this change.

2025-11-18  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	bpf: decode new fields of BPF_BTF_GET_FD_BY_ID command.
	* src/bpf_attr.h (struct BPF_BTF_GET_FD_BY_ID_struct): Add next_id,
	open_flags, and fd_by_id_token_fd fields.
	(expected_BPF_BTF_GET_FD_BY_ID_struct_size): Update to 16.
	* src/bpf.c (decode_BPF_BTF_GET_FD_BY_ID): Decode open_flags and
	fd_by_id_token_fd fields introduced by Linux kernel commit
	v6.15-rc1~98^2~3^2~3.
	* tests/bpf.c (BPF_BTF_GET_FD_BY_ID_checks): Add a test case for
	decoding new fields.
	* NEWS: Mention this change.

2025-11-18  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	bpf: fix decoding of BPF_*_GET_NEXT_ID commands.
	The next_id field in BPF_*_GET_NEXT_ID commands is an output field,
	not an input field.  It should be decoded on syscall exit, not on
	entry.  The previous implementation incorrectly printed the
	uninitialized value of next_id on syscall entry and used the
	"value changed" pattern, which is only appropriate for fields that
	are both input and output.

	Additionally, the kernel always writes the next_id field to userspace
	regardless of the size argument (the kernel copies size bytes from
	userspace, but always writes next_id back via put_user).  Therefore,
	strace should always decode next_id on syscall exit without checking
	the size parameter.

	* src/bpf.c (decode_BPF_PROG_GET_NEXT_ID): Remove printing of next_id
	on syscall entry.  Remove saving and comparing of initial value.
	Decode next_id as a pure output field on syscall exit.

2025-11-18  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	bpf: fix decoding of BPF_MAP_GET_FD_BY_ID command.
	The next_id field is not used by the kernel for BPF_MAP_GET_FD_BY_ID
	command, so remove decoding of this unused field.

	* src/bpf.c (decode_BPF_MAP_GET_FD_BY_ID): Remove decoding of next_id
	field.
	* tests/bpf.c (BPF_MAP_GET_FD_BY_ID_checks): Remove next_id from
	expected output strings.

2025-11-18  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	bpf: fix decoding of BPF_PROG_GET_FD_BY_ID command.
	The next_id and open_flags fields are not used by the kernel for
	BPF_PROG_GET_FD_BY_ID command, so remove decoding of these unused fields.

	* src/bpf_attr.h (struct BPF_PROG_GET_FD_BY_ID_struct): Remove next_id
	and open_flags fields.
	(expected_BPF_PROG_GET_FD_BY_ID_struct_size): Update to 4.
	* src/bpf.c (decode_BPF_PROG_GET_FD_BY_ID): Remove decoding of next_id
	and open_flags fields.
	* tests/bpf.c (BPF_PROG_GET_FD_BY_ID_checks): Simplify to single test
	case with only prog_id field.

2025-11-18  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	bpf: fix decoding of BPF_*_GET_NEXT_ID commands.
	The open_flags field is not used by the kernel for BPF_*_GET_NEXT_ID
	commands, so remove decoding of this unused field.

	* src/bpf_attr.h (struct BPF_PROG_GET_NEXT_ID_struct): Remove
	open_flags field.
	(expected_BPF_PROG_GET_NEXT_ID_struct_size): Update to 8.
	* src/bpf.c (decode_BPF_PROG_GET_NEXT_ID): Remove decoding of
	open_flags field.
	* tests/bpf.c (BPF_PROG_GET_NEXT_ID_checks): Remove open_flags test.

2025-11-18  Dmitry V. Levin  <ldv@strace.io>

	bpf: decode additional fields of BPF_PROG_DETACH command.
	Reimplement decoding of BPF_PROG_DETACH using BPF_PROG_ATTACH decoder.

	* src/bpf_attr.h (struct BPF_PROG_DETACH_struct): Remove.
	(BPF_PROG_DETACH_struct_size, expected_BPF_PROG_DETACH_struct_size):
	Redefine.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_PROG_DETACH)): Remove.
	(decode_BPF_PROG_DETACH): New macro.
	* tests/bpf.c (union bpf_attr_data): Remove
	BPF_ATTR_DATA_FIELD(BPF_PROG_DETACH).
	(BPF_PROG_DETACH_checks): Replace with a macro.
	* NEWS: Mention this change.

2025-11-18  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	bpf: decode new fields of BPF_PROG_ATTACH command.
	* src/bpf_attr.h (struct BPF_PROG_ATTACH_struct): Add target_ifindex,
	relative_fd, relative_id, and expected_revision fields.
	(expected_BPF_PROG_ATTACH_struct_size): Update to 32.
	* src/bpf.c (bpf_attach_type_is_ifindex): New helper function.
	(BEGIN_BPF_CMD_DECODER(BPF_PROG_ATTACH)): Decode target_ifindex,
	relative_fd, relative_id, and expected_revision fields introduced
	by Linux kernel commit v6.6-rc1~162^2~371^2~2^2~7.
	Use bpf_attach_type_is_ifindex to decide whether to print target_fd
	or target_ifindex.
	* tests/bpf.c (BPF_PROG_ATTACH_checks): Add tests for new fields.
	* NEWS: Mention this change.

2025-11-17  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	bpf: decode signature* fields of BPF_PROG_LOAD command.
	* src/bpf_attr.h (struct BPF_PROG_LOAD_struct): Add signature,
	signature_size, and keyring_id fields.
	(expected_BPF_PROG_LOAD_struct_size): Update to 168.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_PROG_LOAD)): Decode
	signature, signature_size, and keyring_id fields introduced by
	Linux kernel commit v6.18-rc1~175^2~24^2~4.
	* tests/bpf.c (BPF_PROG_LOAD_checks): Add a test for signature* fields.
	* tests/kernel_version.c (print_bpf_attr): Add signature* fields to
	expected output.

	bpf: decode fd_array_cnt field of BPF_PROG_LOAD command.
	* src/bpf_attr.h (struct BPF_PROG_LOAD_struct): Add fd_array_cnt field.
	(expected_BPF_PROG_LOAD_struct_size): Update to 152.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_PROG_LOAD)): Decode
	fd_array_cnt field introduced by Linux kernel commit
	v6.14-rc1~133^2~45^2~3.
	* tests/bpf.c (BPF_PROG_LOAD_checks): Add a test for fd_array_cnt field.
	* tests/kernel_version.c (print_bpf_attr): Add fd_array_cnt to expected
	output.

	bpf: decode prog_token_fd field of BPF_PROG_LOAD command.
	* src/bpf_attr.h (struct BPF_PROG_LOAD_struct): Add prog_token_fd field.
	(expected_BPF_PROG_LOAD_struct_size): Update to 148.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_PROG_LOAD)): Decode
	prog_token_fd field introduced by Linux kernel commit
	v6.9-rc1~159^2~423^2~4^2~24.
	* tests/bpf.c (BPF_PROG_LOAD_checks): Add a test for prog_token_fd
	field.
	* tests/kernel_version.c (print_bpf_attr): Add prog_token_fd to expected
	output.

	bpf: decode log_true_size field of BPF_PROG_LOAD command.
	* src/bpf_attr.h (struct BPF_PROG_LOAD_struct): Add log_true_size field.
	(expected_BPF_PROG_LOAD_struct_size): Update to 144.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_PROG_LOAD)): Decode
	log_true_size field introduced by Linux kernel commit
	v6.4-rc1~132^2~87^2~19^2~7.
	* tests/bpf.c (BPF_PROG_LOAD_checks): Add a test for log_true_size
	field.
	* tests/kernel_version.c (print_bpf_attr): Add log_true_size to expected
	output.

	bpf: decode core_relo* fields of BPF_PROG_LOAD command.
	* src/bpf_attr.h (struct BPF_PROG_LOAD_struct): Replace pad field with
	core_relo_cnt, add core_relos and core_relo_rec_size fields.
	(expected_BPF_PROG_LOAD_struct_size): Update to 140.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_PROG_LOAD)): Decode
	core_relo_cnt, core_relos, and core_relo_rec_size fields introduced
	by Linux kernel commit v5.17-rc1~170^2~228^2~20^2~12.
	* tests/bpf.c (BPF_PROG_LOAD_checks): Add a test for core_relo* fields.
	* tests/kernel_version.c (print_bpf_attr): Add core_relo* fields to
	expected output.
	* NEWS: Mention this change.

2025-11-16  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	bpf: decode excl_prog_hash fields of BPF_MAP_CREATE command.
	* src/bpf_attr.h (struct BPF_MAP_CREATE_struct): Add excl_prog_hash
	and excl_prog_hash_size fields.
	(expected_BPF_MAP_CREATE_struct_size): Update to 92.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_MAP_CREATE)): Decode
	excl_prog_hash and excl_prog_hash_size fields introduced by Linux
	kernel commit v6.18-rc1~175^2~35.
	* tests/bpf.c (BPF_MAP_CREATE_checks): Add a test for excl_prog_hash
	and excl_prog_hash_size fields.

	bpf: decode map_token_fd field of BPF_MAP_CREATE command.
	* src/bpf_attr.h (struct BPF_MAP_CREATE_struct): Add map_token_fd
	field.
	(expected_BPF_MAP_CREATE_struct_size): Update to 80.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_MAP_CREATE)): Decode
	map_token_fd field introduced by Linux kernel commit
	v6.9-rc1~159^2~423^2~4^2~26.
	* tests/bpf.c (BPF_MAP_CREATE_checks): Add a test for map_token_fd
	field.

	bpf: decode value_type_btf_obj_fd field of BPF_MAP_CREATE command.
	* src/bpf_attr.h (struct BPF_MAP_CREATE_struct): Add
	value_type_btf_obj_fd field.
	(expected_BPF_MAP_CREATE_struct_size): Update to 76.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_MAP_CREATE)): Decode
	value_type_btf_obj_fd field introduced by Linux kernel commit
	v6.9-rc1~159^2~423^2~10^2~6.
	* tests/bpf.c (BPF_MAP_CREATE_checks): Add a test for
	value_type_btf_obj_fd field.
	* NEWS: Mention this change.

2025-11-13  Masatake YAMATO  <yamato@redhat.com>

	kvm: decode data written to and read from I/O ports.
	With the "-e kvm=vcpu+" option, strace now decodes data written to and read
	from I/O ports.

	* src/kvm.c (kvm_run_structure_decode_io): Decode data written to
	or read from I/O ports as a byte array.
	(kvm_run_structure_decode_main): Add struct vcpu_info as a new
	parameter and pass it down to kvm_run_structure_decode_io().
	(kvm_run_structure_decode): Pass a struct vcpu_info object to
	kvm_run_structure_decode_main.
	* tests/ioctl_kvm_run_common.c (run_kvm): Allocate buffer for run_before
	dynamically and copy entire mmap'ed region to the buffer.
	* tests/ioctl_kvm_run_auxstr_vcpu_more.c (print_kvm_run_more): Print
	data written to or read from I/O ports.

2025-11-13  Masatake YAMATO  <yamato@redhat.com>

	strace.1: document prefixes used in -e kvm=vcpu+ output.

2025-11-13  Dmitry V. Levin  <ldv@strace.io>

	maint/gen_xlat_defs.sh: preserve whitespace in '# *' directives.
	* maint/gen_xlat_defs.sh: Do not assume that '# ' is not followed by
	whitespace.

	xlat: cleanup setsock_options.in.
	* src/xlat/setsock_options.in: Use a single #Generated annotation.

2025-11-13  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: annotate quotatypes.in with "#Pattern"
	* src/xlat/quotatypes.in: Add "#Pattern .*QUOTA" to match
	USRQUOTA, GRPQUOTA, and PRJQUOTA constants.

2025-11-12  Dmitry V. Levin  <ldv@strace.io>

	xlat: remove redundant inet_diag_shutdown_flags.in.
	Apparently, inet_diag_shutdown_flags.in is identically the same as
	sock_shutdown_flags.in, and there is no need to keep both of them.

	* src/defs.h (sock_shutdown_flags): New declaration.
	* src/netlink_inet_diag.c: Do not include
	"xlat/inet_diag_shutdown_flags.h".
	(decode_diag_shutdown): Use sock_shutdown_flags instead of
	inet_diag_shutdown_flags.
	* src/xlat/inet_diag_shutdown_flags.in: Remove.

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: upgrade v4l2_control_id_bases.in from #Prefix to #Pattern.
	* src/xlat/v4l2_control_id_bases.in: Replace "#Prefix V4L2_CID_"
	with "#Pattern V4L2_CID_.*BASE".

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: upgrade fdb_notify_flags.in from #Prefix to #Pattern.
	FDB notify flag constants follow the pattern FDB_NOTIFY_*BIT rather than
	simply FDB_NOTIFY_*.  Using #Pattern provides more precise matching and
	corresponds to the FDB_???_BIT pattern identified in the source code
	analysis.

	* src/xlat/fdb_notify_flags.in: Replace "#Prefix FDB_NOTIFY_" with
	"#Pattern FDB_NOTIFY_.*BIT".

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: upgrade skf_off.in from #Prefix to #Pattern.
	Socket filter offset constants follow the pattern SKF_*_OFF rather than
	simply SKF_*.  Using #Pattern provides more precise matching and
	corresponds to the SKF_???_OFF pattern identified in the source code
	analysis.

	* src/xlat/skf_off.in: Replace "#Prefix SKF_" with
	"#Pattern SKF_.*_OFF".

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: upgrade kd_key_slock_keys.in from #Prefix to #Pattern.
	Keyboard SLOCK key constants follow the pattern K_*_SLOCK rather than
	simply K_*.  Using #Pattern provides more precise matching and
	corresponds to the K_???_SLOCK pattern identified in the source code
	analysis.

	* src/xlat/kd_key_slock_keys.in: Replace "#Prefix K_" with
	"#Pattern K_.*_SLOCK".

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: upgrade fs_ioc_flags.in from #Prefix to #Pattern.
	Filesystem ioctl flag constants follow the pattern FS_*_FL rather than
	simply FS_*.  Using #Pattern provides more precise matching and
	corresponds to the FS_???_FL pattern used in the source code.

	* src/xlat/fs_ioc_flags.in: Replace "#Prefix FS_" with
	"#Pattern FS_.*_FL".

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: upgrade blkpg_ops.in from #Prefix to #Pattern.
	Block partition operation constants follow the pattern BLKPG_*_PARTITION
	rather than simply BLKPG_*.  Using #Pattern provides more precise
	matching and corresponds to the BLKPG_???_PARTITION pattern identified
	in the source code analysis.

	* src/xlat/blkpg_ops.in: Replace "#Prefix BLKPG_" with
	"#Pattern BLKPG_.*_PARTITION".

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: upgrade rxrpc_services.in from #Prefix to #Pattern.
	RxRPC service constants have mixed prefixes: CM_SERVICE (no prefix),
	YFS_FS_SERVICE, YFS_CM_SERVICE, and YFS_VL_SERVICE.  The #Prefix YFS_
	did not match CM_SERVICE.  Using #Pattern .*_SERVICE matches all
	constants based on their common _SERVICE suffix.

	* src/xlat/rxrpc_services.in: Replace "#Prefix YFS_" with
	"#Pattern .*_SERVICE".

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: upgrade tls_info_versions.in from #Prefix to #Pattern.
	TLS version constants follow the pattern TLS_*_VERSION rather than
	simply TLS_1_*.  Using #Pattern provides more precise matching and
	corresponds to the TLS_???_VERSION pattern used in the source code.

	* src/xlat/tls_info_versions.in: Replace "#Prefix TLS_1_" with
	"#Pattern TLS_.*_VERSION".

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: upgrade ubi_volume_types.in from #Prefix to #Pattern.
	UBI volume type constants follow the pattern UBI_*_VOLUME rather than
	simply UBI_*.  Using #Pattern provides more precise matching and
	corresponds to the UBI_???_VOLUME pattern used in the source code.

	* src/xlat/ubi_volume_types.in: Replace "#Prefix UBI_" with
	"#Pattern UBI_.*_VOLUME".

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: upgrade xfs_dqblk_flags.in from #Prefix to #Pattern.
	XFS quota flags follow the pattern FS_*_QUOTA rather than simply FS_*.
	Using #Pattern provides more precise matching and corresponds to the
	FS_???_QUOTA pattern used in the source code.

	* src/xlat/xfs_dqblk_flags.in: Replace "#Prefix FS_" with
	"#Pattern FS_.*_QUOTA".

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: upgrade af_tipc_importance.in from #Prefix to #Pattern.
	TIPC importance constants follow the pattern TIPC_*_IMPORTANCE
	rather than simply TIPC_*.  Using #Pattern provides more precise
	matching and corresponds to the TIPC_???_IMPORTANCE pattern
	used in the source code.

	* src/xlat/af_tipc_importance.in: Replace "#Prefix TIPC_" with
	"#Pattern TIPC_.*_IMPORTANCE".

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: annotate shutdown flag files with #Pattern directive.
	Both inet_diag_shutdown_flags.in and sock_shutdown_flags.in contain
	the same two constants (RCV_SHUTDOWN, SEND_SHUTDOWN) that share a
	common _SHUTDOWN suffix.  Using #Pattern allows matching these
	constants based on their suffix pattern.

	* src/xlat/inet_diag_shutdown_flags.in: Add #Pattern directive.
	* src/xlat/sock_shutdown_flags.in: Likewise.

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: annotate fsmagic.in with #Pattern directive.
	Filesystem magic constants have inconsistent naming patterns:
	some end with _SUPER_MAGIC, others with _FS_MAGIC or just _MAGIC,
	and one (UFS_CIGAM) is MAGIC spelled backwards.  Using #Pattern
	instead of #Prefix allows matching all 115 constants with a single
	flexible regular expression.

	* src/xlat/fsmagic.in: Add #Pattern directive to match constants
	containing _MAGIC or _CIGAM.

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	maint/find-new-xlat-constants.sh: support #Pattern annotations.
	Extend the script to support #Pattern annotations in src/xlat/*.in
	files, which work similarly to #Prefix but use regular expressions
	instead of simple prefix matching.  This provides more flexibility
	for matching constants that don't follow simple PREFIX_* patterns.

	* maint/find-new-xlat-constants.sh (extract_pattern_directive):
	New function to extract #Pattern directive from xlat files.
	(filter_constants_by_pattern): New function to filter constants
	using extended regular expressions with grep -E.
	(extract_header_constants_by_prefix): Rename from
	extract_header_constants for consistency.
	(extract_header_constants_by_pattern): New function to extract
	constants from Linux headers using regex pattern matching.
	(process_line): Check for #Pattern directive first; if found, use
	pattern-based matching, otherwise fall back to prefix-based matching.
	(usage): Document #Prefix and #Pattern directives.

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: support #Pattern annotations.
	Add support for #Pattern directive that allows specifying regular
	expression patterns for matching constants in Linux headers when
	searching for new constants.  Similar to #Prefix directive, but
	with regular expression patterns instead of simple prefixes.

	This directive is intended for other tools (such as maintenance
	scripts) and is ignored by gen.sh, just like #Prefix.

	* src/xlat/gen.sh: Add #Pattern to the list of ignored directives
	in both passes.
	* src/xlat/README.md: Document the #Pattern directive with example.

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	maint: refactor find-new-xlat-constants.sh to separate extraction from filtering
	Refactor the constant extraction logic to use a two-stage approach:
	first extract all constants from the header file, then filter them
	by prefix.  This is clearer and more maintainable than building
	complex grep patterns that include the prefix matching inline.

	* maint/find-new-xlat-constants.sh (build_prefix_pattern): Remove.
	(extract_all_header_constants): New function that extracts all
	constants.
	(filter_constants_by_prefix): New function that filters a list
	of constants by matching against prefix patterns.
	(extract_header_constants): Reimplement as a pipeline that calls
	extract_all_header_constants and filter_constants_by_prefix.

2025-11-12  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: update IFLA_* constants.
	* src/xlat/rtnl_link_attrs.in (IFLA_HEADROOM, IFLA_TAILROOM):
	New constants introduced by Linux kernel commit v6.18-rc1~132^2~101.
	* src/rtnl_link.c (ifinfomsg_nla_decoders): Add decoding for
	IFLA_HEADROOM and IFLA_TAILROOM as u16 values.
	* NEWS: Mention this change.

	xlat: update KEY_* constants.
	* src/xlat/evdev_keycode.in (KEY_EPRIVACY_SCREEN_ON,
	KEY_EPRIVACY_SCREEN_OFF): New constants introduced by Linux kernel
	commit v6.18-rc5~30^2~2.
	* NEWS: Mention this change.

2025-11-12  Dmitry V. Levin  <ldv@strace.io>

	xlat: add more #Prefix annotations.
	Add #Prefix annotations to most of the remaining xlat files.

	* src/xlat/baud_options.in: Add #Prefix annotation.
	* src/xlat/btrfs_compress_types.in: Likewise.
	* src/xlat/btrfs_key_types.in: Likewise.
	* src/xlat/btrfs_tree_objectids.in: Likewise.
	* src/xlat/epollevents.in: Likewise.
	* src/xlat/evdev_keycode.in: Likewise.
	* src/xlat/genl_taskstats_cmd.in: Likewise.
	* src/xlat/getsock_ip_options.in: Likewise.
	* src/xlat/inet_diag_extended_flags.in: Likewise.
	* src/xlat/ip_cmsg_types.in: Likewise.
	* src/xlat/ipc_msg_flags.in: Likewise.
	* src/xlat/ipccalls.in: Likewise.
	* src/xlat/kd_ioctl_cmds.in: Likewise.
	* src/xlat/kd_key_fn_key_vals.in: Likewise.
	* src/xlat/msgctl_flags.in: Likewise.
	* src/xlat/netlink_states.in: Likewise.
	* src/xlat/nl_sock_diag_types.in: Likewise.
	* src/xlat/open_mode_flags.in: Likewise.
	* src/xlat/open_tree_flags.in: Likewise.
	* src/xlat/pollflags.in: Likewise.
	* src/xlat/random_ioctl_cmds.in: Likewise.
	* src/xlat/rxrpc_services.in: Likewise.
	* src/xlat/semctl_flags.in: Likewise.
	* src/xlat/semop_flags.in: Likewise.
	* src/xlat/setsock_ip_options.in: Likewise.
	* src/xlat/shm_resource_flags.in: Likewise.
	* src/xlat/shmctl_flags.in: Likewise.
	* src/xlat/sigact_flags.in: Likewise.
	* src/xlat/sigfpe_codes.in: Likewise.
	* src/xlat/sigill_codes.in: Likewise.
	* src/xlat/sigsegv_codes.in: Likewise.
	* src/xlat/smc_diag_extended_flags.in: Likewise.
	* src/xlat/sock_ax25_options.in: Likewise.
	* src/xlat/sock_ip_options.in: Likewise.
	* src/xlat/sock_ipv6_options.in: Likewise.
	* src/xlat/sock_raw_options.in: Likewise.
	* src/xlat/sock_rds_options.in: Likewise.
	* src/xlat/socketlayers.in: Likewise.
	* src/xlat/sysmips_operations.in: Likewise.
	* src/xlat/tcflsh_options.in: Likewise.
	* src/xlat/tcxonc_options.in: Likewise.
	* src/xlat/term_cflags_csize.in: Likewise.
	* src/xlat/term_cmds_overlapping.in: Likewise.
	* src/xlat/term_oflags_bsdly.in: Likewise.
	* src/xlat/term_oflags_crdly.in: Likewise.
	* src/xlat/term_oflags_ffdly.in: Likewise.
	* src/xlat/term_oflags_nldly.in: Likewise.
	* src/xlat/term_oflags_tabdly.in: Likewise.
	* src/xlat/term_oflags_vtdly.in: Likewise.
	* src/xlat/umount_flags.in: Likewise.
	* src/xlat/wait4_options.in: Likewise.

2025-11-12  Dmitry V. Levin  <ldv@strace.io>

	bundled: update linux UAPI headers to v6.18-rc5.
	* bundled/linux/include/uapi/linux/input-event-codes.h: Update to
	headers_install'ed Linux kernel v6.18-rc5.
	* bundled/linux/include/uapi/linux/io_uring.h: Likewise.

2025-11-11  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: update IORING_SETUP_* constants.
	* src/xlat/uring_setup_flags.in (IORING_SETUP_CQE_MIXED): New constant
	introduced by Linux kernel commit v6.18-rc1~137^2~45.
	* tests/io_uring_setup.c (main): Update expected output.

	xlat: update IORING_REGISTER_* constants.
	* src/xlat/uring_register_opcodes.in (IORING_REGISTER_QUERY): New
	constant introduced by Linux kernel commit v6.18-rc1~137^2~32.
	* tests/io_uring_register.c (main): Update expected output.
	* NEWS: Mention this change.

2025-11-11  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	tee: add support for UBUF and OBJREF parameter types.
	Add support for TEE_IOCTL_PARAM_ATTR_TYPE_UBUF_* and
	TEE_IOCTL_PARAM_ATTR_TYPE_OBJREF_* constants.

	UBUF (user buffer) parameters represent userspace buffers without
	using shared memory, where the 'a' field contains the buffer address
	and 'b' field contains the size.

	OBJREF (object reference) parameters represent objects in TEE or
	userspace, where the 'a' field contains the object identifier and
	'b' field contains flags for the object.

	The 'c' field is not used by the kernel for these parameter types,
	so it is not printed.

	* src/tee.c (tee_print_param_fn): Add cases for
	TEE_IOCTL_PARAM_ATTR_TYPE_UBUF_INPUT, TEE_IOCTL_PARAM_ATTR_TYPE_UBUF_OUTPUT,
	TEE_IOCTL_PARAM_ATTR_TYPE_UBUF_INOUT, TEE_IOCTL_PARAM_ATTR_TYPE_OBJREF_INPUT,
	TEE_IOCTL_PARAM_ATTR_TYPE_OBJREF_OUTPUT, and
	TEE_IOCTL_PARAM_ATTR_TYPE_OBJREF_INOUT. UBUF types were introduced by Linux
	kernel commit v6.18-rc1~145^2~3^2~6. OBJREF types were introduced by Linux
	kernel commit v6.18-rc1~145^2~3^2~5.
	* tests/ioctl_tee.c (NUM_PARAMS): Increase from 8 to 14.
	(fill_params, print_params): Add test cases for the new parameter types.

2025-11-11  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: update TEE_IOCTL_PARAM_ATTR_TYPE_* constants.
	* src/xlat/tee_ioctl_param_attr_types.in
	(TEE_IOCTL_PARAM_ATTR_TYPE_UBUF_INPUT,
	TEE_IOCTL_PARAM_ATTR_TYPE_UBUF_OUTPUT,
	TEE_IOCTL_PARAM_ATTR_TYPE_UBUF_INOUT): New constants introduced by
	Linux kernel commit v6.18-rc1~145^2~3^2~6.
	(TEE_IOCTL_PARAM_ATTR_TYPE_OBJREF_INPUT,
	TEE_IOCTL_PARAM_ATTR_TYPE_OBJREF_OUTPUT,
	TEE_IOCTL_PARAM_ATTR_TYPE_OBJREF_INOUT): New constants introduced by
	Linux kernel commit v6.18-rc1~145^2~3^2~5.

	xlat: update TEE_IMPL_ID_* constants.
	* src/xlat/tee_ioctl_impl_ids.in (TEE_IMPL_ID_QTEE): New constant
	introduced by Linux kernel commit v6.18-rc1~145^2~3^2~3.

	xlat: update TEE_GEN_CAP_* constants.
	* src/xlat/tee_ioctl_gen_caps.in (TEE_GEN_CAP_OBJREF): New constant
	introduced by Linux kernel commit v6.18-rc1~145^2~3^2~5.
	* NEWS: Mention this change.

	xlat: update KVM_CAP_* constants.
	* src/xlat/kvm_cap.in (KVM_CAP_GUEST_MEMFD_FLAGS): New constant
	introduced by Linux kernel commit v6.18-rc2~13^2^2~12.
	* NEWS: Mention this change.

	xlat: update KEXEC_FILE_* constants.
	* src/xlat/kexec_file_load_flags.in (KEXEC_FILE_FORCE_DTB): New constant
	introduced by Linux kernel commit v6.18-rc1~129^2~73.
	* tests/kexec_file_load.c (main): Update expected output.
	* NEWS: Mention this change.

	xlat: update NL80211_CMD_* constants.
	* src/xlat/genl_nl80211_cmd.in (NL80211_CMD_NAN_NEXT_DW_NOTIFICATION,
	NL80211_CMD_NAN_CLUSTER_JOINED): New constants introduced by Linux
	kernel commits v6.18-rc1~132^2~56^2~25 and v6.18-rc1~132^2~56^2~24.
	* tests/netlink_nlctrl.c (main): Update expected output.
	* NEWS: Mention this change.

	xlat: update INPUT_PROP_* constants.
	* src/xlat/evdev_prop.in (INPUT_PROP_HAPTIC_TOUCHPAD): New constant
	introduced by Linux kernel commit v6.18-rc1~81^2~7^2~8.
	* NEWS: Mention this change.

	xlat: update FF_* constants.
	* src/xlat/evdev_ff_types.in (FF_HAPTIC): New constant introduced
	by Linux kernel commit v6.18-rc1~81^2~7^2~9.
	* NEWS: Mention this change.

2025-11-11  Dmitry V. Levin  <ldv@strace.io>

	renameat: enhance arguments decoding.
	* src/seccomp.c (SYS_FUNC(renameat2)): Enhance printing of unknown
	flags argument.

2025-11-11  Dmitry V. Levin  <ldv@strace.io>

	xlat: add more #Prefix annotations.
	Add #Prefix annotations to most of the remaining xlat files.

	* src/xlat/addrfams.in: Add #Prefix annotation.
	* src/xlat/af_packet_types.in: Likewise.
	* src/xlat/af_packet_versions.in: Likewise.
	* src/xlat/af_tipc_flags.in: Likewise.
	* src/xlat/af_tipc_importance.in: Likewise.
	* src/xlat/af_tipc_types.in: Likewise.
	* src/xlat/archvals.in: Likewise.
	* src/xlat/arp_hardware_types.in: Likewise.
	* src/xlat/at_flags.in: Likewise.
	* src/xlat/bdaddr_types.in: Likewise.
	* src/xlat/blkpg_ops.in: Likewise.
	* src/xlat/bootflags1.in: Likewise.
	* src/xlat/bootflags2.in: Likewise.
	* src/xlat/bpf_attach_flags.in: Likewise.
	* src/xlat/bpf_attach_type.in: Likewise.
	* src/xlat/bpf_class.in: Likewise.
	* src/xlat/bpf_commands.in: Likewise.
	* src/xlat/bpf_file_flags.in: Likewise.
	* src/xlat/bpf_file_mode_flags.in: Likewise.
	* src/xlat/bpf_map_flags.in: Likewise.
	* src/xlat/bpf_map_lookup_elem_flags.in: Likewise.
	* src/xlat/bpf_map_types.in: Likewise.
	* src/xlat/bpf_map_update_elem_flags.in: Likewise.
	* src/xlat/bpf_miscop.in: Likewise.
	* src/xlat/bpf_mode.in: Likewise.
	* src/xlat/bpf_op_alu.in: Likewise.
	* src/xlat/bpf_op_jmp.in: Likewise.
	* src/xlat/bpf_prog_flags.in: Likewise.
	* src/xlat/bpf_rval.in: Likewise.
	* src/xlat/bpf_size.in: Likewise.
	* src/xlat/bpf_src.in: Likewise.
	* src/xlat/bpf_test_run_flags.in: Likewise.
	* src/xlat/bt_protocols.in: Likewise.
	* src/xlat/btrfs_balance_args.in: Likewise.
	* src/xlat/btrfs_balance_flags.in: Likewise.
	* src/xlat/btrfs_snap_flags_v2.in: Likewise.
	* src/xlat/btrfs_space_info_flags.in: Likewise.
	* src/xlat/can_protocols.in: Likewise.
	* src/xlat/cap.in: Likewise.
	* src/xlat/cap_mask0.in: Likewise.
	* src/xlat/cap_mask1.in: Likewise.
	* src/xlat/clocknames.in: Likewise.
	* src/xlat/clone3_flags.in: Likewise.
	* src/xlat/clone_flags.in: Likewise.
	* src/xlat/cpuclocknames.in: Likewise.
	* src/xlat/delete_module_flags.in: Likewise.
	* src/xlat/dm_flags.in: Likewise.
	* src/xlat/ebpf_class.in: Likewise.
	* src/xlat/ebpf_mode.in: Likewise.
	* src/xlat/ebpf_op_alu.in: Likewise.
	* src/xlat/ebpf_op_jmp.in: Likewise.
	* src/xlat/ebpf_size.in: Likewise.
	* src/xlat/elf_em.in: Likewise.
	* src/xlat/epollflags.in: Likewise.
	* src/xlat/ethernet_protocols.in: Likewise.
	* src/xlat/evdev_abs.in: Likewise.
	* src/xlat/evdev_autorepeat.in: Likewise.
	* src/xlat/evdev_ev.in: Likewise.
	* src/xlat/evdev_ff_types.in: Likewise.
	* src/xlat/evdev_leds.in: Likewise.
	* src/xlat/evdev_misc.in: Likewise.
	* src/xlat/evdev_prop.in: Likewise.
	* src/xlat/evdev_relative_axes.in: Likewise.
	* src/xlat/evdev_snd.in: Likewise.
	* src/xlat/evdev_switch.in: Likewise.
	* src/xlat/execveat_flags.in: Likewise.
	* src/xlat/faccessat_flags.in: Likewise.
	* src/xlat/falloc_flags.in: Likewise.
	* src/xlat/fan_event_flags.in: Likewise.
	* src/xlat/fan_init_flags.in: Likewise.
	* src/xlat/fan_mark_flags.in: Likewise.
	* src/xlat/fchmodat_flags.in: Likewise.
	* src/xlat/fcntlcmds.in: Likewise.
	* src/xlat/fib_rule_flags.in: Likewise.
	* src/xlat/file_attr_flags.in: Likewise.
	* src/xlat/fs_ioc_flags.in: Likewise.
	* src/xlat/fsmount_attr_flags.in: Likewise.
	* src/xlat/futex2_flags.in: Likewise.
	* src/xlat/futexops.in: Likewise.
	* src/xlat/futexwakeops.in: Likewise.
	* src/xlat/genl_ctrl_attr.in: Likewise.
	* src/xlat/genl_ctrl_attr_op.in: Likewise.
	* src/xlat/genl_ctrl_attr_op_flags.in: Likewise.
	* src/xlat/genl_ctrl_attr_policy.in: Likewise.
	* src/xlat/genl_devlink_cmd.in: Likewise.
	* src/xlat/genl_ethtool_msg_recv.in: Likewise.
	* src/xlat/genl_ethtool_msg_send.in: Likewise.
	* src/xlat/genl_nl80211_cmd.in: Likewise.
	* src/xlat/get_mempolicy_flags.in: Likewise.
	* src/xlat/hw_breakpoint_len.in: Likewise.
	* src/xlat/hw_breakpoint_type.in: Likewise.
	* src/xlat/icmp_filter_flags.in: Likewise.
	* src/xlat/ieee802154_addr_types.in: Likewise.
	* src/xlat/ieee802154_addrs.in: Likewise.
	* src/xlat/if_dqblk_valid.in: Likewise.
	* src/xlat/if_dqinfo_flags.in: Likewise.
	* src/xlat/ifaddrflags.in: Likewise.
	* src/xlat/ifstats_attr_flags.in: Likewise.
	* src/xlat/ifstats_attrs.in: Likewise.
	* src/xlat/ifstats_offload_attrs.in: Likewise.
	* src/xlat/inet_diag_attrs.in: Likewise.
	* src/xlat/inet_diag_bpf_storage_attrs.in: Likewise.
	* src/xlat/inet_diag_bpf_storages_attrs.in: Likewise.
	* src/xlat/inet_protocols.in: Likewise.
	* src/xlat/inotify_flags.in: Likewise.
	* src/xlat/inotify_init_flags.in: Likewise.
	* src/xlat/ioctl_dirs.in: Likewise.
	* src/xlat/ioprio_class.in: Likewise.
	* src/xlat/ip_type_of_services.in: Likewise.
	* src/xlat/ipc_private.in: Likewise.
	* src/xlat/isdn_protocols.in: Likewise.
	* src/xlat/kd_font_ops.in: Likewise.
	* src/xlat/kd_kbd_modes.in: Likewise.
	* src/xlat/kd_key_ascii_keys.in: Likewise.
	* src/xlat/kd_key_cur_keys.in: Likewise.
	* src/xlat/kd_key_dead_keys.in: Likewise.
	* src/xlat/kd_key_fn_keys.in: Likewise.
	* src/xlat/kd_key_lock_keys.in: Likewise.
	* src/xlat/kd_key_pad_keys.in: Likewise.
	* src/xlat/kd_key_shift_keys.in: Likewise.
	* src/xlat/kd_key_slock_keys.in: Likewise.
	* src/xlat/kd_key_spec_keys.in: Likewise.
	* src/xlat/kd_key_tables.in: Likewise.
	* src/xlat/kd_keymap_flags.in: Likewise.
	* src/xlat/kd_meta_vals.in: Likewise.
	* src/xlat/kd_modes.in: Likewise.
	* src/xlat/kexec_arch_values.in: Likewise.
	* src/xlat/kexec_load_flags.in: Likewise.
	* src/xlat/key_perms.in: Likewise.
	* src/xlat/keyctl_commands.in: Likewise.
	* src/xlat/kvm_exit_reason.in: Likewise.
	* src/xlat/lirc_features.in: Likewise.
	* src/xlat/lockfcmds.in: Likewise.
	* src/xlat/lwtunnel_encap_types.in: Likewise.
	* src/xlat/madvise_cmds.in: Likewise.
	* src/xlat/madvise_hppa_generic_cmds.in: Likewise.
	* src/xlat/madvise_hppa_old_cmds.in: Likewise.
	* src/xlat/mbind_flags.in: Likewise.
	* src/xlat/mdb_states.in: Likewise.
	* src/xlat/membarrier_cmds.in: Likewise.
	* src/xlat/memfd_create_flags.in: Likewise.
	* src/xlat/memfd_secret_flags.in: Likewise.
	* src/xlat/modem_flags.in: Likewise.
	* src/xlat/modetypes.in: Likewise.
	* src/xlat/mount_attr_attr.in: Likewise.
	* src/xlat/mount_attr_propagation.in: Likewise.
	* src/xlat/mount_flags.in: Likewise.
	* src/xlat/mount_setattr_flags.in: Likewise.
	* src/xlat/move_pages_flags.in: Likewise.
	* src/xlat/mpol_mode_flags.in: Likewise.
	* src/xlat/mpol_modes.in: Likewise.
	* src/xlat/mq_attr_flags.in: Likewise.
	* src/xlat/msg_flags.in: Likewise.
	* src/xlat/mtd_flags_options.in: Likewise.
	* src/xlat/mtd_type_options.in: Likewise.
	* src/xlat/name_to_handle_at_flags.in: Likewise.
	* src/xlat/nbd_ioctl_cmds.in: Likewise.
	* src/xlat/neighbor_cache_entry_ext_flags.in: Likewise.
	* src/xlat/neighbor_cache_entry_flags.in: Likewise.
	* src/xlat/netlink_ack_flags.in: Likewise.
	* src/xlat/netlink_delete_flags.in: Likewise.
	* src/xlat/netlink_flags.in: Likewise.
	* src/xlat/netlink_get_flags.in: Likewise.
	* src/xlat/netlink_new_flags.in: Likewise.
	* src/xlat/netlink_protocols.in: Likewise.
	* src/xlat/netlink_types.in: Likewise.
	* src/xlat/nfc_sockaddr_protocols.in: Likewise.
	* src/xlat/nl_audit_types.in: Likewise.
	* src/xlat/nl_crypto_types.in: Likewise.
	* src/xlat/nl_netfilter_subsys_ids.in: Likewise.
	* src/xlat/nl_route_types.in: Likewise.
	* src/xlat/nl_selinux_types.in: Likewise.
	* src/xlat/nl_xfrm_types.in: Likewise.
	* src/xlat/nt_descriptor_types.in: Likewise.
	* src/xlat/open_access_modes.in: Likewise.
	* src/xlat/perf_branch_sample_type.in: Likewise.
	* src/xlat/perf_event_sample_format.in: Likewise.
	* src/xlat/perf_hw_cache_id.in: Likewise.
	* src/xlat/perf_hw_id.in: Likewise.
	* src/xlat/personality_types.in: Likewise.
	* src/xlat/pidfd_open_flags.in: Likewise.
	* src/xlat/pkey_access.in: Likewise.
	* src/xlat/pr_mce_kill.in: Likewise.
	* src/xlat/pr_mce_kill_policy.in: Likewise.
	* src/xlat/pr_pac_enabled_keys.in: Likewise.
	* src/xlat/pr_pac_keys.in: Likewise.
	* src/xlat/pr_ppc_dexcr_aspects.in: Likewise.
	* src/xlat/pr_riscv_v_inherit.in: Likewise.
	* src/xlat/pr_riscv_v_states.in: Likewise.
	* src/xlat/pr_sched_core_cmds.in: Likewise.
	* src/xlat/pr_sme_vl_flags.in: Likewise.
	* src/xlat/pr_spec_cmds.in: Likewise.
	* src/xlat/pr_spec_get_store_bypass_flags.in: Likewise.
	* src/xlat/pr_spec_set_store_bypass_flags.in: Likewise.
	* src/xlat/pr_sve_vl_flags.in: Likewise.
	* src/xlat/prctl_options.in: Likewise.
	* src/xlat/priorities.in: Likewise.
	* src/xlat/ptp_extts_flags.in: Likewise.
	* src/xlat/ptp_perout_flags.in: Likewise.
	* src/xlat/resource_flags.in: Likewise.
	* src/xlat/rtc_ioctl_cmds.in: Likewise.
	* src/xlat/rtc_params.in: Likewise.
	* src/xlat/rtc_vl_flags.in: Likewise.
	* src/xlat/rtnl_addr_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_af_spec_bridge_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_af_spec_bridge_vlan_tunnel_info_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_info_data_bridge_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_port_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_vf_info_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_vf_port_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_vf_vlan_list_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_vfinfo_list_attrs.in: Likewise.
	* src/xlat/rtnl_link_attrs.in: Likewise.
	* src/xlat/rtnl_mdb_attrs.in: Likewise.
	* src/xlat/rtnl_mdba_mdb_attrs.in: Likewise.
	* src/xlat/rtnl_mdba_router_attrs.in: Likewise.
	* src/xlat/rtnl_mdba_router_pattr_attrs.in: Likewise.
	* src/xlat/rtnl_netconf_attrs.in: Likewise.
	* src/xlat/rtnl_nexthop_attrs.in: Likewise.
	* src/xlat/rtnl_nha_res_bucket_attrs.in: Likewise.
	* src/xlat/rtnl_nha_res_group_attrs.in: Likewise.
	* src/xlat/rtnl_rta_metrics_attrs.in: Likewise.
	* src/xlat/rtnl_rule_attrs.in: Likewise.
	* src/xlat/rtnl_tc_action_attrs.in: Likewise.
	* src/xlat/rtnl_tc_attrs.in: Likewise.
	* src/xlat/sa_handler_values.in: Likewise.
	* src/xlat/sched_flags.in: Likewise.
	* src/xlat/schedulers.in: Likewise.
	* src/xlat/scsi_sg_commands.in: Likewise.
	* src/xlat/seccomp_ops.in: Likewise.
	* src/xlat/seccomp_ret_action.in: Likewise.
	* src/xlat/setns_types.in: Likewise.
	* src/xlat/sg_io_info.in: Likewise.
	* src/xlat/shm_flags.in: Likewise.
	* src/xlat/sigev_value.in: Likewise.
	* src/xlat/siginfo_codes.in: Likewise.
	* src/xlat/sigprocmaskcmds.in: Likewise.
	* src/xlat/skf_ad.in: Likewise.
	* src/xlat/skf_off.in: Likewise.
	* src/xlat/smc_decl_codes.in: Likewise.
	* src/xlat/smc_diag_attrs.in: Likewise.
	* src/xlat/smc_link_group_roles.in: Likewise.
	* src/xlat/smc_states.in: Likewise.
	* src/xlat/snmp_ip_stats.in: Likewise.
	* src/xlat/sock_bluetooth_options.in: Likewise.
	* src/xlat/sock_can_raw_options.in: Likewise.
	* src/xlat/sock_llc_options.in: Likewise.
	* src/xlat/sock_netlink_options.in: Likewise.
	* src/xlat/sock_nfcllcp_options.in: Likewise.
	* src/xlat/sock_packet_options.in: Likewise.
	* src/xlat/sock_pnp_options.in: Likewise.
	* src/xlat/sock_rxrpc_options.in: Likewise.
	* src/xlat/sock_sctp_options.in: Likewise.
	* src/xlat/sock_tcp_options.in: Likewise.
	* src/xlat/sock_tipc_options.in: Likewise.
	* src/xlat/sock_tls_options.in: Likewise.
	* src/xlat/sock_type_flags.in: Likewise.
	* src/xlat/sock_udp_options.in: Likewise.
	* src/xlat/sock_vsock_options.in: Likewise.
	* src/xlat/sock_xdp_options.in: Likewise.
	* src/xlat/socktypes.in: Likewise.
	* src/xlat/statmount_mnt_propagation.in: Likewise.
	* src/xlat/statmount_sb_flags.in: Likewise.
	* src/xlat/statx_masks.in: Likewise.
	* src/xlat/swap_flags.in: Likewise.
	* src/xlat/syslog_console_levels.in: Likewise.
	* src/xlat/tcp_state_flags.in: Likewise.
	* src/xlat/tcp_states.in: Likewise.
	* src/xlat/tee_ioctl_login_types.in: Likewise.
	* src/xlat/tee_ioctl_param_attr_types.in: Likewise.
	* src/xlat/term_line_discs.in: Likewise.
	* src/xlat/termio_cc.in: Likewise.
	* src/xlat/tls_info_ciphers.in: Likewise.
	* src/xlat/tls_info_versions.in: Likewise.
	* src/xlat/tun_device_types.in: Likewise.
	* src/xlat/ubi_data_types.in: Likewise.
	* src/xlat/ubi_volume_types.in: Likewise.
	* src/xlat/uffd_api_flags.in: Likewise.
	* src/xlat/uffd_register_ioctl_flags.in: Likewise.
	* src/xlat/unshare_flags.in: Likewise.
	* src/xlat/uring_clone_buffers_flags.in: Likewise.
	* src/xlat/uring_files_update_fds.in: Likewise.
	* src/xlat/uring_napi_ops.in: Likewise.
	* src/xlat/uring_sqe_flags.in: Likewise.
	* src/xlat/v4l2_buf_flags.in: Likewise.
	* src/xlat/v4l2_buf_flags_ts_src.in: Likewise.
	* src/xlat/v4l2_buf_flags_ts_type.in: Likewise.
	* src/xlat/v4l2_colorspaces.in: Likewise.
	* src/xlat/v4l2_control_flags.in: Likewise.
	* src/xlat/v4l2_control_id_bases.in: Likewise.
	* src/xlat/v4l2_control_ids.in: Likewise.
	* src/xlat/v4l2_device_capabilities_flags.in: Likewise.
	* src/xlat/v4l2_fields.in: Likewise.
	* src/xlat/v4l2_format_description_flags.in: Likewise.
	* src/xlat/v4l2_input_capabilities_flags.in: Likewise.
	* src/xlat/v4l2_meta_fmts.in: Likewise.
	* src/xlat/v4l2_pix_fmts.in: Likewise.
	* src/xlat/v4l2_sliced_flags.in: Likewise.
	* src/xlat/v4l2_std_ids.in: Likewise.
	* src/xlat/v4l2_streaming_capabilities.in: Likewise.
	* src/xlat/v4l2_tuner_audmodes.in: Likewise.
	* src/xlat/v4l2_tuner_capabilities.in: Likewise.
	* src/xlat/v4l2_tuner_rxsubchanses.in: Likewise.
	* src/xlat/v4l2_tuner_types.in: Likewise.
	* src/xlat/v4l2_vbi_flags.in: Likewise.
	* src/xlat/watchdog_ioctl_flags.in: Likewise.
	* src/xlat/watchdog_ioctl_setoptions.in: Likewise.
	* src/xlat/x86_xfeature_bits.in: Likewise.
	* src/xlat/x86_xfeatures.in: Likewise.
	* src/xlat/xattrat_flags.in: Likewise.
	* src/xlat/xattrflags.in: Likewise.
	* src/xlat/xdp_sockaddr_flags.in: Likewise.
	* src/xlat/xfs_dqblk_flags.in: Likewise.

2025-11-10  Dmitry V. Levin  <ldv@strace.io>

	userfaultfd: enhance uffdio_register.ioctls decoding.
	* src/userfaultfd.c (uffdio_ioctl): Enhance printing of unknown
	uffdio_register.ioctls constants.

	seccomp: enhance arguments decoding.
	* src/seccomp.c (SYS_FUNC(seccomp)): Enhance printing of unknown
	operation.
	* tests/seccomp-strict.c (main): Update expected output.

	rtnl_rule: enhance fib_rule_hdr.tos decoding.
	* src/rtnl_rule.c (DECL_NETLINK_ROUTE_DECODER(decode_fib_rule_hdr)):
	Enhance printing of unknown fib_rule_hdr.tos constants.

	rtnl_route: enhance rtmsg.rtm_tos decoding.
	* src/rtnl_route.c (DECL_NETLINK_ROUTE_DECODER(decode_rtmsg)): Enhance
	printing of unknown rtmsg.rtm_tos constants.

	rtnl_link: enhance IFLA_VF_PORT attribute decoding.
	* src/rtnl_link.c (decode_ifla_port): Enhance printing of unknown
	IFLA_VF_PORT attributes.

	numa: enhance printing of unknown mode and flags arguments.
	* src/numa.c (print_mode, SYS_FUNC(mbind), SYS_FUNC(get_mempolicy),
	SYS_FUNC(move_pages)): Enhance printing of unknown mode and flags
	arguments.

	reboot: enhance arguments decoding.
	* src/reboot.c (SYS_FUNC(reboot)): Enhance printing of unknown
	constants.
	* tests/reboot.c (main): Update expected output.

	net: enhance AF_VSOCK socket options decoding.
	* src/net.c (print_sockopt_fd_level_name): Enhance printing of unknown
	AF_VSOCK socket options.

	kd_ioctl: enhance kbentry.kb_table decoding.
	* src/kd_ioctl.c (kd_kbd_entry): Enhance printing of unknown
	kbentry.kb_table constants.

	evdev: enhance EVIOCGPROP() decoding.
	* src/bpf.c (evdev_read_ioctl): Enhance printing of unknown EVIOCGPROP()
	bits.

	bpf: enhance bpf_attr.test.flags decoding.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_PROG_TEST_RUN)): Enhance printing
	of unknown bpf_attr.test.flags constants.
	* tests/bpf.c (BPF_PROG_TEST_RUN_checks): Update expected output.

	xlat: remove unused file.
	* src/tee.c: Do not include "xlat/tee_ioctl_max_arg_size.h".
	* src/xlat/tee_ioctl_max_arg_size.in: Remove.

2025-11-09  Dmitry V. Levin  <ldv@strace.io>

	userfaultfd: enhance decoding of uffdio_*.mode constants.
	* src/userfaultfd.c (uffdio_ioctl): Enhance printing of unknown
	uffdio_copy.mode, uffdio_zeropage.mode, and uffdio_writeprotect.mode
	constants.

	sockaddr: enhance sockaddr_tipc.addrtype decoding.
	* src/sockaddr.c (print_sockaddr_data_tipc): Enhance printing of unknown
	sockaddr_tipc.addrtype.
	* tests/sockaddr_xlat.c (check_tipc): Update expected output.

	rtnl_stats: enhance BOND_XSTATS_3AD attribute decoding.
	* src/rtnl_stats.c (decode_ifstats_link_xstats_bond_3ad): Enhance
	printing of unknown BOND_XSTATS_3AD attributes.
	* tests/nlattr_ifstats.c (check_xstats): Update expected output.

	quota: enhance Q_QUOTAON and Q_GETFMT arguments decoding.
	* src/quota.c (decode_cmd_data): Enhance printing of unknown quota
	format type idenetifies.
	* tests/quotactl.c (print_dqfmt, main): Update expected output.
	* tests/quotactl_fd.c (main): Likewise.

	net: enhance SOL_ALG socket options decoding.
	* src/net.c (print_sockopt_fd_level_name): Enhance printing of unknown
	SOL_ALG socket options.

	nbd_ioctl: enhance NBD_SET_FLAGS argument decoding.
	* src/nbd_ioctl.c (nbd_ioctl): Enhance printing of unknown NBD_SET_FLAGS
	arguments.

	btrfs: enhance btrfs_ioctl_send_args.flags decoding.
	* src/btrfs.c (btrfs_ioctl_send_args): Enhance printing of unknown
	btrfs_ioctl_send_args.flags constants.
	* tests/btrfs.c (btrfs_test_send_ioctl): Update expected output.

	bpf: enhance link_create.kprobe_multi.flags decoding.
	* src/bpf.c (BEGIN_BPF_CMD_DECODER(BPF_LINK_CREATE)): Enhance printing
	of unknown link_create.kprobe_multi.flags constants.
	* tests/bpf.c (BPF_LINK_CREATE_checks): Update expected output.

2025-11-09  Dmitry V. Levin  <ldv@strace.io>

	xlat: add more #Prefix annotations.
	Add #Prefix annotations to those of xlat files that contain a single
	constant.

	* src/xlat/alg_sockaddr_flags.in: Add #Prefix annotation.
	* src/xlat/bpf_link_create_kprobe_multi_flags.in: Likewise.
	* src/xlat/bpf_query_flags.in: Likewise.
	* src/xlat/bpf_stats_type.in: Likewise.
	* src/xlat/bsg_protocol.in: Likewise.
	* src/xlat/btrfs_dev_stats_flags.in: Likewise.
	* src/xlat/btrfs_logical_ino_args_flags.in: Likewise.
	* src/xlat/btrfs_qgroup_inherit_flags.in: Likewise.
	* src/xlat/clockflags.in: Likewise.
	* src/xlat/fdflags.in: Likewise.
	* src/xlat/fsmount_flags.in: Likewise.
	* src/xlat/fsopen_flags.in: Likewise.
	* src/xlat/futexbitset.in: Likewise.
	* src/xlat/getsock_options.in: Likewise.
	* src/xlat/ieee802154_pan_ids.in: Likewise.
	* src/xlat/kcm_protocols.in: Likewise.
	* src/xlat/kd_font_flags.in: Likewise.
	* src/xlat/keyctl_move_flags.in: Likewise.
	* src/xlat/listmount_flags.in: Likewise.
	* src/xlat/listmount_mnt_id.in: Likewise.
	* src/xlat/lsm_flags.in: Likewise.
	* src/xlat/mctp_nets.in: Likewise.
	* src/xlat/membarrier_flags.in: Likewise.
	* src/xlat/mlock_flags.in: Likewise.
	* src/xlat/mmap_prot.in: Likewise.
	* src/xlat/netfilter_versions.in: Likewise.
	* src/xlat/numa_node.in: Likewise.
	* src/xlat/perf_ioctl_flags.in: Likewise.
	* src/xlat/pr_set_vma.in: Likewise.
	* src/xlat/pr_tagged_addr_enable.in: Likewise.
	* src/xlat/ptrace_peeksiginfo_flags.in: Likewise.
	* src/xlat/qipcrtr_nodes.in: Likewise.
	* src/xlat/qipcrtr_ports.in: Likewise.
	* src/xlat/s390_sthyi_function_codes.in: Likewise.
	* src/xlat/seccomp_ioctl_notif_flags.in: Likewise.
	* src/xlat/seccomp_ioctl_resp_flags.in: Likewise.
	* src/xlat/sigemt_codes.in: Likewise.
	* src/xlat/sigtrap_perf_flags.in: Likewise.
	* src/xlat/sock_ipx_options.in: Likewise.
	* src/xlat/sock_kcm_options.in: Likewise.
	* src/xlat/sparc_kern_features.in: Likewise.
	* src/xlat/tee_ioctl_optee_caps.in: Likewise.
	* src/xlat/tee_ioctl_origins.in: Likewise.
	* src/xlat/ubi_volume_flags.in: Likewise.
	* src/xlat/ubi_volume_props.in: Likewise.
	* src/xlat/uffd_poison_mode_flags.in: Likewise.
	* src/xlat/uffd_zeropage_flags.in: Likewise.
	* src/xlat/uring_register_opcode_flags.in: Likewise.
	* src/xlat/v4l2_capture_modes.in: Likewise.
	* src/xlat/vsock_flags.in: Likewise.
	* src/xlat/vsock_ports.in: Likewise.

2025-11-09  Dmitry V. Levin  <ldv@strace.io>

	xlat: add #Prefix annotations.
	Add #Prefix annotations to those of xlat files that contain constants
	with unambiguous prefixes.

	* src/xlat/adjtimex_modes.in: Add #Prefix annotation.
	* src/xlat/adjtimex_state.in: Likewise.
	* src/xlat/adjtimex_status.in: Likewise.
	* src/xlat/advise.in: Likewise.
	* src/xlat/aio_cmds.in: Likewise.
	* src/xlat/aio_iocb_flags.in: Likewise.
	* src/xlat/alpha_trap_codes.in: Likewise.
	* src/xlat/at_statx_sync_types.in: Likewise.
	* src/xlat/audit_arch.in: Likewise.
	* src/xlat/ax25_protocols.in: Likewise.
	* src/xlat/bluetooth_l2_cid.in: Likewise.
	* src/xlat/bluetooth_l2_psm.in: Likewise.
	* src/xlat/bootflags3.in: Likewise.
	* src/xlat/bpf_prog_types.in: Likewise.
	* src/xlat/bpf_task_fd_type.in: Likewise.
	* src/xlat/bsg_flags.in: Likewise.
	* src/xlat/bsg_subprotocol.in: Likewise.
	* src/xlat/btrfs_balance_ctl_cmds.in: Likewise.
	* src/xlat/btrfs_balance_state.in: Likewise.
	* src/xlat/btrfs_cont_reading_from_srcdev_mode.in: Likewise.
	* src/xlat/btrfs_csum_types.in: Likewise.
	* src/xlat/btrfs_defrag_flags.in: Likewise.
	* src/xlat/btrfs_dev_replace_cmds.in: Likewise.
	* src/xlat/btrfs_dev_replace_results.in: Likewise.
	* src/xlat/btrfs_dev_replace_state.in: Likewise.
	* src/xlat/btrfs_features_compat_ro.in: Likewise.
	* src/xlat/btrfs_features_incompat.in: Likewise.
	* src/xlat/btrfs_fs_info_flags.in: Likewise.
	* src/xlat/btrfs_qgroup_ctl_cmds.in: Likewise.
	* src/xlat/btrfs_qgroup_limit_flags.in: Likewise.
	* src/xlat/btrfs_qgroup_status_flags.in: Likewise.
	* src/xlat/btrfs_scrub_flags.in: Likewise.
	* src/xlat/btrfs_send_flags.in: Likewise.
	* src/xlat/cacheflush_scope.in: Likewise.
	* src/xlat/caif_protocols.in: Likewise.
	* src/xlat/cap_version.in: Likewise.
	* src/xlat/close_range_flags.in: Likewise.
	* src/xlat/compat_ptrace_cmds.in: Likewise.
	* src/xlat/counter_ioctl_component_types.in: Likewise.
	* src/xlat/counter_ioctl_event_types.in: Likewise.
	* src/xlat/counter_ioctl_scopes.in: Likewise.
	* src/xlat/dirent_types.in: Likewise.
	* src/xlat/ebpf_regs.in: Likewise.
	* src/xlat/efd_flags.in: Likewise.
	* src/xlat/epollctls.in: Likewise.
	* src/xlat/evdev_ff_status.in: Likewise.
	* src/xlat/evdev_mtslots.in: Likewise.
	* src/xlat/f_owner_types.in: Likewise.
	* src/xlat/f_seals.in: Likewise.
	* src/xlat/fan_classes.in: Likewise.
	* src/xlat/fdb_notify_flags.in: Likewise.
	* src/xlat/fib_rule_actions.in: Likewise.
	* src/xlat/fiemap_extent_flags.in: Likewise.
	* src/xlat/fiemap_flags.in: Likewise.
	* src/xlat/flockcmds.in: Likewise.
	* src/xlat/fs_xflags.in: Likewise.
	* src/xlat/fsconfig_cmds.in: Likewise.
	* src/xlat/fspick_flags.in: Likewise.
	* src/xlat/futex2_sizes.in: Likewise.
	* src/xlat/futexwakecmps.in: Likewise.
	* src/xlat/genl_ctrl_attr_mcast_grp.in: Likewise.
	* src/xlat/genl_ctrl_cmd.in: Likewise.
	* src/xlat/genl_ioam6_cmd.in: Likewise.
	* src/xlat/genl_mptcp_pm_cmd.in: Likewise.
	* src/xlat/genl_netdev_cmd.in: Likewise.
	* src/xlat/genl_seg6_cmd.in: Likewise.
	* src/xlat/genl_tcp_metrics_cmd.in: Likewise.
	* src/xlat/getrandom_flags.in: Likewise.
	* src/xlat/getsock_ipv6_options.in: Likewise.
	* src/xlat/gpio_event_flags.in: Likewise.
	* src/xlat/gpio_handle_flags.in: Likewise.
	* src/xlat/gpio_line_flags.in: Likewise.
	* src/xlat/hci_channels.in: Likewise.
	* src/xlat/hdio_busstates.in: Likewise.
	* src/xlat/hdio_drive_cmds.in: Likewise.
	* src/xlat/hdio_ide_nice.in: Likewise.
	* src/xlat/if_dqinfo_valid.in: Likewise.
	* src/xlat/iffflags.in: Likewise.
	* src/xlat/ifstats_af_spec_mpls_attrs.in: Likewise.
	* src/xlat/ifstats_xstats_bond_3ad_attrs.in: Likewise.
	* src/xlat/ifstats_xstats_bond_attrs.in: Likewise.
	* src/xlat/ifstats_xstats_bridge_attrs.in: Likewise.
	* src/xlat/ifstats_xstats_bridge_mcast_indices.in: Likewise.
	* src/xlat/ifstats_xstats_type_attrs.in: Likewise.
	* src/xlat/inet6_devconf_indices.in: Likewise.
	* src/xlat/inet6_if_flags.in: Likewise.
	* src/xlat/inet_devconf_indices.in: Likewise.
	* src/xlat/inet_diag_bytecodes.in: Likewise.
	* src/xlat/inet_diag_req_attrs.in: Likewise.
	* src/xlat/inet_diag_ulp_info_attrs.in: Likewise.
	* src/xlat/inet_diag_ulp_info_mptcp_attrs.in: Likewise.
	* src/xlat/inet_diag_ulp_info_tls_attrs.in: Likewise.
	* src/xlat/ioprio_who.in: Likewise.
	* src/xlat/itimer_which.in: Likewise.
	* src/xlat/kcmp_types.in: Likewise.
	* src/xlat/kd_default_led_flags.in: Likewise.
	* src/xlat/kd_kbd_types.in: Likewise.
	* src/xlat/kd_key_brl_keys.in: Likewise.
	* src/xlat/kd_key_types.in: Likewise.
	* src/xlat/kd_led_flags.in: Likewise.
	* src/xlat/kexec_file_load_flags.in: Likewise.
	* src/xlat/key_reqkeys.in: Likewise.
	* src/xlat/key_spec.in: Likewise.
	* src/xlat/keyctl_caps0.in: Likewise.
	* src/xlat/keyctl_caps1.in: Likewise.
	* src/xlat/keyctl_pkey_ops.in: Likewise.
	* src/xlat/kvm_cap.in: Likewise.
	* src/xlat/kvm_cpuid_flags.in: Likewise.
	* src/xlat/kvm_exit_io.in: Likewise.
	* src/xlat/kvm_mem_flags.in: Likewise.
	* src/xlat/landlock_create_ruleset_flags.in: Likewise.
	* src/xlat/landlock_rule_types.in: Likewise.
	* src/xlat/landlock_ruleset_access_fs.in: Likewise.
	* src/xlat/landlock_ruleset_access_net.in: Likewise.
	* src/xlat/landlock_scope_flags.in: Likewise.
	* src/xlat/lbmd_pi_cap_flags.in: Likewise.
	* src/xlat/lbmd_pi_csum_types.in: Likewise.
	* src/xlat/lirc_modes.in: Likewise.
	* src/xlat/loop_crypt_type_options.in: Likewise.
	* src/xlat/loop_flags_options.in: Likewise.
	* src/xlat/lsm_attrs.in: Likewise.
	* src/xlat/lsm_ids.in: Likewise.
	* src/xlat/mctl_sync.in: Likewise.
	* src/xlat/mctp_addrs.in: Likewise.
	* src/xlat/mdb_flags.in: Likewise.
	* src/xlat/mlockall_flags.in: Likewise.
	* src/xlat/module_init_flags.in: Likewise.
	* src/xlat/move_mount_flags.in: Likewise.
	* src/xlat/mptcp_subflow_flags.in: Likewise.
	* src/xlat/mremap_flags.in: Likewise.
	* src/xlat/mtd_file_mode_options.in: Likewise.
	* src/xlat/mtd_mode_options.in: Likewise.
	* src/xlat/mtd_nandecc_options.in: Likewise.
	* src/xlat/mtd_otp_options.in: Likewise.
	* src/xlat/multicast_router_types.in: Likewise.
	* src/xlat/nbd_ioctl_flags.in: Likewise.
	* src/xlat/neighbor_cache_entry_states.in: Likewise.
	* src/xlat/netlink_diag_attrs.in: Likewise.
	* src/xlat/netlink_diag_show.in: Likewise.
	* src/xlat/netlink_sk_meminfo_indices.in: Likewise.
	* src/xlat/netlink_socket_flags.in: Likewise.
	* src/xlat/nf_nft_compat_msg_types.in: Likewise.
	* src/xlat/nfc_protocols.in: Likewise.
	* src/xlat/nfc_saps.in: Likewise.
	* src/xlat/nl_bridge_vlan_flags.in: Likewise.
	* src/xlat/nl_netfilter_msg_types.in: Likewise.
	* src/xlat/notifyflags.in: Likewise.
	* src/xlat/open_resolve_flags.in: Likewise.
	* src/xlat/packet_diag_attrs.in: Likewise.
	* src/xlat/packet_diag_info_flags.in: Likewise.
	* src/xlat/packet_diag_show.in: Likewise.
	* src/xlat/packet_mreq_type.in: Likewise.
	* src/xlat/perf_attr_size.in: Likewise.
	* src/xlat/perf_event_open_flags.in: Likewise.
	* src/xlat/perf_event_read_format.in: Likewise.
	* src/xlat/perf_hw_cache_op_id.in: Likewise.
	* src/xlat/perf_hw_cache_op_result_id.in: Likewise.
	* src/xlat/perf_ioctl_cmds.in: Likewise.
	* src/xlat/perf_sw_ids.in: Likewise.
	* src/xlat/perf_type_id.in: Likewise.
	* src/xlat/phonet_protocols.in: Likewise.
	* src/xlat/pidfd_send_signal_flags.in: Likewise.
	* src/xlat/pr_cap_ambient.in: Likewise.
	* src/xlat/pr_dumpable.in: Likewise.
	* src/xlat/pr_fp_mode.in: Likewise.
	* src/xlat/pr_mdwe_flags.in: Likewise.
	* src/xlat/pr_ppc_dexcr_ctrl_flags.in: Likewise.
	* src/xlat/pr_riscv_icache_flush_ctxes.in: Likewise.
	* src/xlat/pr_riscv_icache_flush_scopes.in: Likewise.
	* src/xlat/pr_sched_core_pidtypes.in: Likewise.
	* src/xlat/pr_set_mm.in: Likewise.
	* src/xlat/pr_sud_cmds.in: Likewise.
	* src/xlat/pr_tagged_addr_mte_tcf.in: Likewise.
	* src/xlat/pr_tsc.in: Likewise.
	* src/xlat/pr_unalign_flags.in: Likewise.
	* src/xlat/ptp_pin_funcs.in: Likewise.
	* src/xlat/ptrace_events.in: Likewise.
	* src/xlat/ptrace_setoptions_flags.in: Likewise.
	* src/xlat/ptrace_syscall_info_op.in: Likewise.
	* src/xlat/quota_formats.in: Likewise.
	* src/xlat/quotacmds.in: Likewise.
	* src/xlat/rename_flags.in: Likewise.
	* src/xlat/resources.in: Likewise.
	* src/xlat/riscv_flush_icache_flags.in: Likewise.
	* src/xlat/route_nexthop_flags.in: Likewise.
	* src/xlat/routing_flags.in: Likewise.
	* src/xlat/routing_protocols.in: Likewise.
	* src/xlat/routing_types.in: Likewise.
	* src/xlat/rtc_backup_switch_modes.in: Likewise.
	* src/xlat/rtc_feature_bits.in: Likewise.
	* src/xlat/rtc_features.in: Likewise.
	* src/xlat/rtnl_addrlabel_attrs.in: Likewise.
	* src/xlat/rtnl_family.in: Likewise.
	* src/xlat/rtnl_ifla_af_spec_inet6_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_af_spec_inet_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_af_spec_mctp_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_br_boolopt_flags.in: Likewise.
	* src/xlat/rtnl_ifla_br_mcast_querier_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_bridge_flags.in: Likewise.
	* src/xlat/rtnl_ifla_bridge_modes.in: Likewise.
	* src/xlat/rtnl_ifla_brport_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_events.in: Likewise.
	* src/xlat/rtnl_ifla_ext_filter_flags.in: Likewise.
	* src/xlat/rtnl_ifla_info_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_info_data_tun_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_proto_down_reason_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_vf_link_states.in: Likewise.
	* src/xlat/rtnl_ifla_vf_stats_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_xdp_attached_mode.in: Likewise.
	* src/xlat/rtnl_ifla_xdp_attrs.in: Likewise.
	* src/xlat/rtnl_ip6mra_creport_attr.in: Likewise.
	* src/xlat/rtnl_ip6mra_msg_types.in: Likewise.
	* src/xlat/rtnl_ipmra_creport_attr.in: Likewise.
	* src/xlat/rtnl_ipmra_msg_types.in: Likewise.
	* src/xlat/rtnl_mdba_mdb_eattr_attrs.in: Likewise.
	* src/xlat/rtnl_mdba_mdb_entry_attrs.in: Likewise.
	* src/xlat/rtnl_neigh_attrs.in: Likewise.
	* src/xlat/rtnl_neigh_fdb_ext_attrs.in: Likewise.
	* src/xlat/rtnl_neightbl_attrs.in: Likewise.
	* src/xlat/rtnl_neightbl_parms_attrs.in: Likewise.
	* src/xlat/rtnl_nexthop_grp_types.in: Likewise.
	* src/xlat/rtnl_nsid_attrs.in: Likewise.
	* src/xlat/rtnl_tca_act_flags.in: Likewise.
	* src/xlat/rtnl_tca_act_hw_stats.in: Likewise.
	* src/xlat/rtnl_tca_root_attrs.in: Likewise.
	* src/xlat/rtnl_tca_root_flags.in: Likewise.
	* src/xlat/rtnl_tca_stab_attrs.in: Likewise.
	* src/xlat/rtnl_tca_stats_attrs.in: Likewise.
	* src/xlat/rwf_flags.in: Likewise.
	* src/xlat/s390_guarded_storage_commands.in: Likewise.
	* src/xlat/s390_runtime_instr_commands.in: Likewise.
	* src/xlat/secbits.in: Likewise.
	* src/xlat/seccomp_filter_flags.in: Likewise.
	* src/xlat/seccomp_ioctl_addfd_flags.in: Likewise.
	* src/xlat/seccomp_mode.in: Likewise.
	* src/xlat/setsock_ipv6_options.in: Likewise.
	* src/xlat/sfd_flags.in: Likewise.
	* src/xlat/sg_io_dxfer_direction.in: Likewise.
	* src/xlat/sg_io_flags.in: Likewise.
	* src/xlat/sg_scsi_reset.in: Likewise.
	* src/xlat/shadow_stack_flags.in: Likewise.
	* src/xlat/shutdown_modes.in: Likewise.
	* src/xlat/sigaltstack_flags.in: Likewise.
	* src/xlat/sigbus_codes.in: Likewise.
	* src/xlat/sigchld_codes.in: Likewise.
	* src/xlat/sigpoll_codes.in: Likewise.
	* src/xlat/sigsys_codes.in: Likewise.
	* src/xlat/sigtrap_codes.in: Likewise.
	* src/xlat/smc_diag_mode.in: Likewise.
	* src/xlat/smc_protocols.in: Likewise.
	* src/xlat/snmp_icmp6_stats.in: Likewise.
	* src/xlat/sock_alg_options.in: Likewise.
	* src/xlat/sock_caif_options.in: Likewise.
	* src/xlat/sock_dccp_options.in: Likewise.
	* src/xlat/sock_iucv_options.in: Likewise.
	* src/xlat/sock_pppol2tp_options.in: Likewise.
	* src/xlat/socketcalls.in: Likewise.
	* src/xlat/sockopt_txrehash_vals.in: Likewise.
	* src/xlat/splice_flags.in: Likewise.
	* src/xlat/statfs_flags.in: Likewise.
	* src/xlat/statmount_mask.in: Likewise.
	* src/xlat/statx_attrs.in: Likewise.
	* src/xlat/sync_file_range_flags.in: Likewise.
	* src/xlat/syslog_action_type.in: Likewise.
	* src/xlat/tcp_ao_keyf_flags.in: Likewise.
	* src/xlat/tee_ioctl_gen_caps.in: Likewise.
	* src/xlat/tee_ioctl_impl_ids.in: Likewise.
	* src/xlat/timerfdflags.in: Likewise.
	* src/xlat/tls_info_configs.in: Likewise.
	* src/xlat/uffd_api_features.in: Likewise.
	* src/xlat/uffd_continue_mode_flags.in: Likewise.
	* src/xlat/uffd_copy_flags.in: Likewise.
	* src/xlat/uffd_register_mode_flags.in: Likewise.
	* src/xlat/uffd_writeprotect_mode_flags.in: Likewise.
	* src/xlat/unix_diag_attrs.in: Likewise.
	* src/xlat/unix_diag_show.in: Likewise.
	* src/xlat/uring_async_cancel_flags.in: Likewise.
	* src/xlat/uring_enter_flags.in: Likewise.
	* src/xlat/uring_iowq_acct.in: Likewise.
	* src/xlat/uring_napi_tracking_strategies.in: Likewise.
	* src/xlat/uring_op_flags.in: Likewise.
	* src/xlat/uring_ops.in: Likewise.
	* src/xlat/uring_register_opcodes.in: Likewise.
	* src/xlat/uring_register_rsrc_flags.in: Likewise.
	* src/xlat/uring_restriction_opcodes.in: Likewise.
	* src/xlat/uring_setup_features.in: Likewise.
	* src/xlat/uring_setup_flags.in: Likewise.
	* src/xlat/usagewho.in: Likewise.
	* src/xlat/v4l2_buf_types.in: Likewise.
	* src/xlat/v4l2_control_classes.in: Likewise.
	* src/xlat/v4l2_control_query_flags.in: Likewise.
	* src/xlat/v4l2_control_types.in: Likewise.
	* src/xlat/v4l2_frameinterval_types.in: Likewise.
	* src/xlat/v4l2_framesize_types.in: Likewise.
	* src/xlat/v4l2_input_status_flags.in: Likewise.
	* src/xlat/v4l2_input_types.in: Likewise.
	* src/xlat/v4l2_memories.in: Likewise.
	* src/xlat/v4l2_sdr_fmts.in: Likewise.
	* src/xlat/vsock_cids.in: Likewise.
	* src/xlat/waitid_types.in: Likewise.
	* src/xlat/watchdog_ioctl_cmds.in: Likewise.
	* src/xlat/whence_codes.in: Likewise.
	* src/xlat/xdp_flags.in: Likewise.
	* src/xlat/xfs_quota_flags.in: Likewise.

2025-11-05  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	maint: add #Prefix directive support to find-new-xlat-constants.sh.
	Add support for using #Prefix directive in xlat files when calculating
	the longest common prefix.  If a #Prefix directive is present in the
	xlat file, use it instead of calculating the prefix from constants.

	This allows xlat file maintainers to explicitly specify the prefix
	when the automatic calculation would be incorrect or when multiple
	prefixes are needed.

	* maint/find-new-xlat-constants.sh (extract_prefix_directive): New
	function.
	(calculate_prefix): Check for #Prefix directive and use it if
	present.

2025-11-05  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	maint: fix prefix calculation in find-new-xlat-constants.sh.
	The awk script in calculate_prefix() was producing incorrect prefixes
	when the stripped constants still had varying suffixes.  For example,
	with kvm_cpuid_flags.in, the constants after stripping the last
	component were:
	- KVM_CPUID_FLAG_SIGNIFCANT_
	- KVM_CPUID_FLAG_STATEFUL_
	- KVM_CPUID_FLAG_STATE_READ_

	The script found the common prefix as KVM_CPUID_FLAG_S (because all
	start with S), but the correct prefix should be KVM_CPUID_FLAG_
	(ending at the underscore).

	* maint/find-new-xlat-constants.sh (calculate_prefix): Ensure the prefix
	always ends with an underscore by stripping the last component.

2025-11-05  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	doc: add a commit message guide.
	Add a comprehensive guide for writing commit messages in
	doc/COMMIT-MESSAGES.md.  The guide documents conventions
	established since v4.13, including commit structure,
	ChangeLog-style entries, common patterns, examples, and
	commit trailers.

	Update README-hacking to reference the new guide and remove
	redundant commit message requirements that are now
	comprehensively documented.

	* doc/COMMIT-MESSAGES.md: New file.
	* README-hacking: Remove redundant commit message requirements
	section.  Reference doc/COMMIT-MESSAGES.md for comprehensive
	guidelines.

2025-11-04  Dmitry V. Levin  <ldv@strace.io>

	xlat/gen.sh: introduce #Prefix directive.
	This directive is intended for other tools and is currently ignored
	by `gen.sh`, similar to #From and #Generated.

	* src/xlat/gen.sh: Introduce #Prefix.
	* src/xlat/README.md: Document it.

2025-11-04  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	maint: add find-new-xlat-constants.sh script.
	* maint/find-new-xlat-constants.sh: New file.

2025-11-03  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	maint/list-xlat-linux-headers.sh: add -c COMMIT_RANGE option.
	Add -c COMMIT_RANGE option to filter table output to only include
	headers that changed between the specified commits.

	* maint/list-xlat-linux-headers.sh: Add -c COMMIT_RANGE option.

2025-11-03  Dmitry V. Levin  <ldv@strace.io>

	maint/list-xlat-linux-headers.sh: apply coding stype conventions.
	* maint/list-xlat-linux-headers.sh: Move function opening braces
	to the next line.
	(error, warning, fatal): New functions.  Use them for consistent
	error handling.
	(usage): Fix exit code and output for -h/--help options.

2025-11-02  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	maint: add list-xlat-linux-headers.sh script.
	Extract linux kernel header paths from xlat files that contain
	the following annotations:
	- #From
	- #Generated by maint/enum2xlat.sh
	- #Generated by maint/gen_xlat_defs.sh

	* maint/list-xlat-linux-headers.sh: New file.

2025-11-02  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	doc: add manual page for maint/gen_xlat_defs.sh.
	* doc/gen_xlat_defs.sh.1: New file.

2025-11-01  dependabot[bot]  <49699333+dependabot[bot]@users.noreply.github.com>

	build(deps): bump actions/upload-artifact from 4 to 5.
	Bumps [actions/upload-artifact](https://github.com/actions/upload-artifact) from 4 to 5.
	- [Release notes](https://github.com/actions/upload-artifact/releases)
	- [Commits](https://github.com/actions/upload-artifact/compare/v4...v5)

	---
	updated-dependencies:
	- dependency-name: actions/upload-artifact
	  dependency-version: '5'
	  dependency-type: direct:production
	  update-type: version-update:semver-major
	...

2025-10-31  Masatake YAMATO  <yamato@redhat.com>

	kvm: decode kvm_run.{immediate_exit,flags} conditionally.
	struct kvm_run.immediate_exit was introduced by linux kernel
	commit v4.11-rc1~109^2~15, and struct kvm_run.flags was introduced
	by linux kernel commit v4.2-rc1~134^2~41.

	* configure (AC_CHECK_MEMBERS): Add kvm_run.immediate_exit and struct
	kvm_run.flags.
	* src/kvm.c (kvm_run_structure_decode_main): Decode
	kvm_run.immediate_exit only if HAVE_STRUCT_KVM_RUN_IMMEDIATE_EXIT is
	defined. Decode struct kvm_run.flags only if HAVE_STRUCT_KVM_RUN_FLAGS
	is defined.
	* tests/ioctl_kvm_run_auxstr_vcpu_more.c (print_kvm_run_more): Print
	these members only when the corresponding macros are defined.

	Resolves: https://github.com/strace/strace/issues/359

2025-10-30  Masatake YAMATO  <yamato@redhat.com>

	tests: enhance the case testing ioctl(KVM_RUN)
	Add some instructions to the guest code to make the interaction
	between the device emulation code and the guest more complex.

	The first two instructions read data from an address where no memory
	is mapped. The device emulation code gains control with KVM_EXIT_MMIO
	and provides data to the memory region of the kvm_run structure of
	vcpu0.

	Then the device emulation code invokes ioctl(KVM_RUN).  Here we expect
	strace to decode the provided data (0xab) at kvm_run::mmio.data[0].

	The next two instructions write data to an I/O port.  The device
	emulation code gains the control again with KVM_EXIT_IO.

	The kvm_run decoding output following ioctl(..., KVM_RUN) may look
	like this:

	  ioctl(5<anon_inode:kvm-vcpu:0>, KVM_RUN, 0) = 0 (KVM_EXIT_IO)
	  VCPU:0< {...,exit_reason=6 /* KVM_EXIT_MMIO */, ..., \
	            {mmio={..., data=[0xab, ...], len=1, is_write=0}}}
	  VCPU:0> {...,exit_reason=2 /* KVM_EXIT_IO */, ..., ...

	Decoding both before-state and after-state makes it possible to print
	the value of kvm_run::mmio.data[0].

	* tests/ioctl_kvm_run_common.c (code): Add instructions that
	read from an I/O memory region and write to the I/O port again.
	(run_kvm) <KVM_EXIT_IO>: Don't reject the new instruction.
	<KVM_EXIT_IOMEM>: Provide data when the guest reads
	from an unmmapped memory region.

2025-10-30  Masatake YAMATO  <yamato@redhat.com>

	kvm: decode kvm_run structure both before and after invoking KVM_RUN.
	The original code didn't account for cases where the process writes
	data to the memory region mapped for the kvm_run structure.

	A test added in a subsequent commit will demonstrate the limitation of
	the original code.

	strace now prints " VCPU:CPUID< " as the prefix for decoding the
	before-state, and " VCPU:CPUID> " for the after-state.

	* src/kvm.c (kvm_run_structure_decode_main): Decode only a single
	kvm_run object; a caller passes before-state or after-state.
	(kvm_run_structure_decode): Call kvm_run_structure_decode_main twice.
	* tests/ioctl_kvm_run_auxstr_vcpu.c (decode_exit_reason): New helper
	function.
	(print_KVM_RUN): Use decode_exit_reason to decode exit_reason in
	before-state and after-state. Pass the decoded exit_reason of
	before-state to print_KVM_RUN_MORE.
	* tests/ioctl_kvm_run_auxstr_vcpu_more.c (print_kvm_run_more): Move
	the logic from print_KVM_RUN_MORE here. This function handles a single
	kvm_run object.
	(print_KVM_RUN_MORE): Call print_kvm_run_more twice. Unify multiple
	printf invocations into one.

2025-10-30  Masatake YAMATO  <yamato@redhat.com>

	kvm: (refactor) add a flag representing the process runs VM to tcb.
	* src/defs.h (TCP_AFTER_KVM_RUN): New macro definition.
	* src/kvm.c (kvm_ioctl) <KVM_RUN>: Set the flag.
	* src/syscall.c (syscall_exiting_trace): Call
	kvm_run_structure_decode only when the flag is set. Clear
	the flag at the end.

2025-10-29  Dmitry V. Levin  <ldv@strace.io>
	    auto@cursor.ai

	xlat: annotate xlat files with source Linux kernel headers.
	Add #From directives to xlat files to indicate the Linux kernel header
	files that define the constants used in each file.  This improves
	traceability and helps maintainers understand the source of constants.

	Files with multiple source headers are annotated with multiple #From
	directives.  Autogenerated files (marked with #Generated directive)
	are excluded from annotation.

2025-10-29  Masatake YAMATO  <yamato@redhat.com>

	doc: add a symlink to xlat/README.md.
	Placing the document in the `doc` directory may increase the chance
	that potential contributors will see it.

	* doc/README-xlat.md: New symlink.

2025-10-28  Dmitry V. Levin  <ldv@strace.io>

	xlat: convert comments about source of xlat constants into directives.
	* src/xlat/alg_sockaddr_flags.in: Convert the comment about the source
	of the xlat constants into #From directive.
	* src/xlat/ax25_protocols.in: Likewise.
	* src/xlat/elf_em.in: Likewise.
	* src/xlat/kd_ioctl_cmds.in: Likewise.
	* src/xlat/key_perms.in: Likewise.
	* src/xlat/pr_dumpable.in: Likewise.
	* src/xlat/syslog_console_levels.in: Likewise.
	* src/xlat/x86_xfeature_bits.in: Likewise.
	* src/xlat/x86_xfeatures.in: Likewise.

2025-10-28  Dmitry V. Levin  <ldv@strace.io>

	xlat/gen.sh: introduce #From directive.
	This directive is intended for other tools and is currently ignored
	by `gen.sh`.

	* src/xlat/gen.sh: Introduce #From.
	* src/xlat/README.md: Document it.

2025-10-28  Dmitry V. Levin  <ldv@strace.io>

	xlat: convert "Generated by maint/gen_xlat_defs.sh" comments into directives
	* maint/gen_xlat_defs.sh: Generate a xlat directive instead of a comment.
	* src/xlat/mmap_flags.in: Regenerate.
	* src/xlat/ptrace_cmds.in: Likewise.
	* src/xlat/scmvals.in: Likewise.
	* src/xlat/setsock_options.in: Likewise.
	* src/xlat/sock_options.in: Likewise.

	xlat: convert "Generated by maint/enum2xlat.sh" comments into directives
	* maint/enum2xlat.sh: Generate a xlat directive instead of a comment.
	* src/xlat/af_tipc_scope.in: Regenerate using maint/update-xlat.sh.
	* src/xlat/btrfs_dev_stats_values.in: Likewise.
	* src/xlat/crypto_nl_attrs.in: Likewise.
	* src/xlat/dcb_commands.in: Likewise.
	* src/xlat/genl_thermal_cmd.in: Likewise.
	* src/xlat/gpio_v2_line_attr_ids.in: Likewise.
	* src/xlat/gpio_v2_line_flags.in: Likewise.
	* src/xlat/in6_addr_gen_mode.in: Likewise.
	* src/xlat/nf_acct_msg_types.in: Likewise.
	* src/xlat/nf_cthelper_msg_types.in: Likewise.
	* src/xlat/nf_ctnetlink_exp_msg_types.in: Likewise.
	* src/xlat/nf_ctnetlink_msg_types.in: Likewise.
	* src/xlat/nf_cttimeout_msg_types.in: Likewise.
	* src/xlat/nf_hook_msg_types.in: Likewise.
	* src/xlat/nf_ipset_msg_types.in: Likewise.
	* src/xlat/nf_osf_msg_types.in: Likewise.
	* src/xlat/nf_queue_msg_types.in: Likewise.
	* src/xlat/nf_tables_msg_types.in: Likewise.
	* src/xlat/nf_ulog_msg_types.in: Likewise.
	* src/xlat/nl_attr_type.in: Likewise.
	* src/xlat/nl_policy_type_attr.in: Likewise.
	* src/xlat/nlmsgerr_attrs.in: Likewise.
	* src/xlat/routing_scopes.in: Likewise.
	* src/xlat/routing_table_ids.in: Likewise.
	* src/xlat/rtnl_dcb_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_br_boolopts.in: Likewise.
	* src/xlat/rtnl_route_attrs.in: Likewise.
	* maint/update-xlat.sh: Update regular expression.

2025-10-28  Dmitry V. Levin  <ldv@strace.io>

	xlat/gen.sh: introduce #Generated directive.
	This directive is intended for other tools and is currently ignored
	by `gen.sh`.

	* src/xlat/gen.sh: Introduce #Generated.
	* src/xlat/README.md: Document it.

2025-10-28  Dmitry V. Levin  <ldv@strace.io>

	Document xlat file format.
	* src/xlat/README.md: New file.

2025-10-28  Dmitry V. Levin  <ldv@strace.io>

	xlat: drop numeric constants support.
	Numeric constant support was introduced by commit v4.9~69 to handle
	several corner cases that are no longer relevant.  The last numeric
	constant was removed by commit v6.0~27, and there are no plans to use
	them again.

	* src/xlat/gen.sh: Remove special handling of [0-9]* lines.

2025-10-28  Dmitry V. Levin  <ldv@strace.io>

	xlat/gen.sh: fix handling of 1<<(shift constant expression) syntax.
	*src/xlat/gen.sh: Handle 1<<(shift constant expression) as a shift
	constant expression instead of a numeric expression.

	src/xlat/hdio_ide_nice.in: use proper shift constant expression syntax.
	* src/xlat/hdio_ide_nice.in: Remove unsuported witespace to make sure
	shift constant expressions are not handled as numeric expressions.

	xlat: update BR_* constants.
	* src/xlat/rtnl_ifla_br_boolopts.in (BR_BOOLOPT_FDB_LOCAL_VLAN_0):
	New constant introduced by Linux kernel commit v6.18-rc1~132^2~195^2~4.
	* src/xlat/rtnl_ifla_br_boolopt_flags.in
	(1<<BR_BOOLOPT_FDB_LOCAL_VLAN_0): Likewise.
	* tests/nlattr_ifla_linkinfo.c (main): Update expected output.
	* NEWS: Mention this change.

2025-10-27  Masatake YAMATO  <yamato@redhat.com>

	kvm: decode KVM_EXIT_MMIO related fields of kvm_run struct.
	* src/kvm.c (kvm_run_structure_decode_mmio): New function.
	(kvm_run_structure_decode_main) <case KVM_EXIT_MMIO>: Decode the area
	of kvm_run struct.
	* tests/ioctl_kvm_run_common.c (__asm__): Add the instructions
	accessing address where no memory backing store to code.
	(run_kvm): Raise an error only when getting unexpected MMIO exit.
	* tests/ioctl_kvm_run_auxstr_vcpu_more.c (print_KVM_RUN_MORE): Print
	mmio members of kvm_run struct.

	kvm: decode KVM_EXIT_IO related fields of kvm_run struct.
	* src/kvm.c: Include "xlat/kvm_exit_io.h".
	(kvm_run_structure_decode_io): New function.
	(kvm_run_structure_decode_main) <case KVM_EXIT_IO>: Call
	kvm_run_structure_decode_io.
	* src/xlat/kvm_exit_io.in: New file.
	* tests/ioctl_kvm_run_auxstr_vcpu_more.c (print_KVM_RUN_MORE)
	<case KVM_EXIT_IO>: Print the members in kvm_run::io.

	tests: check decoding of kvm=vcpu+
	* tests/.gitignore (ioctl_kvm_run_auxstr_vcpu_more): New entry.
	* tests/gen_tests.in: Generate
	ioctl_kvm_run_auxstr_vcpu_more.gen.test.
	* tests/ioctl_kvm_run.c (print_KVM_RUN): Extend signature as
	defined in tests/ioctl_kvm_run_auxstr_vcpu.c.
	* tests/ioctl_kvm_run_auxstr_vcpu.c (need_print_KVM_RUN_MORE): Define
	if need_print_KVM_RUN is defined.
	(print_KVM_RUN_MORE): Declare if print_KVM_RUN_MORE is defined.
	(print_KVM_RUN): Extend the interface. Call print_KVM_RUN_MORE.
	* tests/ioctl_kvm_run_auxstr_vcpu_more.c: New file, a wrapper around
	ioctl_kvm_run_auxstr_vcpu_more.c.
	* tests/ioctl_kvm_run_common.c (print_KVM_RUN): Adjust the signature
	to the new interface.
	(run_kvm): pass the states of kvm_run before calling KVM_RUN
	and that of after calling KVM_RUN to print_KVM_RUN.
	* tests/pure_executables.list: Add ioctl_kvm_run_auxstr_vcpu_more.

2025-10-27  Masatake YAMATO  <yamato@redhat.com>

	kvm: decode kvm_run structure when -e kvm=vcpu+ option is given.
	Decode like:

	  # ./strace -f -p "$(pidof qemu-system-x86_64)" -e kvm=vcpu+ -e ioctl
	  ...
	  [pid 2652507] ioctl(25, KVM_RUN, 0)     = 0 (KVM_EXIT_MMIO)
	   VCPU:1> {request_interrupt_window=0, immediate_exit=0, \
	    exit_reason=6 (KVM_EXIT_MMIO), ready_for_interrupt_injection=1, \
	    if_flag=1, flags=0, cr8=0x00000000000001, apic_base=0x000000fee00c00}

	* src/defs.h (struct tcb::vcpu_leaving,
	struct tcb::vcpu_entering): New members.
	(enum decode_kvm_run_structure_modes::decode_kvm_run_structure_modes): New
	enumerator.
	(kvm_run_structure_decode): Declare.
	* src/filter_qualify.c (qualify_kvm): Handle "-e kvm=vcpu+".
	* src/kvm.c (kvm_vcpu_info_free): Free the memory object assigned to
	struct tcb::vcpu_entering.
	(kvm_ioctl_run_attach_auxstr): Store the function static variable
	vcpu_run_struct to struct tcb::vcpu_leaving.
	(kvm_ioctl_decode_run): Copy-in the kvm_run area of the fd to
	 struct tcb::vcpu_entering.
	(kvm_run_structure_decode_main, kvm_run_structure_decode): New
	functions.
	* src/syscall.c (syscall_exiting_trace): Call kvm_run_structure_decode.
	* src/strace.c (usage): Document the vcpu+.
	* NEWS: Mention this enhancement.

2025-10-26  Masatake YAMATO  <yamato@redhat.com>

	kvm: add a helper function for copying-in kvm_run struct.
	* src/kvm.c (kvm_ioctl_run_umove): The new helper function.

2025-10-26  Masatake YAMATO  <yamato@redhat.com>

	kvm: make the error message of command line parsing more generic.
	This is a preparation for future enhancement of "-e kvm=vcpu" option.

	* src/filter_qualify.c (qualify_kvm): Include the option argument
	as-is to the error message.

2025-10-26  Masatake YAMATO  <yamato@redhat.com>

	kvm: introduce a concept "mode" of decoding kvm_run structure.
	This is a preparation for future enhancement.

	* src/defs.h (decode_kvm_run_structure_modes): New enum.
	(kvm_run_structure_decoder_init): Extend the interface of the function
	to take enum decode_kvm_run_structure_modes as an argument.
	* src/filter_qualify.c (qualify_kvm): Pass
	DECODE_KVM_RUN_STRUCTURE_EXIT_REASON to
	kvm_run_structure_decoder_init().
	* src/kvm.c (decode_kvm_run_structure): Change the variable type
	to enum decode_kvm_run_structure_modes from bool.
	(kvm_run_structure_decoder_init): Save
	enum decode_kvm_run_structure_modes argument into
	decode_kvm_run_structure.

2025-10-26  Masatake YAMATO  <yamato@redhat.com>

	kvm: (refactor) unify the terms used in code printing kvm_run struct.
	In the original code, both "decode" and "dump" were used.

	* src/kvm (decode_kvm_run_structure): Rename from
	dump_kvm_run_structure.
	(kvm_ioctl_create_vcpu, kvm_ioctl_decode_run,
	kvm_run_structure_decoder_init): Use the renamed variable.

2025-10-26  Masatake YAMATO  <yamato@redhat.com>

	tests: use .code16 to express kvm input directly in real-mode.
	In the original proposal, the code passed to the virtual machine
	was assumed being executed in real-mode:

	https://lists.strace.io/pipermail/strace-devel/2017-December/007764.html

	    +	const uint8_t code[] = {
	    +		0xba, 0xf8, 0x03, /* mov $0x3f8, %dx */
	    +		0x00, 0xd8,       /* add %bl, %al */
	    +		0x04, '0',        /* add $'0', %al */
	    ...

	This code was derived from https://lwn.net/Articles/658511/.
	code[] was well understandable.

	However, when merging as 4f47c43ce73abf0398eb7f080a35fd3c5c1ff401,
	the code was arranged like:

	    +code(void)
	    +{
	    +   __asm__("mov $0xd80003f8, %edx; mov $'\n', %al; out %al, (%dx); hlt");

	The notation was converted to protect-mode(e.g. %edx) though the gas
	output of __asm__ (...) is the same as the code[] in the original
	proposal.  I don't understand the intention and profit behind this
	conversion.

	The code was transformed again in the development history,
	101621d4c7aac7be44570477480de04181236a09:

	    +__asm__(
	    +   ".type code, @object        \n"
	    +   "code:              \n"
	    +   "   mov $0xd80003f8, %edx   \n"

	Just after making a virtual machine, it is in real-mode.  So writing
	the code passed to the virtual machine in the real-mode in real-mode
	notation is intuitive. It is hard to extend the the code passed to the
	virtual machine in the real-mode in protect-mode notation.

	* tests/ioctl_kvm_run_common.c (top-level): Use .code16 int
	the inline assembly code. Rewrite the code in real-mode notation.

2025-10-23  Dmitry V. Levin  <ldv@strace.io>

	Implement FS_IOC_GETLBMD_CAP ioctl decoder.
	* src/xlat/lbmd_pi_cap_flags.in: New file.
	* src/xlat/lbmd_pi_csum_types.in: Likewise.
	* src/fs_0x15_ioctl.c: Include "xlat/lbmd_pi_cap_flags.h" and
	"xlat/lbmd_pi_csum_types.h".
	(decode_logical_block_metadata_cap): New function.
	(fs_0x15_ioctl): Use it to handle FS_IOC_GETLBMD_CAP.
	* tests/ioctl_fs_0x15.c (main): Check FS_IOC_GETLBMD_CAP decoding.
	* NEWS: Mention this change.

2025-10-22  Dmitry V. Levin  <ldv@strace.io>

	Implement FS_IOC_GETFSSYSFSPATH ioctl decoder.
	* src/fs_0x15_ioctl.c (decode_fs_sysfs_path): New function.
	(fs_0x15_ioctl): Use it to handle FS_IOC_GETFSSYSFSPATH.
	* tests/ioctl_fs_0x15.c (main): Check FS_IOC_GETFSSYSFSPATH decoding.
	* NEWS: Mention this change.

2025-10-21  Dmitry V. Levin  <ldv@strace.io>

	Implement FS_IOC_GETFSUUID ioctl decoder.
	* src/fs_0x15_ioctl.c (decode_fsuuid2): New function.
	(fs_0x15_ioctl): Use it to handle FS_IOC_GETFSUUID.
	* tests/ioctl_fs_0x15.c (do_ioctl_ptr): New function.
	(main): Check FS_IOC_GETFSUUID decoding.
	* NEWS: Mention this change.

	Introduce framework for decoding of linux/fs.h 0x15 ioctl commands.
	* src/fs_0x15_ioctl.c: New file.
	* src/Makefile.am (libstrace_a_SOURCES): Add fs_0x15_ioctl.c.
	* src/defs.h (DECL_IOCTL): Add fs_0x15.
	* src/ioctl.c (ioctl_decode): Handle ioctl type 0x15.
	* tests/ioctl_fs_0x15.c: New file.
	* tests/ioctl_fs_0x15-Xabbrev.c: Likewise.
	* tests/ioctl_fs_0x15-Xraw.c: Likewise.
	* tests/ioctl_fs_0x15-Xverbose.c: Likewise.
	* tests/ioctl_fs_0x15-success.c: Likewise.
	* tests/ioctl_fs_0x15-success-Xabbrev.c: Likewise.
	* tests/ioctl_fs_0x15-success-Xraw.c: Likewise.
	* tests/ioctl_fs_0x15-success-Xverbose.c: Likewise.
	* tests/pure_executables.list: Add ioctl_fs_0x15, ioctl_fs_0x15-Xabbrev,
	ioctl_fs_0x15-Xraw, and ioctl_fs_0x15-Xverbose.
	* tests/Makefile.am (check_PROGRAMS): Add ioctl_fs_0x15-success,
	ioctl_fs_0x15-success-Xabbrev, ioctl_fs_x-success-Xraw,
	and ioctl_fs_0x15-success-Xverbose.
	* tests/.gitignore: Add ioctl_fs_0x15, ioctl_fs_0x15-Xabbrev,
	ioctl_fs_0x15-Xraw, ioctl_fs_0x15-Xverbose, ioctl_fs_0x15-success,
	ioctl_fs_0x15-success-Xabbrev, ioctl_fs_0x15-success-Xraw, and
	ioctl_fs_0x15-success-Xverbose.
	* tests/gen_tests.in (ioctl_fs_0x15, ioctl_fs_0x15-Xabbrev,
	ioctl_fs_0x15-Xraw, ioctl_fs_0x15-Xverbose, ioctl_fs_0x15-success,
	ioctl_fs_0x15-success-Xabbrev, ioctl_fs_0x15-success-Xraw,
	ioctl_fs_0x15-success-Xverbose): New tests.

2025-10-20  Dmitry V. Levin  <ldv@strace.io>

	ioctl: optimize decoding of certain unknown ioctl types.
	When the generic ioctl handler is used to decode unknown ioctl types,
	do the decoding on entering syscall.

	* src/ioctl.c (ioctl_decode_unknown_type): Return RVAL_DECODED when
	falling back to the default handler.

2025-10-20  Dmitry V. Levin  <ldv@strace.io>

	xlat: update RWF_* constants.
	* src/xlat/rwf_flags.in (RWF_NOSIGNAL): New constant introduced
	by Linux kernel commit v6.18-rc1~242^2~18.
	* NEWS: Mention this change.

2025-10-19  Dmitry V. Levin  <ldv@strace.io>

	xlat: update AUDIT_* constants.
	* xlat/nl_audit_types.in (AUDIT_MAC_TASK_CONTEXTS): New constant
	introduced by Linux kernel commit v6.18-rc1~203^2~3.
	(AUDIT_MAC_OBJ_CONTEXTS): New constant introduced by Linux kernel
	commit v6.18-rc1~203^2~2.
	* NEWS: Mention this change.

	bundled: add uapi/linux/audit.h and uapi/linux/elf-em.h.
	* bundled/linux/include/uapi/linux/audit.h: New file, imported from
	headers_install'ed Linux kernel v6.18-rc1.
	* bundled/linux/include/uapi/linux/elf-em.h: Likewise.
	* bundled/Makefile.am (EXTRA_DIST): Add
	bundled/linux/include/uapi/linux/audit.h and
	bundled/linux/include/uapi/linux/elf-em.h.

2025-10-13  Dmitry V. Levin  <ldv@strace.io>

	bundled: update linux/tee.h to v6.18-rc1.
	Note that the definition of struct tee_ioctl_shm_register_fd_data
	introduced by Linux kernel commit v6.18-rc1~145^2~16^2~4 differs
	from the bundled definition introduced by strace commit v5.9~8,
	and this affects the value of TEE_IOC_SHM_REGISTER_FD ioctl macro.

	* bundled/include/uapi/linux/tee.h: Update to headers_install'ed
	Linux kernel v6.18-rc1.
	* src/tee.c (struct tee_ioctl_shm_register_fd_data,
	TEE_IOC_SHM_REGISTER_FD): Remove.
	* tests/ioctl_tee.c (struct tee_ioctl_shm_register_fd_data,
	TEE_IOC_SHM_REGISTER_FD): Likewise.
	(main): Update expected output.

2025-10-13  Dmitry V. Levin  <ldv@strace.io>

	bundled: update linux UAPI headers to v6.18-rc1.
	The update of linux/tee.h is delayed because of conflicts with src/tee.c.

	* bundled/include/uapi/linux/devlink.h: Update to headers_install'ed
	Linux kernel v6.18-rc1.
	* bundled/include/uapi/linux/ethtool.h: Likewise.
	* bundled/include/uapi/linux/ethtool_netlink_generated.h: Likewise.
	* bundled/include/uapi/linux/fcntl.h: Likewise.
	* bundled/include/uapi/linux/fs.h: Likewise.
	* bundled/include/uapi/linux/if_bridge.h: Likewise.
	* bundled/include/uapi/linux/if_link.h: Likewise.
	* bundled/include/uapi/linux/input-event-codes.h: Likewise.
	* bundled/include/uapi/linux/input.h: Likewise.
	* bundled/include/uapi/linux/io_uring.h: Likewise.
	* bundled/include/uapi/linux/kexec.h: Likewise.
	* bundled/include/uapi/linux/mptcp.h: Likewise.
	* bundled/include/uapi/linux/mptcp_pm.h: Likewise.
	* bundled/include/uapi/linux/netfilter/nf_tables.h: Likewise.
	* bundled/include/uapi/linux/nl80211.h: Likewise.
	* bundled/include/uapi/linux/nsfs.h: Likewise.
	* bundled/include/uapi/linux/prctl.h: Likewise.
	* bundled/include/uapi/linux/ptp_clock.h: Likewise.
	* bundled/include/uapi/linux/tcp.h: Likewise.
	* bundled/include/uapi/linux/v4l2-controls.h: Likewise.
	* bundled/include/uapi/linux/version.h: Likewise.
	* bundled/include/uapi/linux/videodev2.h: Likewise.

2025-09-29  Dmitry V. Levin  <ldv@strace.io>

	Post-release administrivia.
	* NEWS: Add a header line for the next release.
	* debian/changelog.in: Add a changelog entry for 6.17-1.
	* strace.spec.in: Likewise.

2025-09-28  Dmitry V. Levin  <ldv@strace.io>

	Prepare for 6.17 release.
	* NEWS: Update for 6.17 release.

	Update copyright headers.
	Headers updated automatically using maint/update_copyright_years.sh
	script.

2025-09-29  Gleb Fotengauer-Malinovskiy  <glebfm@altlinux.org>

	Update ioctl entries from linux v6.17.
	* src/linux/32/ioctls_inc_align16.h: Update from linux v6.17 using
	ioctls_gen.sh.
	* src/linux/32/ioctls_inc_align32.h: Likewise.
	* src/linux/32/ioctls_inc_align64.h: Likewise.
	* src/linux/64/ioctls_inc.h: Likewise.
	* src/linux/x32/ioctls_inc0.h: Likewise.
	* NEWS: Mention this.

2025-09-19  Eugene Syromyatnikov  <evgsyr@gmail.com>

	Fix typos reported by codespell.
	Correct the spelling issues reported by codespell[1].  The issues
	in the bundled directory are left intact.

	[1] https://fossies.org/linux/misc/strace-6.16.tar.xz/codespell.html

	* src/defs.h: Replace "appled" with "applied".
	* src/ldt.c: Replace "tht" with "the", following the change
	in v6.8-rc1~195^2 "arch/x86: Fix typos".
	* src/linux/s390/syscallent.h: Replace "Coporation" with "Corporation".
	* src/linux/s390x/syscallent.h: Likewise.
	* src/s390.c: Replce "re-declare" with "declare".

2025-09-02  dependabot[bot]  <49699333+dependabot[bot]@users.noreply.github.com>

	build(deps): bump actions/checkout from 4 to 5.
	Bumps [actions/checkout](https://github.com/actions/checkout) from 4 to 5.
	- [Release notes](https://github.com/actions/checkout/releases)
	- [Changelog](https://github.com/actions/checkout/blob/main/CHANGELOG.md)
	- [Commits](https://github.com/actions/checkout/compare/v4...v5)

	---
	updated-dependencies:
	- dependency-name: actions/checkout
	  dependency-version: '5'
	  dependency-type: direct:production
	  update-type: version-update:semver-major
	...

2025-09-02  Dmitry V. Levin  <ldv@strace.io>

	xlat: update V4L2_* constants.
	* src/xlat/v4l2_control_id_bases.in (V4L2_CID_USER_RKISP1_BASE):
	New constant introduced by Linux kernel commit v6.17-rc1~90^2~237.
	* src/xlat/v4l2_meta_fmts.in (V4L2_META_FMT_UVC_MSXU_1_5):
	New constant introduced by Linux kernel commit v6.17-rc1~90^2~9.
	* src/xlat/v4l2_pix_fmts.in (V4L2_PIX_FMT_RAW_CRU10,
	V4L2_PIX_FMT_RAW_CRU12, V4L2_PIX_FMT_RAW_CRU14,
	V4L2_PIX_FMT_RAW_CRU20): New constants introduced by Linux kernel
	commit v6.17-rc1~90^2~153.
	* NEWS: Mention this change.

	xlat: update PR_SYS_* constants.
	* src/xlat/pr_sud_cmds.in (PR_SYS_DISPATCH_ON): Rename to
	PR_SYS_DISPATCH_EXCLUSIVE_ON introduced by Linux kernel commit
	v6.17-rc1~152^2~2.
	(PR_SYS_DISPATCH_INCLUSIVE_ON): New constant introduced by the same
	commit.
	* tests/prctl-syscall-user-dispatch.c (main): Update.
	* NEWS: Mention this change.

2025-09-01  Dmitry V. Levin  <ldv@strace.io>

	xlat: update NETCONFA_* constants.
	* src/xlat/rtnl_netconf_attrs.in (NETCONFA_FORCE_FORWARDING): New
	constant introduced by Linux kernel commit v6.17-rc1~126^2~19.
	* src/rtnl_netconf.c (netconfmsg_nla_decoders): Handle
	NETCONFA_FORCE_FORWARDING.
	* NEWS: Mention this change.

	xlat: update NTF_EXT_* constants.
	* src/xlat/neighbor_cache_entry_ext_flags.in (NTF_EXT_EXT_VALIDATED):
	New constant introduced by Linux kernel commit v6.17-rc1~126^2~251^2~1.
	* tests/nlattr_ndmsg.c (main): Update expected output.
	* NEWS: Mention this change.

2025-08-31  Dmitry V. Levin  <ldv@strace.io>

	xlat: update KVM_* constants.
	* src/xlat/kvm_cap.in (KVM_CAP_ARM_CACHEABLE_PFNMAP_SUPPORTED): New
	constant introduced by Linux kernel commit v6.17-rc1~111^2~3^2~8^2.
	* NEWS: Mention this change.

	xlat: update KEXEC_* constants.
	* src/xlat/kexec_load_flags.in (KEXEC_FILE_NO_CMA):
	New constant introduced by Linux kernel commit v6.17-rc1~53^2~14.
	* tests/kexec_file_load.c (main): Update expected output.
	* NEWS: Mention this change.

	xlat: update DEVCONF_* constants.
	* src/xlat/inet6_devconf_indices.in (DEVCONF_FORCE_FORWARDING):
	New constant introduced by Linux kernel commit v6.17-rc1~126^2~19.
	* NEWS: Mention this change.

2025-08-28  Dmitry V. Levin  <ldv@strace.io>

	xlat: update BTN_* and KEY_* constants.
	* src/xlat/evdev_keycode.in (BTN_GRIPL, BTN_GRIPR, BTN_GRIPL2,
	BTN_GRIPR2): New constants introduced by Linux kernel commit
	v6.17-rc1~30^2^2~10.
	(KEY_PERFORMANCE): New constant introduced by Linux kernel commit
	v6.17-rc1~30^2^2~1.
	* NEWS: Mention this change.

	xlat: update XDP_* constants.
	* src/xlat/sock_xdp_options.in (XDP_MAX_TX_SKB_BUDGET): New constant
	introduced by Linux kernel commit v6.17-rc1~126^2~153.
	* NEWS: Mention this change.

2025-08-27  Dmitry V. Levin  <ldv@strace.io>

	xlat: update FALLOC_* constants.
	* src/xlat/falloc_flags.in (FALLOC_FL_WRITE_ZEROES): New constant
	introduced by Linux kernel commit v6.17-rc1~220^2^2~3.
	* tests/fallocate.c: Update.
	* NEWS: Mention this change.

	xlat: update ETHTOOL_MSG_* constants.
	* src/xlat/genl_ethtool_msg_recv.in (ETHTOOL_MSG_PSE_NTF): New constant
	introduced by Linux kernel commit v6.17-rc1~126^2~350^2~11.
	(ETHTOOL_MSG_RSS_NTF): New constant introduced by Linux kernel commit
	v6.17-rc1~126^2~291^2~2.
	(ETHTOOL_MSG_RSS_CREATE_ACT_REPLY, ETHTOOL_MSG_RSS_CREATE_NTF): New
	constants introduced by Linux kernel commit v6.17-rc1~126^2~52^2~2.
	(ETHTOOL_MSG_RSS_DELETE_NTF): New constant introduced by Linux kernel
	commit v6.17-rc1~126^2~52^2~1.
	* src/xlat/genl_ethtool_msg_send.in (ETHTOOL_MSG_RSS_SET): New constant
	introduced by Linux kernel commit v6.17-rc1~126^2~84^2~10.
	(ETHTOOL_MSG_RSS_CREATE_ACT): New constant introduced by Linux kernel
	commit v6.17-rc1~126^2~52^2~2.
	(ETHTOOL_MSG_RSS_DELETE_ACT): New constant introduced by Linux kernel
	commit v6.17-rc1~126^2~52^2~1.
	* tests/netlink_nlctrl.c (test_nla_ops_family): Check it.
	* NEWS: Mention this change.

2025-08-25  Dmitry V. Levin  <ldv@strace.io>

	xlat: update BTRFS_* constants.
	* src/xlat/btrfs_defrag_flags.in (BTRFS_DEFRAG_RANGE_NOCOMPRESS):
	New constant introduced by Linux kernel commit v6.17-rc1~240^2~8.
	* NEWS: Mention this.

	xlat: update BPF_* constants.
	* src/xlat/bpf_commands.in (BPF_PROG_STREAM_READ_BY_FD): New constant
	introduced by Linux kernel commit v6.17-rc1~125^2~36^2~10.
	* NEWS: Mention this change.

2025-08-21  Dmitry V. Levin  <ldv@strace.io>

	xlat: update SCM_* constants.
	* src/xlat/scmvals.in (SCM_INQ): New constant introduced
	by Linux kernel commit v6.17-rc1~126^2~172^2~1.
	* NEWS: Mention this change.

	net: implement decoding of SO_INQ socket option.
	* src/xlat/sock_options.in (SO_INQ): New constant introduced
	by Linux kernel commit v6.17-rc1~126^2~172^2~1.
	* src/net.c (print_getsockopt, print_setsockopt) <SO_INQ>: Print it.
	* tests/sockopt-sol_socket.c (main): Test it.
	* NEWS: Mention this change.

2025-08-21  Dmitry V. Levin  <ldv@strace.io>

	xlat: fix decoding of SO_DEVMEM_DONTNEED socket option.
	Unlike SCM_DEVMEM_LINEAR and SCM_DEVMEM_DMABUF, SO_DEVMEM_DONTNEED
	is a setsockopt socket option and not a control message type.

	* src/xlat/scmvals.in (SO_DEVMEM_DONTNEED): Move ...
	* src/xlat/setsock_options.in: ... here.

2025-08-19  Dmitry V. Levin  <ldv@strace.io>

	tests: check decoding of file_getattr and file_setattr syscalls.
	* tests/file_xetattr-common.c: New file.
	* tests/file_getattr.c: New test.
	* tests/file_getattr-P.c: Likewise.
	* tests/file_getattr-success-Xabbrev.c: Likewise.
	* tests/file_getattr-success-Xraw.c: Likewise.
	* tests/file_getattr-success-Xverbose.c: Likewise.
	* tests/file_getattr-success.c: Likewise.
	* tests/file_getattr-y.c: Likewise.
	* tests/file_getattr-yy.c: Likewise.
	* tests/file_setattr.c: Likewise.
	* tests/file_setattr-P.c: Likewise.
	* tests/file_setattr-Xabbrev.c: Likewise.
	* tests/file_setattr-Xraw.c: Likewise.
	* tests/file_setattr-Xverbose.c: Likewise.
	* tests/file_setattr-y.c: Likewise.
	* tests/file_setattr-yy.c: Likewise.
	* tests/test_fs_xflags.h (INVALID_FS_XFLAGS64): New macro.
	* tests/Makefile.am (EXTRA_DIST): Add file_xetattr-common.c.
	* tests/pure_executables.list: Add file_getattr, file_getattr-P,
	file_getattr-success, file_getattr-success-Xabbrev,
	file_getattr-success-Xraw, file_getattr-success-Xverbose,
	file_getattr-y, file_getattr-yy, file_setattr, file_setattr-P,
	file_setattr-Xabbrev, file_setattr-Xraw, file_setattr-Xverbose,
	file_setattr-y, and file_setattr-yy.
	* tests/.gitignore: Likewise.
	* tests/gen_tests.in (file_getattr, file_getattr-P,
	file_getattr-success, file_getattr-success-Xabbrev,
	file_getattr-success-Xraw, file_getattr-success-Xverbose,
	file_getattr-y, file_getattr-yy, file_setattr, file_setattr-P,
	file_setattr-Xabbrev, file_setattr-Xraw, file_setattr-Xverbose,
	file_setattr-y, file_setattr-yy): New tests.

2025-08-19  Dmitry V. Levin  <ldv@strace.io>

	Implement decoding of file_getattr and file_setattr syscalls.
	These new syscalls were introduced by Linux kernel commit
	v6.17-rc1~214^2~2.

	* src/xlat/file_attr_flags.in: New file.
	* src/file_attr.c: Likewise.
	* src/defs.h (fs_xflags): New declaration.
	* src/Makefile.am (libstrace_a_SOURCES): Add file_attr.c.
	* src/linux/generic/syscallent-common.h [BASE_NR + 468]: Wire up
	file_getattr.
	[BASE_NR + 469]: Wire up file_setattr.
	* src/pathtrace.c (pathtrace_match_set): Handle SEN_file_getattr and
	SEN_file_setattr.
	* NEWS: Mention this change.

2025-08-19  Dmitry V. Levin  <ldv@strace.io>

	tests: move {,IN}VALID_FS_XFLAGS{,STR} macros to a separate file.
	* tests/ioctl_fs_x.c (VALID_FS_XFLAGS, INVALID_FS_XFLAGS,
	VALID_FS_XFLAGS_STR, INVALID_FS_XFLAGS_STR): Move ...
	* tests/test_fs_xflags.h: ... to new file.
	* tests/Makefile.am (EXTRA_DIST): Add test_fs_xflags.h.

	tests/ioctl_fs_x: macroize FS_XFLAG_* strings.
	* tests/ioctl_fs_x.c (VALID_FSX_XFLAGS): Rename to VALID_FS_XFLAGS.
	(INVALID_FSX_XFLAGS): Rename to INVALID_FS_XFLAGS.
	(VALID_FS_XFLAGS_STR, INVALID_FS_XFLAGS_STR): New macros.
	(main): Use them.

2025-08-17  Gyorgy Sarvari  <skandigraun@gmail.com>

	tests: fix uio.test with musl-libc.
	musl-libc handles the pwrite calls differently than glibc, making
	the uio test fail.  Using glibc, there are separated pwrite and pwritev
	calls, however musl uses only pwritev2 for both pwrite and pwritev.

	To account to this difference, modify the expected matching regexp
	to also match the musl output (append it with an OR).

2025-08-11  Dmitry V. Levin  <ldv@strace.io>

	bundled: update linux UAPI headers to v6.17-rc1.
	* bundled/linux/include/uapi/linux/btrfs.h: Update to
	headers_install'ed Linux kernel v6.17-rc1.
	* bundled/linux/include/uapi/linux/devlink.h: Likewise.
	* bundled/linux/include/uapi/linux/ethtool.h: Likewise.
	* bundled/linux/include/uapi/linux/ethtool_netlink.h: Likewise.
	* bundled/linux/include/uapi/linux/ethtool_netlink_generated.h: Likewise.
	* bundled/linux/include/uapi/linux/falloc.h: Likewise.
	* bundled/linux/include/uapi/linux/fcntl.h: Likewise.
	* bundled/linux/include/uapi/linux/fs.h: Likewise.
	* bundled/linux/include/uapi/linux/if_link.h: Likewise.
	* bundled/linux/include/uapi/linux/if_xdp.h: Likewise.
	* bundled/linux/include/uapi/linux/in6.h: Likewise.
	* bundled/linux/include/uapi/linux/input-event-codes.h: Likewise.
	* bundled/linux/include/uapi/linux/input.h: Likewise.
	* bundled/linux/include/uapi/linux/io_uring.h: Likewise.
	* bundled/linux/include/uapi/linux/kexec.h: Likewise.
	* bundled/linux/include/uapi/linux/mctp.h: Likewise.
	* bundled/linux/include/uapi/linux/neighbour.h: Likewise.
	* bundled/linux/include/uapi/linux/netconf.h: Likewise.
	* bundled/linux/include/uapi/linux/netdev.h: Likewise.
	* bundled/linux/include/uapi/linux/netfilter/nfnetlink_hook.h: Likewise.
	* bundled/linux/include/uapi/linux/nl80211.h: Likewise.
	* bundled/linux/include/uapi/linux/nsfs.h: Likewise.
	* bundled/linux/include/uapi/linux/pkt_sched.h: Likewise.
	* bundled/linux/include/uapi/linux/prctl.h: Likewise.
	* bundled/linux/include/uapi/linux/v4l2-controls.h: Likewise.
	* bundled/linux/include/uapi/linux/version.h: Likewise.
	* bundled/linux/include/uapi/linux/videodev2.h: Likewise.

2025-08-06  Dmitry V. Levin  <ldv@strace.io>

	Post-release administrivia.
	* NEWS: Add a header line for the next release.
	* debian/changelog.in: Add a changelog entry for 6.16-1.
	* strace.spec.in: Likewise.

2025-08-05  Dmitry V. Levin  <ldv@strace.io>

	Prepare for 6.16 release.
	* NEWS: Update for 6.16 release.

	Update copyright headers.
	Headers updated automatically using maint/update_copyright_years.sh
	script.

	tests: change a few tests to check -N/--arg-names option.
	* tests/gen_tests.in (fchdir): Pass -N option.
	(flock): Pass --arg-names option.
	* tests/fchdir.c (main): Update expected output.
	* tests/flock.c (main): Likewise.

	tests: check -N/--arg-names error diagnostics.
	* tests/options-syntax.test: Check -N/--arg-names in combination with -c/--summary-only

2025-08-05  Gustavo Costa  <xfgusta@gmail.com>

	strace: add an option for printing syscall argument names.
	* src/strace.c (Nflag): New variable.
	(init): Handle -N/--arg-names option.
	(usage): Document it.
	* src/defs.h (Nflag): New variable declaration.
	* src/print_fields.h (tprints_arg_name) [IN_STRACE]: Use Nflag.
	* doc/strace.1.in: Document the new option.
	* NEWS: Mention this change.

2025-08-04  Dmitry V. Levin  <ldv@strace.io>

	s390: annotate syscall argument names using tprints_arg_name and tprints_arg_next_name
	* src/s390.c (SYS_FUNC(s390_sthyi), SYS_FUNC(s390_guarded_storage),
	SYS_FUNC(s390_runtime_instr), SYS_FUNC(s390_pci_mmio_write),
	SYS_FUNC(s390_pci_mmio_read)): Annotate syscall argument names using
	tprints_arg_name and tprints_arg_next_name.

	prctl: annotate syscall argument names using tprints_arg_next_name.
	* src/prctl.c (print_get_uint_arg, print_set_kulong_arg): New functions.
	(SYS_FUNC(prctl)): Use them.
	(print_prctl_args,  SYS_FUNC(prctl)): Annotate syscall argument names
	using tprints_arg_next_name.

2025-08-04  Dmitry V. Levin  <ldv@strace.io>

	prctl: enhance printing of the last argument of PR_SCHED_CORE.
	Only PR_SCHED_CORE_GET operation of PR_SCHED_CORE command takes the last
	argument as a pointer.

	* src/prctl.c (SYS_FUNC(prctl)) <PR_SCHED_CORE && !PR_SCHED_CORE_GET>:
	Do not treat the last argument as a pointer.
	* tests/prctl-sched-core.c (main): Update expected output.

2025-08-04  Dmitry V. Levin  <ldv@strace.io>

	printargs: annotate syscall argument names.
	* src/util.c (printargs): Annotate syscall argument names using
	tprints_arg_name and tprints_arg_next_name.

	defs.h: define MAX_ARGS unconditionally.
	* src/defs.h (MAX_ARGS): Define unconditionally.

	defs.h: apply hardening to n_args() macro.
	* src/defs.h (n_args): Make sure the return value does not exceed
	MAX_ARGS.

	keyctl: annotate syscall argument names using tprints_arg_next_name.
	* src/keyctl.c (keyctl_get_keyring_id, keyctl_update_key,
	keyctl_handle_key_key, keyctl_read_key, keyctl_keyring_search,
	keyctl_chown_key, keyctl_instantiate_key, keyctl_instantiate_key_iov,
	keyctl_negate_key, keyctl_reject_key, keyctl_set_timeout,
	keyctl_get_persistent, keyctl_setperm_key, print_dh_params,
	keyctl_dh_compute, keyctl_pkey_query, keyctl_pkey_op,
	keyctl_restrict_keyring, keyctl_move, keyctl_capabilities,
	SYS_FUNC(keyctl)): Annotate syscall argument names using
	tprints_arg_next_name.

	ipc_msg: annotate indirect msgrcv syscall on error path.
	* src/ipc_msg.c (fetch_msgrcv_args): Use umoven and umove instead of
	their high-level wrappers.
	(SYS_FUNC(msgrcv)): When fetch_msgrcv_args returns an error, annotate
	syscall arguments using tprints_arg_next_name.

	src: remove no longer used function printargs_d.
	* src/defs.h (printargs_d): Remove.
	* src/util.c (printargs_d): Likewise.

	src: introduce a separate parser for timer_delete and timer_getoverrun syscalls
	* src/time.c (SYS_FUNC(timer_delete)): New function.
	* src/syscall_dummy.h (sys_timer_delete): Remove alias.
	(sys_timer_getoverrun): Alias to sys_timer_delete instead of printargs_d.

	src: enhance setpgrp decoder.
	* src/syscall_dummy.h (set_setpgrp): Alias to sys_setpgid instead of
	printargs_d.

	src: introduce a separate parser for nice syscall.
	* src/nice.c: New file.
	* src/Makefile.am (libstrace_a_SOURCES): Add nice.c.
	* src/syscall_dummy.h (sys_nice): Remove alias.

	src: introduce a separate parser for iopl syscall.
	* src/iopl.c: New file.
	* src/Makefile.am (libstrace_a_SOURCES): Add iopl.c.
	* src/syscall_dummy.h (sys_iopl): Remove alias.

2025-08-04  Gustavo Costa  <xfgusta@gmail.com>

	src: introduce a separate parser for pkey_free syscall.
	* src/pkeys.c (SYS_FUNC(pkey_free)): New function.
	* src/syscall_dummy.h (sys_pkey_free): Remove alias to printargs_d.

	src: introduce a separate parser for set_tid_address syscall.
	* src/set_tid_address.c: New file.
	* src/Makefile.am (libstrace_a_SOURCES): Add set_tid_address.c.
	* src/syscall_dummy.h (sys_set_tid_address): Remove alias to printargs.

	src: introduce a separate parser for exit syscall.
	* src/exit.c: New file.
	* src/Makefile.am (libstrace_a_SOURCES): Add exit.c.
	* src/syscall_dummy.h (sys_exit): Remove alias to printargs_d.

2025-08-04  Dmitry V. Levin  <ldv@strace.io>

	src: remove no longer used function printargs_u.
	The last user of printargs_u was sys_alarm alias.

	* src/defs.h (printargs_u): Remove.
	* src/util.c (printargs_u): Likewise.

2025-08-04  Gustavo Costa  <xfgusta@gmail.com>

	src: introduce a separate parser for alarm syscall.
	* src/alarm.c: New file.
	* src/Makefile.am (libstrace_a_SOURCES): Add alarm.c.
	* src/syscall_dummy.h (sys_alarm): Remove alias to printargs_u.

	src: annotate syscall parsers using tprints_arg_name and tprints_arg_next_name
	* maint/gen/codegen.c (generate_decoder): Annotate syscall argument
	names using tprints_arg_name and tprints_arg_next_name.
	* src/gen/gen_hdio.c: Update generated file.
	* src/access.c (decode_access, decode_faccessat): Annotate syscall
	argument names using tprints_arg_name and tprints_arg_next_name.
	* src/affinity.c (SYS_FUNC(sched_setaffinity),
	SYS_FUNC(sched_getaffinity)): Likewise.
	* src/aio.c (SYS_FUNC(io_setup), SYS_FUNC(io_destroy),
	SYS_FUNC(io_submit), SYS_FUNC(io_cancel), print_io_getevents): Likewise.
	* src/alpha.c (SYS_FUNC(osf_statfs), SYS_FUNC(osf_fstatfs)): Likewise.
	* src/bind.c (SYS_FUNC(bind)): Likewise.
	* src/bjm.c (SYS_FUNC(delete_module), SYS_FUNC(init_module),
	SYS_FUNC(finit_module)): Likewise.
	* src/block.c (block_ioctl): Likewise.
	* src/bpf.c (SYS_FUNC(bpf)): Likewise.
	* src/btrfs.c (btrfs_ioctl): Likewise.
	* src/cacheflush.c (SYS_FUNC(cacheflush)): Likewise.
	* src/cachestat.c (SYS_FUNC(cachestat)): Likewise.
	* src/capability.c (SYS_FUNC(capget), SYS_FUNC(capset)): Likewise.
	* src/chdir.c (SYS_FUNC(chdir)): Likewise.
	* src/chmod.c (decode_chmod, decode_fchmodat, SYS_FUNC(fchmodat2),
	SYS_FUNC(fchmod)): Likewise.
	* src/clone.c (SYS_FUNC(clone3), SYS_FUNC(setns), SYS_FUNC(unshare)):
	Likewise.
	* src/close_range.c (SYS_FUNC(close_range)): Likewise.
	* src/copy_file_range.c (SYS_FUNC(copy_file_range)): Likewise.
	* src/counter_ioctl.c (counter_ioctl): Likewise.
	* src/desc.c (decode_select, do_pselect6, SYS_FUNC(close),
	SYS_FUNC(oldselect)): Likewise.
	* src/dirent.c (SYS_FUNC(readdir)): Likewise.
	* src/dm.c (dm_known_ioctl): Likewise.
	* src/dup.c (dup_123): Likewise.
	* src/epoll_ioctl.c (print_struct_epoll_params): Likewise.
	* src/epoll.c (SYS_FUNC(epoll_create), SYS_FUNC(epoll_create1),
	SYS_FUNC(epoll_ctl), epoll_wait_common, epoll_pwait_common): Likewise.
	* src/evdev.c (evdev_ioctl): Likewise.
	* src/eventfd.c (do_eventfd): Likewise.
	* src/execve.c (decode_execve, SYS_FUNC(execveat), SYS_FUNC(execv)):
	Likewise.
	* src/fadvise.c (SYS_FUNC(fadvise64), SYS_FUNC(fadvise64_64)): Likewise.
	* src/fallocate.c (SYS_FUNC(fallocate)): Likewise.
	* src/fanotify.c (SYS_FUNC(fanotify_init), SYS_FUNC(fanotify_mark)):
	Likewise.
	* src/fchownat.c (SYS_FUNC(fchownat)): Likewise.
	* src/fcntl.c (print_fcntl, SYS_FUNC(fcntl), SYS_FUNC(fcntl64)):
	Likewise.
	* src/file_handle.c (SYS_FUNC(name_to_handle_at),
	SYS_FUNC(open_by_handle_at)): Likewise.
	* src/flock.c (SYS_FUNC(flock)): Likewise.
	* src/fs_0x94_ioctl.c (decode_file_dedupe_range, fs_0x94_ioctl):
	Likewise.
	* src/fs_f_ioctl.c (decode_fiemap, fs_f_ioctl): Likewise.
	* src/fs_x_ioctl.c (fs_x_ioctl): Likewise.
	* src/fsconfig.c (SYS_FUNC(fsconfig)): Likewise.
	* src/fsmount.c (SYS_FUNC(fsmount)): Likewise.
	* src/fsopen.c (SYS_FUNC(fsopen)): Likewise.
	* src/fspick.c (SYS_FUNC(fspick)): Likewise.
	* src/fstatfs.c (SYS_FUNC(fstatfs)): Likewise.
	* src/fstatfs64.c (SYS_FUNC(fstatfs64)): Likewise.
	* src/futex.c (do_futex): Likewise.
	* src/futex2.c (SYS_FUNC(futex_waitv), SYS_FUNC(futex_wake),
	SYS_FUNC(futex_wait), SYS_FUNC(futex_requeue)): Likewise.
	* src/get_robust_list.c (SYS_FUNC(get_robust_list)): Likewise.
	* src/getcpu.c (SYS_FUNC(getcpu)): Likewise.
	* src/getcwd.c (SYS_FUNC(getcwd)): Likewise.
	* src/getpid.c (SYS_FUNC(getpgid), SYS_FUNC(getsid),
	SYS_FUNC(setpgid)): Likewise.
	* src/getrandom.c (SYS_FUNC(getrandom)): Likewise.
	* src/gpio_ioctl.c (print_gpiochip_info, print_gpioline_info,
	print_gpioline_info_unwatch, print_gpiohandle_request,
	print_gpioevent_request, print_gpiohandle_get_values,
	print_gpiohandle_set_values, print_gpiohandle_set_config,
	print_gpio_v2_line_info, print_gpio_v2_line_request,
	print_gpio_v2_line_get_values, print_gpio_v2_line_set_values,
	print_gpio_v2_line_set_config): Likewise.
	* src/hdio.c (print_hdio_getgeo, print_hdio_drive_cmd): Likewise.
	* src/hostname.c (SYS_FUNC(sethostname), SYS_FUNC(gethostname)):
	Likewise.
	* src/inotify_ioctl.c (inotify_ioctl): Likewise.
	* src/inotify.c (SYS_FUNC(inotify_add_watch),
	SYS_FUNC(inotify_rm_watch), SYS_FUNC(inotify_init1)): Likewise.
	* src/io_uring.c (SYS_FUNC(io_uring_setup), SYS_FUNC(io_uring_enter),
	SYS_FUNC(io_uring_register)): Likewise.
	* src/io.c (SYS_FUNC(read), SYS_FUNC(write), SYS_FUNC(readv),
	SYS_FUNC(writev), SYS_FUNC(pread), SYS_FUNC(pwrite), SYS_FUNC(tee),
	SYS_FUNC(splice), SYS_FUNC(vmsplice), do_preadv, do_pwritev): Likewise.
	* src/ioctl.c (SYS_FUNC(ioctl), ioctl_decode_unknown_type): Likewise.
	* src/ioperm.c (SYS_FUNC(ioperm)): Likewise.
	* src/ioprio.c (SYS_FUNC(ioprio_get), SYS_FUNC(ioprio_set)): Likewise.
	* src/ipc_msg.c (SYS_FUNC(msgget), SYS_FUNC(msgsnd), SYS_FUNC(msgrcv),
	tprint_msgsnd, tprint_msgrcv): Likewise.
	* src/ipc_msgctl.c (SYS_FUNC(msgctl)): Likewise.
	* src/ipc_sem.c (tprint_sembuf_array, do_semtimedop, SYS_FUNC(semop),
	SYS_FUNC(semget)): Likewise.
	* src/ipc_semctl.c (SYS_FUNC(semctl)): Likewise.
	* src/ipc_shm.c (SYS_FUNC(shmget), SYS_FUNC(shmat), SYS_FUNC(shmdt),
	print_shmaddr_shmflg): Likewise.
	* src/ipc_shmctl.c (SYS_FUNC(shmctl)): Likewise.
	* src/ipc.c (SYS_FUNC(ipc)): Likewise.
	* src/kcmp.c (SYS_FUNC(kcmp)): Likewise.
	* src/kd_ioctl.c (kiocsound, kd_mk_tone, kd_get_kb_type, kd_io,
	kd_set_mode, kd_get_mode, kd_screen_map, kd_uni_screen_map,
	kd_set_kbd_mode, kd_get_kbd_mode, kd_kbd_entry, kd_kbd_str_entry,
	kd_diacr, kd_diacr_uc, kd_keycode, kd_sigaccept, kd_kbdrep, kd_font,
	kd_kbmeta, kd_unimapclr, kd_cmap): Likewise.
	* src/kd_mpers_ioctl.c (kd_unimap, kd_fontx, kd_font_op): Likewise.
	* src/kexec.c (SYS_FUNC(kexec_load), SYS_FUNC(kexec_file_load)):
	Likewise.
	* src/keyctl.c (SYS_FUNC(add_key), SYS_FUNC(request_key),
	SYS_FUNC(keyctl)): Likewise.
	* src/kvm.c (kvm_ioctl_create_vcpu, kvm_ioctl_set_user_memory_region,
	kvm_ioctl_decode_regs, kvm_ioctl_decode_cpuid2, kvm_ioctl_decode_sregs,
	kvm_ioctl_decode_check_extension): Likewise.
	* src/landlock.c (SYS_FUNC(landlock_create_ruleset),
	SYS_FUNC(landlock_add_rule), SYS_FUNC(landlock_restrict_self)):
	Likewise.
	* src/ldt.c (SYS_FUNC(modify_ldt), SYS_FUNC(set_thread_area),
	SYS_FUNC(get_thread_area)): Likewise.
	* src/link.c (SYS_FUNC(link), SYS_FUNC(linkat), SYS_FUNC(unlinkat),
	SYS_FUNC(symlinkat)): Likewise.
	* src/lirc_ioctl.c (lirc_ioctl): Likewise.
	* src/listen.c (SYS_FUNC(listen)): Likewise.
	* src/listmount.c (SYS_FUNC(listmount)): Likewise.
	* src/lookup_dcookie.c (SYS_FUNC(lookup_dcookie)): Likewise.
	* src/loop.c (loop_ioctl): Likewise.
	* src/lseek.c (SYS_FUNC(lseek), SYS_FUNC(llseek)): Likewise.
	* src/lsm.c (SYS_FUNC(lsm_get_self_attr), SYS_FUNC(lsm_set_self_attr),
	SYS_FUNC(lsm_list_modules), print_args_size_flags): Likewise.
	* src/map_shadow_stack.c (SYS_FUNC(map_shadow_stack)): Likewise.
	* src/mem.c (SYS_FUNC(brk), SYS_FUNC(old_mmap),
	SYS_FUNC(old_mmap_pgoff), SYS_FUNC(munmap), SYS_FUNC(mremap),
	SYS_FUNC(madvise), SYS_FUNC(process_madvise),
	SYS_FUNC(process_mrelease), SYS_FUNC(mlockall), SYS_FUNC(msync),
	SYS_FUNC(mlock2), SYS_FUNC(mincore), SYS_FUNC(remap_file_pages),
	SYS_FUNC(mseal), SYS_FUNC(subpage_prot), print_mmap, do_mprotect):
	Likewise.
	* src/membarrier.c (SYS_FUNC(membarrier)): Likewise.
	* src/memfd_create.c (SYS_FUNC(memfd_create)): Likewise.
	* src/memfd_secret.c (SYS_FUNC(memfd_secret)): Likewise.
	* src/mknod.c (decode_mknod, SYS_FUNC(mknodat)): Likewise.
	* src/mmsghdr.c (SYS_FUNC(sendmmsg), do_recvmmsg): Likewise.
	* src/mount_setattr.c (decode_dfd_file_flags,
	decode_dfd_file_flags_attr): Likewise.
	* src/mount.c (SYS_FUNC(mount)): Likewise.
	* src/move_mount.c (SYS_FUNC(move_mount)): Likewise.
	* src/mq.c (SYS_FUNC(mq_open), SYS_FUNC(mq_notify),
	SYS_FUNC(mq_getsetattr), do_mq_timedsend, do_mq_timedreceive): Likewise.
	* src/msghdr.c (SYS_FUNC(sendmsg), SYS_FUNC(recvmsg)): Likewise.
	* src/mtd.c (mtd_ioctl): Likewise.
	* src/nbd_ioctl.c (nbd_ioctl): Likewise.
	* src/net.c (SYS_FUNC(socket), SYS_FUNC(accept4), SYS_FUNC(send),
	SYS_FUNC(sendto), SYS_FUNC(recv), SYS_FUNC(recvfrom), SYS_FUNC(pipe),
	SYS_FUNC(socketpair), SYS_FUNC(getsockopt), SYS_FUNC(setsockopt),
	decode_sockname, do_pipe, print_sockopt_fd_level_name): Likewise.
	* src/numa.c (SYS_FUNC(migrate_pages), SYS_FUNC(mbind),
	SYS_FUNC(set_mempolicy), SYS_FUNC(get_mempolicy),
	SYS_FUNC(set_mempolicy_home_node), SYS_FUNC(move_pages)): Likewise.
	* src/oldstat.c (SYS_FUNC(oldstat), SYS_FUNC(oldfstat)): Likewise.
	* src/open.c (decode_open, SYS_FUNC(openat), SYS_FUNC(openat2),
	SYS_FUNC(creat)): Likewise.
	* src/or1k_atomic.c (SYS_FUNC(or1k_atomic)): Likewise.
	* src/perf_ioctl.c (perf_ioctl_query_bpf, perf_ioctl_modify_attributes,
	perf_ioctl): Likewise.
	* src/perf.c (SYS_FUNC(perf_event_open)): Likewise.
	* src/personality.c (SYS_FUNC(personality)): Likewise.
	* src/pidfd_getfd.c (SYS_FUNC(pidfd_getfd)): Likewise.
	* src/pidfd_open.c (SYS_FUNC(pidfd_open)): Likewise.
	* src/pkeys.c (SYS_FUNC(pkey_alloc)): Likewise.
	* src/nsfs.c (nsfs_ioctl): Likewise.
	* src/poll.c (decode_poll_entering, do_poll, do_ppoll): Likewise.
	* src/prctl.c (SYS_FUNC(prctl), SYS_FUNC(arch_prctl)): Likewise.
	* src/print_sg_req_info.c (decode_sg_req_info): Likewise.
	* src/process_vm.c (SYS_FUNC(process_vm_readv),
	SYS_FUNC(process_vm_writev)): Likewise.
	* src/ptp.c (ptp_ioctl): Likewise.
	* src/ptrace.c (decode_ptrace_entering): Likewise.
	* src/quota.c (decode_cmd_data, SYS_FUNC(quotactl),
	SYS_FUNC(quotactl_fd)): Likewise.
	* src/random_ioctl.c (random_ioctl): Likewise.
	* src/readahead.c (SYS_FUNC(readahead)): Likewise.
	* src/readlink.c (decode_readlink, SYS_FUNC(readlinkat)): Likewise.
	* src/reboot.c (SYS_FUNC(reboot)): Likewise.
	* src/renameat.c (decode_renameat, SYS_FUNC(renameat2)): Likewise.
	* src/resource.c (SYS_FUNC(getrlimit), SYS_FUNC(setrlimit),
	SYS_FUNC(prlimit64), SYS_FUNC(getrusage), SYS_FUNC(osf_getrusage),
	SYS_FUNC(getpriority), SYS_FUNC(setpriority)): Likewise.
	* src/riscv.c (SYS_FUNC(riscv_flush_icache)): Likewise.
	* src/rtc.c (rtc_ioctl): Likewise.
	* src/sched.c (SYS_FUNC(sched_getscheduler),
	SYS_FUNC(sched_setscheduler), SYS_FUNC(sched_getparam),
	SYS_FUNC(sched_setparam), SYS_FUNC(sched_get_priority_min),
	SYS_FUNC(sched_setattr), SYS_FUNC(sched_getattr),
	do_sched_rr_get_interval): Likewise.
	* src/scsi.c (decode_sg_scsi_id, scsi_ioctl): Likewise.
	* src/seccomp_ioctl.c (seccomp_ioctl): Likewise.
	* src/seccomp.c (SYS_FUNC(seccomp)): Likewise.
	* src/sendfile.c (SYS_FUNC(sendfile64), SYS_FUNC(sendfile)): Likewise.
	* src/shutdown.c (SYS_FUNC(shutdown)): Likewise.
	* src/sigaltstack.c (SYS_FUNC(sigaltstack)): Likewise.
	* src/signal.c (SYS_FUNC(ssetmask), SYS_FUNC(sigaction),
	SYS_FUNC(signal), SYS_FUNC(sigsuspend), SYS_FUNC(osf_sigprocmask),
	SYS_FUNC(sigprocmask), SYS_FUNC(kill), SYS_FUNC(tkill),
	SYS_FUNC(tgkill), SYS_FUNC(sigpending), SYS_FUNC(rt_sigprocmask),
	SYS_FUNC(rt_sigaction), SYS_FUNC(rt_sigpending),
	SYS_FUNC(rt_sigsuspend), SYS_FUNC(rt_tgsigqueueinfo),
	SYS_FUNC(pidfd_send_signal), print_sigqueueinfo, do_rt_sigtimedwait):
	Likewise.
	* src/signalfd.c (do_signalfd): Likewise.
	* src/sock.c (sock_ioctl, decode_ifconf): Likewise.
	* src/socketcall.c (SYS_FUNC(socketcall)): Likewise.
	* src/sram_alloc.c (SYS_FUNC(sram_alloc)): Likewise.
	* src/stat.c (SYS_FUNC(stat), SYS_FUNC(fstat), SYS_FUNC(newfstatat)):
	Likewise.
	* src/stat64.c (SYS_FUNC(stat64), SYS_FUNC(fstat64),
	SYS_FUNC(fstatat64)): Likewise.
	* src/statfs.c (SYS_FUNC(statfs)): Likewise.
	* src/statfs64.c (SYS_FUNC(statfs64)): Likewise.
	* src/statmount.c (SYS_FUNC(statmount)): Likewise.
	* src/statx.c (SYS_FUNC(statx)): Likewise.
	* src/swapon.c (SYS_FUNC(swapon)): Likewise.
	* src/sync_file_range.c (SYS_FUNC(sync_file_range)): Likewise.
	* src/sync_file_range2.c (SYS_FUNC(sync_file_range2)): Likewise.
	* src/sysctl.c (SYS_FUNC(sysctl)): Likewise.
	* src/sysinfo.c (SYS_FUNC(sysinfo)): Likewise.
	* src/syslog.c (SYS_FUNC(syslog)): Likewise.
	* src/sysmips.c (SYS_FUNC(sysmips)): Likewise.
	* src/tee.c (tee_version, tee_open_session, tee_invoke, tee_cancel,
	tee_close_session, tee_suppl_recv, tee_suppl_send, tee_shm_alloc,
	tee_shm_register_fd, tee_shm_register): Likewise.
	* src/term.c (term_ioctl): Likewise.
	* src/time.c (SYS_FUNC(gettimeofday), SYS_FUNC(settimeofday),
	SYS_FUNC(osf_gettimeofday), SYS_FUNC(osf_settimeofday),
	SYS_FUNC(getitimer), SYS_FUNC(osf_getitimer), SYS_FUNC(setitimer),
	SYS_FUNC(osf_setitimer), SYS_FUNC(timer_create),
	SYS_FUNC(timerfd_create), SYS_FUNC(alarm), do_nanosleep, do_adjtimex,
	do_clock_settime, do_clock_gettime, do_clock_nanosleep,
	do_clock_adjtime, do_timer_settime, do_timer_gettime,
	do_timerfd_settime, do_timerfd_gettime): Likewise.
	* src/times.c (SYS_FUNC(times): Likewise.
	* src/truncate.c (SYS_FUNC(truncate), SYS_FUNC(truncate64),
	SYS_FUNC(ftruncate), SYS_FUNC(ftruncate64)): Likewise.
	* src/ubi.c (decode_UBI_IOCMKVOL, decode_UBI_IOCRSVOL,
	decode_UBI_IOCRNVOL, decode_UBI_IOCEBCH, decode_UBI_IOCATT,
	decode_UBI_IOCEBMAP, decode_UBI_IOCSETVOLPROP, ubi_ioctl): Likewise.
	* src/uid.c (SYS_FUNC(setfsuid), SYS_FUNC(setuid), SYS_FUNC(getresuid),
	SYS_FUNC(setreuid), SYS_FUNC(setresuid), SYS_FUNC(chown),
	SYS_FUNC(fchown), SYS_FUNC(setgroups), SYS_FUNC(getgroups)): Likewise.
	* src/umask.c (SYS_FUNC(umask)): Likewise.
	* src/umount.c (SYS_FUNC(umount2)): Likewise.
	* src/uname.c (SYS_FUNC(uname)): Likewise.
	* src/userfaultfd.c (SYS_FUNC(userfaultfd), uffdio_ioctl): Likewise.
	* src/ustat.c (SYS_FUNC(ustat)): Likewise.
	* src/utime.c (SYS_FUNC(utime)): Likewise.
	* src/utimes.c (SYS_FUNC(utimes), SYS_FUNC(futimesat),
	SYS_FUNC(osf_utimes), do_utimensat): Likewise.
	* src/v4l2.c (print_v4l2_capability, print_v4l2_fmtdesc,
	print_v4l2_format, print_v4l2_requestbuffers, print_v4l2_exportbuffer,
	print_v4l2_buffer, print_v4l2_buffer_time32, print_v4l2_framebuffer,
	print_v4l2_buf_type, print_v4l2_streamparm, print_v4l2_standard,
	print_v4l2_input, print_v4l2_control, print_v4l2_tuner,
	print_v4l2_queryctrl, print_v4l2_query_ext_ctrl, print_v4l2_cropcap,
	print_v4l2_crop, print_v4l2_ext_controls, print_v4l2_frmsizeenum,
	print_v4l2_frmivalenum, print_v4l2_create_buffers, v4l2_ioctl):
	Likewise.
	* src/wait.c (printwaitn, SYS_FUNC(waitid)): Likewise.
	* src/watchdog_ioctl.c (watchdog_ioctl): Likewise.
	* src/xattr.c (decode_setxattr_without_path,
	decode_getxattr_without_path, print_xattr_list,
	decode_dirfd_pathname_flags, decode_dirfd_pathname_flags_name,
	SYS_FUNC(setxattr), SYS_FUNC(fsetxattr), SYS_FUNC(getxattr),
	SYS_FUNC(fgetxattr), SYS_FUNC(listxattr), SYS_FUNC(flistxattr),
	SYS_FUNC(removexattr), SYS_FUNC(fremovexattr), SYS_FUNC(setxattrat),
	SYS_FUNC(getxattrat), SYS_FUNC(listxattrat)): Likewise.
	* src/xgetdents.c (xgetdents): Likewise.

2025-08-04  Dmitry V. Levin  <ldv@strace.io>

	print_fields.h: add tprints_arg_name and tprints_arg_next_name.
	* src/print_fields.h (tprints_arg_name, tprints_arg_next_name): New
	inline functions.

	print_fields.h: update arg printing primitives.
	* src/print_fields.h (tprints_arg_name_end): Remove.
	(tprints_arg_name_begin): Replace with tprints_arg_name_unconditionally.
	tprints_arg_next_name_unconditionally): New inline function.
	* src/clone.c (SYS_FUNC(clone)): Update.

	src: move tprint_arg_next() invocations around.
	Where appropriate, move tprint_arg_next() invocations closer
	to the code that prints the corresponding arguments.

	ipc_msg: fix typos in comments.
	* src/ipc_msg.c (tprint_msgsnd, tprint_msgrcv): Fix typo in the comment
	about the address argument.

2025-08-03  Gleb Fotengauer-Malinovskiy  <glebfm@altlinux.org>

	Update ioctl entries from linux v6.16.
	* src/linux/32/ioctls_inc_align16.h: Update from linux v6.16 using
	ioctls_gen.sh.
	* src/linux/32/ioctls_inc_align32.h: Likewise.
	* src/linux/32/ioctls_inc_align64.h: Likewise.
	* src/linux/64/ioctls_inc.h: Likewise.
	* src/linux/x32/ioctls_inc0.h: Likewise.
	* src/linux/powerpc/ioctls_arch0.h: Likewise.
	* NEWS: Mention this.

2025-08-03  Gleb Fotengauer-Malinovskiy  <glebfm@altlinux.org>
	    Dmitry V. Levin  <ldv@strace.io>

	maint: update for linux v6.16.
	* maint/ioctls_sym.sh: Add workarounds for asm/ioctls.h and
	drm/nova_drm.h headers.

2025-07-29  Dmitry V. Levin  <ldv@strace.io>

	build: add toplevel recursive check-prerequisites rule.
	This is useful when one needs to build all test suite prerequisites
	without running the test suite itself.

	* configure.ac (AM_EXTRA_RECURSIVE_TARGETS): Add check-prerequisites.
	* tests/Makefile.am (.PHONY): Add check-prerequisites-local.
	(check-prerequisites-local): New rule.

2025-07-29  Dmitry V. Levin  <ldv@strace.io>

	tests: check legacy syscall tampering.
	Check legacy code used for system call tampering when
	PTRACE_SET_SYSCALL_INFO API was not available yet.

	* tests/legacy_syscall_tampering.test: New test.
	* tests/Makefile.am (MISC_TESTS): Add it.

2025-07-29  Dmitry V. Levin  <ldv@strace.io>

	tests/qual_fault-exit_group.test: run in errexit noglob nounset mode.
	This is going to be used by subsequent commits.

	* tests/qual_fault-exit_group.test: Run in errexit noglob nounset mode.

2025-07-29  Dmitry V. Levin  <ldv@strace.io>

	tests/init.sh: allow this script to be loaded more than once.
	* tests/init-once.sh: Rename from tests/init.sh.
	* tests/init.sh: New script, a thin wrapper around tests/init.sh
	with a guard against multiple loading.
	* tests/Makefile.am (check_SCRIPTS): Add init.sh.

	disable_ptrace_set_syscall_info: new helper program.
	* src/disable_ptrace_set_syscall_info.c: New file.
	* src/Makefile.am (noinst_PROGRAMS): Add
	disable_ptrace_set_syscall_info.
	(disable_ptrace_set_syscall_info_LDADD): New variable.
	* src/.gitignore: Add /disable_ptrace_set_syscall_info.

2025-07-29  Dmitry V. Levin  <ldv@strace.io>

	Introduce PTRACE_SET_SYSCALL_INFO support.
	When PTRACE_SET_SYSCALL_INFO API works, use it instead of traditional
	arch_set_{scno,error,success} API.

	* src/syscall.c (set_scno): New function declaration.
	(tamper_with_syscall_entering): Use set_scno instead of arch_set_scno.
	(set_scno): New function.
	(set_error, set_success): Use PTRACE_SET_SYSCALL_INFO API when
	available.
	* NEWS: Mention this change.

2025-07-29  Dmitry V. Levin  <ldv@strace.io>

	Check whether PTRACE_SET_SYSCALL_INFO is supported by the kernel.
	The result of this check is going to be used by subsequent commits.

	* src/ptrace_syscall_info.c (ptrace_set_syscall_info_supported): New
	variable.
	[HAVE_FORK] (do_test_ptrace_set_syscall_info): New function.
	(test_ptrace_set_syscall_info): Likewise.
	(test_ptrace_get_syscall_info): Check ptrace_set_syscall_info_supported.
	* src/ptrace_syscall_info.h (ptrace_set_syscall_info_supported,
	test_ptrace_set_syscall_info): Declare.
	* src/filter_qualify.c (inject_set): Remove static keyword.
	* src/number_set.h (inject_set): Declare.
	* src/strace.c (init): Use test_ptrace_set_syscall_info.

2025-07-29  Dmitry V. Levin  <ldv@strace.io>

	ptrace_syscall_info: prepare runtime test for PTRACE_SET_SYSCALL_INFO.
	* src/ptrace_syscall_info.c [HAVE_FORK] (dummy_syscall_args): New
	static array.
	[HAVE_FORK] (struct si_entry, struct si_exit): New types.
	[HAVE_FORK] (check_psi_none, check_psi_entry, check_psi_exit,
	do_test_ptrace_get_syscall_info): New functions.
	(test_ptrace_get_syscall_info) [HAVE_FORK]: Use
	do_test_ptrace_get_syscall_info.

2025-07-28  Dmitry V. Levin  <ldv@strace.io>

	bundled: update linux UAPI headers to v6.16.
	* bundled/linux/include/uapi/linux/ethtool_netlink.h: Update to
	headers_install'ed Linux kernel v6.16.
	* bundled/linux/include/uapi/linux/ethtool_netlink_generated.h: Likewise.
	* bundled/linux/include/uapi/linux/mptcp_pm.h: Likewise.
	* bundled/linux/include/uapi/linux/netfilter/nf_tables.h: Likewise.
	* bundled/linux/include/uapi/linux/netfilter/nfnetlink.h: Likewise.
	* bundled/linux/include/uapi/linux/vm_sockets.h: Likewise.

2025-07-28  Dmitry V. Levin  <ldv@strace.io>

	Revert "xlat: update NFT_MSG_* constants"
	The Linux kernel commit v6.16-rc7~37^2~13^2~1 reverted the change
	introduced earlier by Linux kernel commit v6.16-rc1~132^2~30^2~1.

	This reverts commit 4a80f35bda083abdd4f8be15681e24cc7d7c40c4.

	* src/xlat/nf_nftables_msg_types.in (NFT_MSG_NEWDEV, NFT_MSG_DELDEV):
	Remove.
	* src/netlink.c (decode_nlmsg_flags_netfilter): Remove them.

2025-07-27  Dmitry V. Levin  <ldv@strace.io>

	Fix a few erroneous uses of tprint_arg_next in place of tprint_struct_next
	* src/landlock.c (print_landlock_ruleset_attr): Replace
	tprint_arg_next calls with tprint_struct_next when printing struct
	landlock_ruleset_attr.
	* src/ptp.c (ptp_ioctl): Replace tprint_arg_next calls with
	tprint_struct_next when printing struct ptp_pin_desc.
	* src/sock.c (sock_ioctl): Replace tprint_arg_next calls with
	tprint_struct_next when printing struct_ifreq.

2025-07-20  Dmitry V. Levin  <ldv@strace.io>

	tests: check VIDIOC_EXPBUF decoding on exiting syscall.
	* tests/ioctl_v4l2-success.c: Include "kernel_fcntl.h".
	(main): Check VIDIOC_EXPBUF decoding.

2025-07-07  Barnabás Pőcze  <pobrn@protonmail.com>

	v4l2: decode `VIDIOC_EXPBUF`
	Decode the `VIDIOC_EXPBUF` v4l2 ioctl as follows:

	  ioctl(17</dev/video10>,
	        VIDIOC_EXPBUF,
	        {type=V4L2_BUF_TYPE_VIDEO_CAPTURE, index=2, plane=0, flags=O_RDWR|O_CLOEXEC}
	          => {fd=25</dmabuf:>}) = 0 <0.000091>

	Every current field is supported, the `fd` field is decoded on return.

	* src/v4l2.c: Decode `VIDIOC_EXPBUF`.
	* tests/ioctl_v4l2.c: Remove `VIDIOC_EXPBUF` from list of unsupported
	  ioctls, and add some `VIDIOC_EXPBUF` tests.

2025-07-02  Dmitry V. Levin  <ldv@strace.io>

	strace-log-merge.1: improve grammar, clarity and consistency.
	This change is prepared using valuable hints from the Gemini AI
	that was prompted to fix the grammar and improve clarity.

2025-07-01  Dmitry V. Levin  <ldv@strace.io>

	strace.1: improve grammar, clarity and consistency.
	This change is prepared using valuable hints from the Gemini AI
	that was prompted to fix the grammar and improve clarity.

2025-06-24  Dmitry V. Levin  <ldv@strace.io>

	xlat/btrfs_dev_stats_values.in: remove #val_type.
	* src/xlat/btrfs_dev_stats_values.in (#val_type): Remove, all constants
	are defined in enum btrfs_dev_stat_values which is a regular enum.

2025-06-23  Dmitry V. Levin  <ldv@strace.io>

	xlat: regenerate some xlat files using maint/enum2xlat.sh.
	* src/xlat/af_tipc_scope.in: Regenerate using maint/enum2xlat.sh.
	* src/xlat/crypto_nl_attrs.in: Likewise.
	* src/xlat/dcb_commands.in: Likewise.
	* src/xlat/genl_thermal_cmd.in: Likewise.
	* src/xlat/gpio_v2_line_attr_ids.in: Likewise.
	* src/xlat/gpio_v2_line_flags.in: Likewise.
	* src/xlat/in6_addr_gen_mode.in: Likewise.
	* src/xlat/nf_acct_msg_types.in: Likewise.
	* src/xlat/nf_cthelper_msg_types.in: Likewise.
	* src/xlat/nf_ctnetlink_exp_msg_types.in: Likewise.
	* src/xlat/nf_ctnetlink_msg_types.in: Likewise.
	* src/xlat/nf_cttimeout_msg_types.in: Likewise.
	* src/xlat/nf_hook_msg_types.in: Likewise.
	* src/xlat/nf_ipset_msg_types.in: Likewise.
	* src/xlat/nf_osf_msg_types.in: Likewise.
	* src/xlat/nf_queue_msg_types.in: Likewise.
	* src/xlat/nf_tables_msg_types.in: Likewise.
	* src/xlat/nf_ulog_msg_types.in: Likewise.
	* src/xlat/nl_attr_type.in: Likewise.
	* src/xlat/nl_policy_type_attr.in: Likewise.
	* src/xlat/nlmsgerr_attrs.in: Likewise.
	* src/xlat/routing_scopes.in: Likewise.
	* src/xlat/routing_table_ids.in: Likewise.
	* src/xlat/rtnl_dcb_attrs.in: Likewise.
	* src/xlat/rtnl_ifla_br_boolopts.in: Likewise.
	* src/xlat/rtnl_route_attrs.in: Likewise.

	xlat: update IPSET_CMD_* constants.
	* src/xlat/nf_ipset_msg_types.in (IPSET_CMD_GET_BYNAME,
	IPSET_CMD_GET_BYINDEX): New constants introduced by Linux kernel
	commit v5.0-rc1~129^2~14^2~34^2.
	* NEWS: Mention this change.

	xlat: update CRYPTOCFGA_STAT_* constants.
	* src/xlat/crypto_nl_attrs.in (CRYPTOCFGA_STAT_LARVAL,
	CRYPTOCFGA_STAT_HASH, CRYPTOCFGA_STAT_BLKCIPHER, CRYPTOCFGA_STAT_AEAD,
	CRYPTOCFGA_STAT_COMPRESS, CRYPTOCFGA_STAT_RNG, CRYPTOCFGA_STAT_CIPHER,
	CRYPTOCFGA_STAT_AKCIPHER, CRYPTOCFGA_STAT_KPP, CRYPTOCFGA_STAT_ACOMP):
	New constants introduced by Linux kernel commit v4.20-rc1~116^2~40.
	* NEWS: Mention this change.

	xlat: update THERMAL_GENL_CMD_* constants.
	* src/xlat/genl_thermal_cmd.in (THERMAL_GENL_CMD_THRESHOLD_GET,
	THERMAL_GENL_CMD_THRESHOLD_ADD, THERMAL_GENL_CMD_THRESHOLD_DELETE,
	THERMAL_GENL_CMD_THRESHOLD_FLUSH): New constants introduced by
	Linux kernel commit v6.13-rc1~193^2~3^2~16.
	* tests/netlink_nlctrl.c (test_nla_ops_family): Update expected output.
	* NEWS: Mention this change.

2025-06-22  Dmitry V. Levin  <ldv@strace.io>

	maint: add update-xlat.sh.
	* maint/update-xlat.sh: New helper script for updating xlat files
	generated earlier by maint/enum2xlat.sh.

2025-06-21  Dmitry V. Levin  <ldv@strace.io>

	maint: add enum2xlat.sh.
	* maint/enum2xlat.sh: New helper script for generating xlat files
	from enum definitions found in bundled kernel headers.

2025-06-20  Dmitry V. Levin  <ldv@strace.io>

	rtnl_route: implement decoding of RTA_NH_ID and RTA_FLOWLABEL.
	* src/xlat/rtnl_route_attrs.in (RTA_FLOWLABEL): New constant introduced
	by Linux kernel commit v6.14-rc1~162^2~186^2~3.
	* src/rtnl_route.c (rtmsg_nla_decoders): Handle RTA_NH_ID and
	RTA_FLOWLABEL.
	* NEWS: Mention this change.

2025-06-20  Dmitry V. Levin  <ldv@strace.io>

	netlink: rename nf_nftables_msg_types to nf_tables_msg_types.
	Change the name of the table to match the name of the enum defined
	in include/uapi/linux/netfilter/nf_tables.h file.

	* src/xlat/nf_nftables_msg_types.in: Rename
	to src/xlat/nf_tables_msg_types.in.
	* src/netlink.c: Replace nf_nftables_msg_types with nf_tables_msg_types.

2025-06-19  Dmitry V. Levin  <ldv@strace.io>

	util: use ARRSZ_PAIR macro.
	* src/util.c (printeventfd): Apply the following sed expression:
	  s/\<\([[:alpha:]][[:alnum:]_]*\), ARRAY_SIZE(\1)/ARRSZ_PAIR(\1)/

	xlat: update V4L2_* constants.
	* src/xlat/v4l2_meta_fmts.in (V4L2_META_FMT_RPI_FE_CFG,
	V4L2_META_FMT_RPI_FE_STATS): New constants introduced by Linux kernel
	commit v6.13-rc1~149^2~133.
	(V4L2_META_FMT_C3ISP_PARAMS, V4L2_META_FMT_C3ISP_STATS): New constants
	introduced by Linux kernel commit v6.16-rc1~145^2~22.
	* src/xlat/v4l2_pix_fmts.in (V4L2_PIX_FMT_Y16I): New constant introduced
	by Linux kernel commit v6.13-rc1~149^2~224.
	(V4L2_PIX_FMT_NV20, V4L2_PIX_FMT_NV15): New constants introduced
	by Linux kernel commit v6.16-rc1~145^2~307.
	* NEWS: Mention this change.

	Update decoding of statx syscall.
	* src/statx.h (struct_statx): Add stx_atomic_write_unit_max_opt
	introduced by Linux kernel commit v6.16-rc1~209^2~4^2^2~16,
	update reserved space.
	* src/statx.c (SYS_FUNC(statx)): Print stx_atomic_write_unit_max_opt
	member of struct statx when STATX_ATTR_WRITE_ATOMIC bit is set.
	* tests/xstatx.c (print_stat): Check it.
	* NEWS: Mention this change.

	xlat: update RXRPC_* constants.
	* src/xlat/sock_rxrpc_options.in (RXRPC_MANAGE_RESPONSE): New constant
	introduced by Linux kernel commit v6.16-rc1~132^2~308^2~10.
	* NEWS: Mention this change.

	xlat: update PR_* constants.
	* src/xlat/prctl_options.in (PR_GET_SHADOW_STACK_STATUS,
	PR_SET_SHADOW_STACK_STATUS, PR_LOCK_SHADOW_STACK_STATUS): New constants
	introduced by Linux kernel commit v6.13-rc1~15^2~5^2~38.
	(PR_TIMER_CREATE_RESTORE_IDS): New constant introduced by Linux kernel
	commit v6.15-rc1~204^2~4.
	(PR_FUTEX_HASH): New constant introduced by Linux kernel commit
	v6.16-rc1~199^2^2~20.
	* tests/prctl-no-args.c (options_unknown): Update.
	* NEWS: Mention this change.

2025-06-18  Dmitry V. Levin  <ldv@strace.io>

	xlat: update NFT_MSG_* constants.
	* src/xlat/nf_nftables_msg_types.in (NFT_MSG_NEWDEV, NFT_MSG_DELDEV):
	New constants introduced by Linux kernel commit v6.16-rc1~132^2~30^2~1.
	* src/netlink.c (decode_nlmsg_flags_netfilter): Handle them.
	* NEWS: Mention this change.

	xlat: update NETDEV_* constants.
	* src/xlat/genl_netdev_cmd.in (NETDEV_CMD_BIND_RX): New constant
	introduced by Linux kernel commit v6.12-rc1~232^2~32^2~11.
	(NETDEV_CMD_NAPI_SET): New constant introduced by Linux kernel commit
	v6.13-rc1~135^2~333^2~3.
	(NETDEV_CMD_BIND_TX): New constant introduced by Linux kernel commit
	v6.16-rc1~132^2~125^2~6.
	* tests/netlink_nlctrl.c (test_nla_ops_family): Update expected output.
	* NEWS: Mention this change.

	xlat: update KVM_* constants.
	* src/xlat/kvm_cap.in (KVM_CAP_ARM_EL2, KVM_CAP_ARM_EL2_E2H0): New
	constants introduced by Linux kernel commit v6.16-rc1~78^2^2~9^2~4.
	(KVM_CAP_RISCV_MP_STATE_RESET): New constant introduced by Linux
	kernel commit v6.16-rc1~78^2~12.
	* NEWS: Mention this change.

	xlat: update SW_* constants.
	* src/xlat/evdev_switch.in (SW_MACHINE_COVER): New constant introduced
	by Linux kernel commit v5.8-rc6~36^2~6.
	(SW_USB_INSERT): New constant introduced by Linux kernel commit
	v6.16-rc1~28^2~157.
	* NEWS: Mention this change.

	xlat: update BR_* constants.
	* src/xlat/rtnl_ifla_br_boolopts.in
	(BR_BOOLOPT_MDB_OFFLOAD_FAIL_NOTIFICATION): New constant introduced by
	Linux kernel commit v6.16-rc1~132^2~317^2~.
	* src/xlat/rtnl_ifla_br_boolopt_flags.in
	(1<<BR_BOOLOPT_MDB_OFFLOAD_FAIL_NOTIFICATION): Likewise.
	* tests/nlattr_ifla_linkinfo.c (main): Update expected output.
	* NEWS: Mention this.

	xlat: update MDB_* constants.
	* src/xlat/mdb_flags.in (MDB_FLAGS_OFFLOAD_FAILED): New constant
	introduced by Linux kernel commit v6.16-rc1~132^2~317^2~2.
	* NEWS: Mention this change.

	xlat: update FUTEX2_* constants.
	* src/xlat/futex2_flags.in (FUTEX2_MPOL): New constant introduced
	by Linux kernel commit v6.16-rc1~199^2^2~15.
	* tests/futex2_flags.h (futex2_flags): Test it.
	* tests/futex_waitv.c (main): Update expected output.
	* NEWS: Mention this change.

2025-06-17  Jan Macku  <jamacku@redhat.com>

	ci: fix Differential ShellCheck failures.
	Add a branch on which to run the Action. This will fix issues like:
	
	`git: base SHA1 (0000000000000000000000000000000000000000) doesn't exist. Make sure that the base branch is up-to-date.`

2025-06-17  Dmitry V. Levin  <ldv@strace.io>

	net: implement decoding of SO_PASSRIGHTS socket option.
	* src/xlat/sock_options.in (SO_PASSRIGHTS): New constant introduced
	by Linux kernel commit v6.16-rc1~132^2~45^2~1.
	* src/net.c (print_getsockopt, print_setsockopt) <SO_PASSRIGHTS>:
	Print it.
	* tests/sockopt-sol_socket.c (main): Test it.
	* NEWS: Mention this change.

	net: implement decoding of SO_RCVPRIORITY socket option.
	* src/xlat/sock_options.in (SO_RCVPRIORITY): New constant introduced
	by Linux kernel commit v6.14-rc1~162^2~206^2.
	* src/net.c (print_getsockopt, print_setsockopt) <SO_RCVPRIORITY>:
	Print it.
	* tests/sockopt-sol_socket.c (main): Test it.
	* NEWS: Mention this change.

	xlat: update IORING_* constants.
	* bundled/linux/include/uapi/linux/io_uring.h: Update to
	headers_install'ed Linux kernel v6.16-rc2.
	* src/xlat/uring_ops.in (IORING_OP_PIPE): New constant introduced
	by Linux kernel commit v6.16-rc1~215^2~54.
	* tests/io_uring_register.c (main): Update expected output.
	* NEWS: Mention this change.

2025-06-17  Dmitry V. Levin  <ldv@strace.io>

	bundled: update linux UAPI headers to v6.16-rc2.
	The update of linux/io_uring.h is delayed because it contains an update
	of enum io_uring_op that has to be done along with the corresponding
	update of src/xlat/uring_ops.in and tests/io_uring_register.c files.

	* bundled/linux/include/uapi/linux/blktrace_api.h: Update to
	headers_install'ed Linux kernel v6.16-rc2.
	* bundled/linux/include/uapi/linux/devlink.h: Likewise.
	* bundled/linux/include/uapi/linux/dm-ioctl.h: Likewise.
	* bundled/linux/include/uapi/linux/ethtool.h: Likewise.
	* bundled/linux/include/uapi/linux/ethtool_netlink_generated.h: Likewise.
	* bundled/linux/include/uapi/linux/fs.h: Likewise.
	* bundled/linux/include/uapi/linux/fscrypt.h: Likewise.
	* bundled/linux/include/uapi/linux/futex.h: Likewise.
	* bundled/linux/include/uapi/linux/if_bridge.h: Likewise.
	* bundled/linux/include/uapi/linux/if_link.h: Likewise.
	* bundled/linux/include/uapi/linux/input-event-codes.h: Likewise.
	* bundled/linux/include/uapi/linux/netdev.h: Likewise.
	* bundled/linux/include/uapi/linux/netfilter/nf_tables.h: Likewise.
	* bundled/linux/include/uapi/linux/netfilter/nfnetlink.h: Likewise.
	* bundled/linux/include/uapi/linux/nl80211.h: Likewise.
	* bundled/linux/include/uapi/linux/perf_event.h: Likewise.
	* bundled/linux/include/uapi/linux/pkt_sched.h: Likewise.
	* bundled/linux/include/uapi/linux/prctl.h: Likewise.
	* bundled/linux/include/uapi/linux/stat.h: Likewise.
	* bundled/linux/include/uapi/linux/taskstats.h: Likewise.
	* bundled/linux/include/uapi/linux/tcp.h: Likewise.
	* bundled/linux/include/uapi/linux/version.h: Likewise.
	* bundled/linux/include/uapi/linux/videodev2.h: Likewise.
	* bundled/linux/include/uapi/rdma/ib_user_verbs.h: Likewise.

2025-05-27  Dmitry V. Levin  <ldv@strace.io>

	Post-release administrivia.
	* NEWS: Add a header line for the next release.
	* debian/changelog.in: Add a changelog entry for 6.15-1.
	* strace.spec.in: Likewise.

2025-05-26  Dmitry V. Levin  <ldv@strace.io>

	Prepare for 6.15 release.
	* NEWS: Update for 6.15 release.

2025-05-25  Dmitry V. Levin  <ldv@strace.io>

	Update copyright headers.
	Headers updated automatically using maint/update_copyright_years.sh
	script.

2025-05-24  Dmitry V. Levin  <ldv@strace.io>

	Update .mailmap.
	* .mailmap: Add enother email address of Sahil Siddiq to avoid
	duplication in CREDITS file.

2025-05-23  Sahil Siddiq  <sahilcdq0@gmail.com>

	tests: Add tests for AF_TIPC decoding.
	Add tests to verify decoding of AF_TIPC socket addresses and
	socket options.

	* tests/sol_tipc-group_join.c: New file.
	* tests/sol_tipc-group_join-Xabbrev.c: Likewise.
	* tests/sol_tipc-group_join-Xraw.c: Likewise.
	* tests/sol_tipc-group_join-Xverbose.c: Likewise.
	* tests/sol_tipc-group_join-success.c: Likewise.
	* tests/sol_tipc-group_join-success-Xabbrev.c: Likewise.
	* tests/sol_tipc-group_join-success-Xraw.c: Likewise.
	* tests/sol_tipc-group_join-success-Xverbose.c: Likewise.
	* tests/sol_tipc-importance.c: Likewise.
	* tests/sol_tipc-importance-Xabbrev: Likewise.
	* tests/sol_tipc-importance-Xraw: Likewise.
	* tests/sol_tipc-importance-Xverbose: Likewise.
	* tests/sol_tipc-importance-success: Likewise.
	* tests/sol_tipc-importance-success-Xabbrev: Likewise.
	* tests/sol_tipc-importance-success-Xraw: Likewise.
	* tests/sol_tipc-importance-success-Xverbose: Likewise.
	* tests/.gitignore: Add sol_tipc-* entries.
	* tests/Makefile.am (check_PROGRAMS): Likewise.
	* tests/gen_tests.in: Likewise.
	* tests/sockaddr_xlat.c: Include <linux/tipc.h>.
	(check_tipc): New function.
	(main): Invoke it.

2025-05-23  Sahil Siddiq  <sahilcdq0@gmail.com>

	net: Implement decoding of AF_TIPC socket options.
	* src/xlat/af_tipc_flags.in: New file.
	* src/xlat/af_tipc_importance.in: Likewise.
	* src/net.c: Include <linux/tipc.h> and "xlat/af_tipc_*" headers.
	(print_tipc_importance, print_tipc_group_join): New functions.
	(print_getsockopt, print_setsockopt): Use them to decode AF_TIPC
	socket options.
	* NEWS: Mention this change.

	sockaddr: Implement decoding of AF_TIPC socket addresses.
	* src/xlat/af_tipc_scope.in: New file.
	* src/xlat/af_tipc_types.in: Likewise.
	* src/sockaddr.c: Include <linux/tipc.h> and "xlat/af_tipc_*" headers.
	(print_sockaddr_data_tipc): New function.
	(sa_printers) <[AF_TIPC]>: New printer.

2025-05-22  Dmitry V. Levin  <ldv@strace.io>

	bundled: add uapi/linux/tipc.h.
	* bundled/linux/include/uapi/linux/tipc.h: New file, imported from
	headers_install'ed Linux kernel v6.15-rc7.
	* bundled/Makefile.am (EXTRA_DIST): Add linux/include/uapi/linux/tipc.h.

	bundled: update linux UAPI headers to v6.15-rc7.

2025-05-20  Gleb Fotengauer-Malinovskiy  <glebfm@altlinux.org>

	Update ioctl entries from linux v6.15.
	* src/linux/32/ioctls_inc_align16.h: Update from linux v6.15-rc7 using
	ioctls_gen.sh.
	* src/linux/32/ioctls_inc_align32.h: Likewise.
	* src/linux/32/ioctls_inc_align64.h: Likewise.
	* src/linux/64/ioctls_inc.h: Likewise.
	* src/linux/x32/ioctls_inc0.h: Likewise.
	* NEWS: Mention this.

2025-05-15  Dmitry V. Levin  <ldv@strace.io>

	tests: check decoding of open_tree_attr syscall.
	* tests/open_tree_attr.c: New file.
	* tests/open_tree_attr-P.c: Likewise.
	* tests/pure_executables.list: Add open_tree_attr and open_tree_attr-P.
	* tests/.gitignore: Likewise.
	* tests/gen_tests.in (open_tree_attr, open_tree_attr-P): New tests.

2025-05-14  Dmitry V. Levin  <ldv@strace.io>

	Implement decoding of open_tree_attr syscall.
	This new syscall was introduced by Linux kernel commit
	v6.15-rc1~252^2~4^2~2.

	* src/linux/generic/syscallent-common.h [BASE_NR + 467]: Wire up
	open_tree_attr.
	* src/mount_setattr.c (SYS_FUNC(open_tree_attr)): New function.
	* src/pathtrace.c (pathtrace_match_set): Handle SEN_open_tree_attr.
	* NEWS: Mention this change.

2025-05-13  Dmitry V. Levin  <ldv@strace.io>

	open_tree: move into mount_setattr.
	* src/mount_setattr.c: Include "kernel_fcntl.h" and
	"xlat/open_tree_flags.h".
	(SYS_FUNC(open_tree)): Move here from open_tree.c, rewrite using
	decode_dfd_file_flags helper.
	* src/open_tree.c: Remove.
	* src/Makefile.am (libstrace_a_SOURCES): Remove open_tree.c.

2025-05-12  Dmitry V. Levin  <ldv@strace.io>

	mount_setattr: factor out helper functions.
	* src/mount_setattr.c (decode_dfd_file_flags,
	decode_dfd_file_flags_attr): New helper functions.
	(+SYS_FUNC(mount_setattr)): Use decode_dfd_file_flags_attr.

2025-05-11  Dmitry V. Levin  <ldv@strace.io>

	xlat/open_tree_flags: remove unsupported constants.
	* src/xlat/open_tree_flags.in (AT_REMOVEDIR, AT_SYMLINK_FOLLOW): Remove
	constants that have never been supported by open_tree syscall.
	* tests/open_tree.c (main): Update expected output.

	Fixes: v5.2~45 "Implement decoding of open_tree syscall"

2025-05-08  Dmitry V. Levin  <ldv@strace.io>

	tests/group_req: fix compilation warnings.
	Workaround the following warnings generated in group_req.c test starting
	with glibc-2.40.9000-1022-ge3a6e85d67f1a48dec3e2557a83d6ce1544a58cb that
	introduced _FORTIFY_SOURCE support for inet_pton:

	  In function 'inet_pton',
	      inlined from 'main' at group_req.c:48:2:
	  /usr/include/bits/inet-fortified.h:56:10: warning: call to '__inet_pton_chk_warn' declared with attribute warning: inet_pton called with a destination buffer size too small [-Wattribute-warning]
	     56 |   return __glibc_fortify (inet_pton, sz, sizeof (char),

	  In function 'inet_pton',
	      inlined from 'main' at group_req.c:51:2:
	  /usr/include/bits/inet-fortified.h:56:10: warning: call to '__inet_pton_chk_warn' declared with attribute warning: inet_pton called with a destination buffer size too small [-Wattribute-warning]
	     56 |   return __glibc_fortify (inet_pton, sz, sizeof (char),

	* tests/group_req.c (main): Explicitly cast pointers of type
	"struct group_req.gr_group *" to pointers of types "struct sockaddr_in *"
	and "struct sockaddr_in6 *" using unions, to workaround _FORTIFY_SOURCE
	warnings for inet_pton.

2025-05-07  Dmitry V. Levin  <ldv@strace.io>

	Update decoding of statmount syscall further.
	* src/xlat/statmount_mask.in (STATMOUNT_OPT_ARRAY): New constant
	introduced by Linux kernel commit v6.13-rc1~229^2~2.
	(STATMOUNT_OPT_SEC_ARRAY): New constant introduced by Linux kernel
	commit v6.13-rc1~229^2.
	(STATMOUNT_SUPPORTED_MASK): New constant introduced by Linux kernel
	commit v6.15-rc1~252^2~4^2~5.
	(STATMOUNT_MNT_UIDMAP, STATMOUNT_MNT_GIDMAP): New constants introduced
	by Linux kernel commit v6.15-rc1~252^2~4.
	* src/statmount.c (print_quoted_cstring_sequence): New function.
	(PRINT_FIELD_CSTRING_SEQUENCE): New macro.
	(print_statmount): Print new members of struct statmount.
	* tests/statmount.c: Check it.

2025-05-06  Dmitry V. Levin  <ldv@strace.io>

	Update decoding of statmount syscall.
	* src/xlat/statmount_mask.in (STATMOUNT_FS_SUBTYPE): New constant
	introduced by Linux kernel commit v6.13-rc1~229^2~4^2~1.
	(STATMOUNT_SB_SOURCE): New constant introduced by Linux kernel commit
	v6.13-rc1~229^2~4^2.
	* src/statmount.c (print_statmount): Print new fs_subtype and sb_source
	members of struct statmount.
	* tests/statmount.c: Check it.
	* NEWS: Mention this change.

2025-05-05  Dmitry V. Levin  <ldv@strace.io>

	tests: extend test coverage of statmount syscall decoder.
	* tests/statmount.c: Extend test coverage.

2025-05-04  Dmitry V. Levin  <ldv@strace.io>

	xlat: update KVM_* constants.
	* src/xlat/kvm_cap.in (KVM_CAP_PRE_FAULT_MEMORY): New constant
	introduced by Linux kernel commit v6.11-rc1~89^2~21^2~5.
	(KVM_CAP_X86_APIC_BUS_CYCLES_NS, KVM_CAP_X86_GUEST_MODE):
	New constants introduced by Linux kernel commit v6.11-rc1~89^2~14.
	(KVM_CAP_ARM_WRITABLE_IMP_ID_REGS): New constant introduced
	by Linux kernel commit v6.15-rc1~195^2~2^2~2^2~4.
	* NEWS: Mention this change.

2025-05-03  Dmitry V. Levin  <ldv@strace.io>

	xlat: update IFLA_* constants.
	* src/xlat/rtnl_link_attrs.in (IFLA_DPLL_PIN): New constant introduced
	by Linux kernel commit v6.7-rc1~122^2~328^2~4.
	(IFLA_MAX_PACING_OFFLOAD_HORIZON): New constant introduced
	by Linux kernel commit v6.13-rc1~135^2~413^2~1.
	(IFLA_NETNS_IMMUTABLE): New constant introduced by Linux kernel
	commit v6.15-rc1~160^2~188^2~1.
	* src/rtnl_link.c (ifinfomsg_nla_decoders): Add
	IFLA_MAX_PACING_OFFLOAD_HORIZON and IFLA_NETNS_IMMUTABLE.
	* NEWS: Mention this change.

2025-05-02  Dmitry V. Levin  <ldv@strace.io>

	xlat: update FRA_* constants.
	* src/xlat/rtnl_rule_attrs.in (FRA_SPORT_MASK, FRA_DPORT_MASK):
	New constants introduced by Linux kernel commit v6.15-rc1~160^2~276^2~7.
	(FRA_DSCP_MASK): New constant introduced by Linux kernel commit
	v6.15-rc1~160^2~248^2~5.
	* src/rtnl_rule.c (fib_rule_hdr_nla_decoders): Add them.
	* NEWS: Mention this change.

2025-05-01  Dmitry V. Levin  <ldv@strace.io>

	xlat: update FAN_* constants.
	* src/xlat/fan_event_flags.in (FAN_MNT_ATTACH, FAN_MNT_DETACH):
	New constant introduced by Linux kernel commit v6.15-rc1~252^2~8^2~1.
	* src/xlat/fan_init_flags.in (FAN_REPORT_MNT): Likewise.
	* src/xlat/fan_mark_flags.in (FAN_MARK_MNTNS): Likewise.
	* tests/fanotify_init.c (main): Update expected output.
	* tests/fanotify_mark.c: Likewise.
	* NEWS: Mention this change.

2025-04-30  Dmitry V. Levin  <ldv@strace.io>

	xlat: update BPF_* constants.
	* src/xlat/bpf_attach_flags.in (BPF_F_PREORDER): New constant introduced
	by Linux kernel commit v6.15-rc1~98^2~38.
	* src/xlat/ebpf_mode.in (BPF_XADD): Rename to BPF_ATOMIC following the
	change introduced by Linux kernel commit v5.12-rc1~200^2~324^2~1^2~7.
	* tests/bpf.c: Update expected output.
	* NEWS: Mention this change.

2025-04-29  Dmitry V. Levin  <ldv@strace.io>

	xlat: update AUDIT_* constants.
	* xlat/nl_audit_types.in (AUDIT_LANDLOCK_ACCESS): New constant
	introduced by Linux kernel commit v6.15-rc1~127^2~19.
	(AUDIT_LANDLOCK_DOMAIN): New constant introduced by Linux kernel
	commit v6.15-rc1~127^2~18.
	* NEWS: Mention this change.

2025-04-28  Dmitry V. Levin  <ldv@strace.io>

	xlat: update PKEY_* constants.
	* src/xlat/pkey_access.in (PKEY_UNRESTRICTED): New constant introduced
	by Linux kernel commit v6.15-rc1~35^2~7^3~3.
	* tests/pkey_alloc.c (main): Update expected output.
	* NEWS: Mention this change.

2025-04-27  Dmitry V. Levin  <ldv@strace.io>

	xlat: update V4L2_* constants.
	* src/xlat/v4l2_control_flags.in (V4L2_CTRL_FLAG_HAS_WHICH_MIN_MAX):
	New constant introduced by Linux kernel commit v6.15-rc1~174^2~94.
	* src/xlat/v4l2_control_id_bases.in (V4L2_CID_USER_UVC_BASE):
	New constant introduced by Linux kernel commit v6.15-rc1~174^2~80.
	* src/xlat/v4l2_control_types.in (V4L2_CTRL_TYPE_RECT):
	New constant introduced by Linux kernel commit v6.15-rc1~174^2~95.
	* tests/ioctl_v4l2-success.c (main): Update expected output.
	* NEWS: Mention this change.

2025-04-26  Dmitry V. Levin  <ldv@strace.io>

	xlat: update TCP_* constants.
	* src/xlat/sock_tcp_options.in (TCP_RTO_MAX_MS): New constant introduced
	by Linux kernel commit v6.15-rc1~160^2~352^2~1.
	(TCP_RTO_MIN_US): New constant introduced by Linux kernel commit
	v6.15-rc1~160^2~36^2~1.
	(TCP_DELACK_MAX_US): New constant introduced by Linux kernel commit
	v6.15-rc1~160^2~36^2.
	* NEWS: Mention this change.

2025-04-25  Dmitry V. Levin  <ldv@strace.io>

	xlat: update RTPROT_* constants.
	* src/xlat/routing_protocols.in (RTPROT_OVN): New constant introduced
	by Linux kernel commit v6.15-rc1~160^2~225.
	* NEWS: Mention this change.

2025-04-24  Dmitry V. Levin  <ldv@strace.io>

	xlat: update LANDLOCK_* constants.
	* src/xlat/landlock_create_ruleset_flags.in
	(LANDLOCK_CREATE_RULESET_ERRATA): New constant introduced by Linux
	kernel commit v6.15-rc1~127^2~33.
	* src/landlock.c (SYS_FUNC(landlock_create_ruleset): Update.
	* tests/landlock_create_ruleset.c (main): Check it.
	* NEWS: Mention this change.

2025-04-23  Dmitry V. Levin  <ldv@strace.io>

	xlat: update COUNTER_* constants.
	* src/xlat/counter_ioctl_event_types.in (COUNTER_EVENT_DIRECTION_CHANGE):
	New constant introduced by Linux kernel commit v6.15-rc1~78^2~9^2~6.
	* tests/ioctl_counter.c (main): Update expected output.
	* NEWS: Mention this change.

2025-04-22  Dmitry V. Levin  <ldv@strace.io>

	xlat: update BTRFS_* constants.
	* src/xlat/btrfs_defrag_flags.in (BTRFS_DEFRAG_RANGE_COMPRESS_LEVEL):
	New constant introduced by Linux kernel commit v6.15-rc1~152^2~36.
	* NEWS: Mention this.

2025-04-21  Dmitry V. Levin  <ldv@strace.io>

	xlat: update IORING_* constants.
	* bundled/linux/include/uapi/linux/io_uring.h: Update to
	headers_install'ed Linux kernel v6.15-rc3.
	* src/xlat/uring_enter_flags.in (IORING_ENTER_NO_IOWAIT): New constant
	introduced by Linux kernel commit v6.15-rc1~167^2~9.
	* src/xlat/uring_setup_features.in (IORING_FEAT_NO_IOWAIT): Likewise.
	* src/xlat/uring_ops.in (IORING_OP_RECV_ZC): New constant introduced
	by Linux kernel commit v6.15-rc1~124^2~11.
	(IORING_OP_EPOLL_WAIT): New constant introduced by Linux kernel commit
	v6.15-rc1~123^2.
	(IORING_OP_READV_FIXED, IORING_OP_WRITEV_FIXED): New constants
	introduced by Linux kernel commit v6.15-rc1~122^2~22.
	* src/xlat/uring_register_opcodes.in (IORING_REGISTER_ZCRX_IFQ):
	New constant introduced by Linux kernel commit v6.15-rc1~124^2~16.
	* tests/io_uring_enter.c (main): Update expected output.
	* tests/io_uring_register.c (main): Likewise.
	* NEWS: Mention this change.

2025-04-20  Dmitry V. Levin  <ldv@strace.io>

	bundled: update linux UAPI headers to v6.15-rc3.
	The update of linux/io_uring.h is delayed because it contains an update
	of enum io_uring_op that has to be done along with the corresponding
	update of src/xlat/uring_ops.in and tests/io_uring_register.c files.

	* bundled/linux/include/uapi/linux/btrfs.h: Update to
	headers_install'ed Linux kernel v6.15-rc3.
	* bundled/linux/include/uapi/linux/const.h: Likewise.
	* bundled/linux/include/uapi/linux/counter.h: Likewise.
	* bundled/linux/include/uapi/linux/ethtool.h: Likewise.
	* bundled/linux/include/uapi/linux/fib_rules.h: Likewise.
	* bundled/linux/include/uapi/linux/fs.h: Likewise.
	* bundled/linux/include/uapi/linux/if_link.h: Likewise.
	* bundled/linux/include/uapi/linux/if_xdp.h: Likewise.
	* bundled/linux/include/uapi/linux/landlock.h: Likewise.
	* bundled/linux/include/uapi/linux/mount.h: Likewise.
	* bundled/linux/include/uapi/linux/netdev.h: Likewise.
	* bundled/linux/include/uapi/linux/nl80211.h: Likewise.
	* bundled/linux/include/uapi/linux/perf_event.h: Likewise.
	* bundled/linux/include/uapi/linux/prctl.h: Likewise.
	* bundled/linux/include/uapi/linux/rtnetlink.h: Likewise.
	* bundled/linux/include/uapi/linux/stddef.h: Likewise.
	* bundled/linux/include/uapi/linux/taskstats.h: Likewise.
	* bundled/linux/include/uapi/linux/tcp.h: Likewise.
	* bundled/linux/include/uapi/linux/thermal.h: Likewise.
	* bundled/linux/include/uapi/linux/v4l2-controls.h: Likewise.
	* bundled/linux/include/uapi/linux/version.h: Likewise.
	* bundled/linux/include/uapi/linux/videodev2.h: Likewise.
	* bundled/linux/include/uapi/linux/xattr.h: Likewise.

2025-03-26  Dmitry V. Levin  <ldv@strace.io>

	Post-release administrivia.
	* NEWS: Add a header line for the next release.
	* debian/changelog.in: Add a changelog entry for 6.14-1.
	* strace.spec.in: Likewise.

2025-03-25  Dmitry V. Levin  <ldv@strace.io>

	Prepare for 6.14 release.
	* NEWS: Update for 6.14 release.

	Update copyright headers.
	Headers updated automatically using maint/update_copyright_years.sh
	script.

2025-03-25  Dmitry V. Levin  <ldv@strace.io>

	Fix preprocessor indentation.
	Indent the C preprocessor directives to reflect their nesting
	using the following script:

	$ cppi -l $(git grep -El '^[[:space:]]*#[[:space:]]*(if|ifdef|ifndef|elif|else|endif|define|pragma)[[:space:]]' src tests |grep -Ev '\.(sh|test)$') |while read f; do
		cppi < "$f" > "$f".cppi; mv "$f".cppi "$f"
	done

2025-03-24  Masatake YAMATO  <yamato@redhat.com>

	tests: verify the auxstr of clone3(2) with -e namespace=new option.
	* tests/gen_tests.in (clone3-report-ns-id): New test.
	* tests/pure_executables.list: Add clone3-report-ns-id.
	* tests/clone3-report-ns-id.c: New file.
	* tests/.gitignore: Add clone3-report-ns-id.

	Changes in v3 (Suggested by Dmitry V. Levin <ldv@strace.io>):
	* Don't wait for the child process exiting in the parent process.

	Changes in v4 (Suggested by Dmitry V. Levin <ldv@strace.io>):
	* Fix the comment,
	* Fix the type of variable receiving the result of readlink(),
	* Don't include sys/syscall.h,
	* Skip the test case if clone3(2) is not available,
	* Skip the test case if /proc/self/ns/user is not available,
	* Add the file name to the error message reported when readlink(2)
	  fails,
	* Unify the function calls printing the expected output.

	Changes in v5 (Suggested by Dmitry V. Levin <ldv@strace.io>):
	* Add a missing period in comment,
	* Update Copyright years,
	* Skip the test case if clone3(2) fails.

2025-03-24  Masatake YAMATO  <yamato@redhat.com>

	tests: verify the auxstr of clone(2) with -e namespace=new option.
	Instead of adding a new test program, I extended tests/clone-flags.c
	for the testing the auxstr.

	* tests/clone-flags.c: (retrieve_userns): New function.
	(wait_cloned) <userns_buf, userns_buflen>: New parameters for
	returning the id of the user namespace.
	(do_clone_newns): New macro.
	(main): Call do_clone_newns for making a process in a new namespace.
	* tests/clone-flags.test (run_strace_match_diff): Append
	-e namespace=new to the command line.

	Changes in v3 (Suggested by Dmitry V. Levin <ldv@strace.io>):
	* Don't wait for the child process exiting in the parent process.

	Changes in v4 (Suggested by Dmitry V. Levin <ldv@strace.io>):
	* Fix the type of variable receiving the result of readlink(),
	* Reuse a local variable (buf),
	* Don't skip running the test case even if creating an user
	  namespace,
	* Don't make the test "failed" even if readlink() fails.
	* Add missing free(3) call.

	Changes in v5 (Suggested by Dmitry V. Levin <ldv@strace.io>):
	* Remove the duplicate lines mistakenly introduced in the last change,
	* Use tabs for indenting the lines.

2025-03-24  Masatake YAMATO  <yamato@redhat.com>

	tests: verify the auxstr of setns(2) when --namespace=new is given.
	* tests/gen_tests.in (setns-report-ns-id): New test.
	* tests/pure_executables.list: Add setns-report-ns-id.
	* tests/setns-report-ns-id.c: New file.
	* tests/.gitignore: Add setns-report-ns-id.

	Changes in v2 (Suggested by Dmitry V. Levin <ldv@strace.io>):
	* Call unshare in the parent process instead of the child process.

	Changes in v3 (Suggested by Dmitry V. Levin <ldv@strace.io>):
	* Don't do fork.

	Changes in v4 (Suggested by Dmitry V. Levin <ldv@strace.io>):
	* Fix the type of variable receiving the result of readlink(),
	* Call skip_if_unavailable() with pre-defined string literal,
	* Make the test case failure if readlink() reports error,
	* Use puts() instead of printf().

	Changes in v5 (Suggested by Dmitry V. Levin <ldv@strace.io>):
	* Add a missing period in comment,
	* Update Copyright years.

2025-03-24  Masatake YAMATO  <yamato@redhat.com>

	tests: verify the auxstr of unshare(2) with -e namespace=new option.
	* tests/gen_tests.in (unshare-report-ns-id): New test.
	* tests/pure_executables.list: Add unshare-report-ns-id.
	* tests/unshare-report-ns-id.c: New file just including unshare.c.
	* tests/unshare.c (main): Extend `unshare_flags' array for testing
	'-e namespace=new' option.
	(main::PRINT_NAMESPACE): print the namespace as a part of auxstr
	after changing the current directory to /proc/self/ns.
	* tests/.gitignore: Add unshare-report-ns-id.

	Changes in v3 (Suggested by Dmitry V. Levin <ldv@strace.io>):
	* Implement unshare-report-ns-id.c by including unshare.c.

	Changes in v4 (Suggested by Dmitry V. Levin <ldv@strace.io>):
	* Fix the style of conditional expressions,
	* Fix the type of variable receiving the result of readlink(),
	* Include the file name to the error messages reported when
	  readlink() fails.

2025-03-24  Masatake YAMATO  <yamato@redhat.com>

	tests: verify the argument passed to "-e namespace=..."
	* tests/options-syntax.test: Check error diagnostics when
	-e namespace=/--namespace= is specified with an invalid option
	argument.

2025-03-24  Masatake YAMATO  <yamato@redhat.com>

	auxstr: show namespaces when -e namespace=new is given.
	    $ src/strace -qq -e signal=none -e unshare -e namespace=new unshare --user --net /bin/true
	    unshare(CLONE_NEWUSER|CLONE_NEWNET)     = 0 (net:[4026537408], user:[4026537407])
	    $ src/strace -qq -f -e signal=none -e unshare,clone -e namespace=new \
	      		 podman run --rm -ti registry.access.redhat.com/ubi7/ubi:latest /bin/true
	    [pid 1089104] clone(child_stack=NULL, flags=CLONE_NEWNS|CLONE_NEWUSER|SIGCHLD) = 1089110 (mnt:[4026531841], user:[4026531837])
	    [pid 1089104] clone(child_stack=NULL, flags=CLONE_VM|CLONE_VFORK|SIGCHLD) = 1089111
	    ERRO[0000] running `/usr/bin/newuidmap 1089110 0 1000 1 1 100000 65536`: newuidmap: write to uid_map failed: Operation not permitted
	    Error: cannot set up namespace using "/usr/bin/newuidmap": exit status 1

	* src/clone.c: Include "xstring.h" and <unistd.h>.
	(show_namespace): New variable.
	(namespace_auxstr_init, read_namespace_id, get_namespace_auxstr): New
	functions.
	(SYS_FUNC(clone)): Don't add RVAL_DECODED to the return
	value if the clone makes new namespaces (entering).
	Set the value returned from get_namespace_auxstr() to the auxstr
	member of tcp if the clone makes new namespaces, and add RVAL_STR to
	the return value (leaving).
	(SYS_FUNC(clone3), SYS_FUNC(setns), SYS_FUNC(unshare)): Likewise.
	* src/defs.h (qualify_namespace, namespace_auxstr_init): New
	declaration.
	* src/filter_qualify.c (qualify_namespace): New function.
	(qual_options): Add "namespace".
	* src/strace.c (usage): Describe -e namespace=new option.
	(init) <namespace_qual>: New constant.
	(init) <GETOPT_QUAL_NAMESPACE>: New enumerator.
	(init) <longopts>: Add "namespace".
	(init): Call qualify_namespace when --namespace is specified.
	* doc/strace1.n (-e namespace=new): Document the option.

	Changes in v2 (Suggested by Dmitry V. Levin <ldv@strace.io>):
	* Consider CLONE_INTO_CGROUP flag, and
	* Use an array instead of a sequence of if-statements in
	  get_namespace_auxstr(),
	* Remove unnecessary cast operations,
	* Translate pids with translate_pid() before passing them
	  to get_namespace_auxstr.

	Changes in v4 (Suggested by Dmitry V. Levin <ldv@strace.io>):
	* Use syserror() instead of comparing tcp->u_rval with 0,
	* Fix the style of conditional expressions.

	Changes in v5 (Suggested by Dmitry V. Levin <ldv@strace.io>):
	* Move the NEWS entry,
	* Update the formatting of the man page,
	* Don't cast tcp->u_rval to int when calling get_namespace_auxstr.

2025-03-24  Masatake YAMATO  <yamato@redhat.com>

	tests: (clone-flags) revise the way to handle the result of readlink.
	* tests/clone-flags.c (main): Use ssize_t instead of int for
	receiving a result of readlink(2).
	Add the file name to the error message reported when readlink(2)
	fails.

	Suggested by Dmitry V. Levin <ldv@strace.io> in a review
	comment of github#332.

2025-03-19  Gleb Fotengauer-Malinovskiy  <glebfm@altlinux.org>

	Update ioctl entries from linux v6.14.
	* src/linux/32/ioctls_inc_align16.h: Update from linux v6.14-rc7 using
	ioctls_gen.sh.
	* src/linux/32/ioctls_inc_align32.h: Likewise.
	* src/linux/32/ioctls_inc_align64.h: Likewise.
	* src/linux/64/ioctls_inc.h: Likewise.
	* src/linux/x32/ioctls_inc0.h: Likewise.
	* src/linux/s390/ioctls_arch0.h: Likewise.
	* src/linux/s390x/ioctls_arch0.h: Likewise.
	* NEWS: Mention this.

2025-03-15  Dmitry V. Levin  <ldv@strace.io>

	README.md: add repology badge.
	Show downstream usage for various versions of strace instead of listing
	a few binary repositories manually.

2025-03-14  Dmitry V. Levin  <ldv@strace.io>

	README.md: update references to github CI.
	Link: https://github.com/github/docs/commit/f9b50ac4387b46f8a3ca80ede226fb15384ff7f3

2025-03-09  Dmitry V. Levin  <ldv@strace.io>

	.github: remove x32 jobs.
	As ubuntu-20.04 images are being deprecated and later images do not
	support x32, remove x32 jobs.

	* .github/workflows/ci.yml (*-x32-*): Remove.

2025-03-09  Dmitry V. Levin  <ldv@strace.io>

	.github: switch remaining x86_64 and x86 builder jobs away from ubuntu-20.04
	As ubuntu-20.04 images are being deprecated, switch the remaining x86_64
	and x86 builder jobs from ubuntu-20.04 to ubuntu-22.04.

	* .github/workflows/ci.yml (gcc10-x86_64-kheaders, gcc10-x86_64-dw,
	gcc10-x86_64-unwind, gcc9-x86_64-kheaders, gcc9-x86_64-dw,
	gcc9-x86_64-unwind, gcc10-x86-kheaders, gcc10-x86-nostacktrace,
	gcc9-x86-kheaders, gcc9-x86-nostacktrace, musl-x86_64-nostacktrace):
	Replace ubuntu-20.04 with ubuntu-22.04.

	Link: https://github.blog/changelog/2025-01-15-github-actions-ubuntu-20-runner-image-brownout-dates-and-other-breaking-changes/

2025-03-08  Dmitry V. Levin  <ldv@strace.io>

	test_ptrace_seize: simplify PTRACE_SEIZE availability check.
	As PTRACE_SEIZE return code semantics has always been well-defined,
	there is no need to fork a process to find out whether PTRACE_SEIZE
	is supported.

	Before Linux kernel commit v3.1-rc1~308^2~28, PTRACE_SEIZE was
	an unrecognized operation and therefore used to fail with ESRCH.

	Starting with v3.1-rc1~308^2~28 and up to v3.4-rc1~109^2~20,
	PTRACE_SEIZE used to require PTRACE_SEIZE_DEVEL flag.
	Without that flag, PTRACE_SEIZE used to fail with EIO.

	Since v3.4-rc1~109^2~20, PTRACE_SEIZE of oneself fails with EPERM.

	Like any ptrace operation, PTRACE_SEIZE could also be filtered out
	by a syscall filter, but that is beyond the scope of this check.

2025-02-27  Dmitry V. Levin  <ldv@strace.io>

	tests/clone3.c: do not use XLAT_KNOWN(SIGCHLD, "SIGCHLD")
	* tests/clone3.c (main): Print XLAT_ARGS(SIGCHLD) using XLAT_FMT_U
	format instead.

2025-02-26  Dmitry V. Levin  <ldv@strace.io>

	tests: check decoding of PTRACE_SET_SYSCALL_INFO.
	* tests/tests.h (XLAT_FMT_JD): New macro.
	* tests/ptrace_set_syscall_info.c: New file.
	* tests/ptrace_set_syscall_info-Xabbrev.c: Likewise.
	* tests/ptrace_set_syscall_info-Xraw.c: Likewise.
	* tests/ptrace_set_syscall_info-Xverbose.c: Likewise.
	* tests/pure_executables.list: Add ptrace_set_syscall_info,
	ptrace_set_syscall_info-Xabbrev, ptrace_set_syscall_info-Xraw,
	and ptrace_set_syscall_info-Xverbose.
	* tests/.gitignore: Likewise.
	* tests/gen_tests.in (ptrace_set_syscall_info,
	ptrace_set_syscall_info-Xabbrev, ptrace_set_syscall_info-Xraw,
	ptrace_set_syscall_info-Xverbose): New tests.

	Fix PRINT_FIELD_SYSCALL_NAME for invalid syscall numbers.
	* src/syscall_name.c (syscall_name_arch): Change the type of syscall
	number from "kernel_ulong_t" to "unsigned long long", handle the case
	when these types differ in size.
	* src/print_fields.h (PRINT_FIELD_SYSCALL_NAME): Zero-extend the syscall
	number field before passing it on to syscall_name_arch.

2025-02-25  Dmitry V. Levin  <ldv@strace.io>

	tests/cur_audit_arch.h: introduce *_AUDIT_ARCH_STR.
	* tests/cur_audit_arch.h (CUR_AUDIT_ARCH_STR, PERS0_AUDIT_ARCH_STR,
	M32_AUDIT_ARCH_STR, MX32_AUDIT_ARCH_STR): New macros.
	* tests/ioctl_seccomp.c: Enable XLAT_MACROS_ONLY for "xlat/audit_arch.h".
	(main): Use *_AUDIT_ARCH_STR macros instead of sprintxval(audit_arch).
	* tests/ptrace.c: Likewise.

2025-02-15  Dmitry V. Levin  <ldv@strace.io>

	ptrace: implement PTRACE_SET_SYSCALL_INFO decoder.
	* src/ptrace_syscall_info.h (print_ptrace_syscall_info): Add kernel_len
	argument.
	* src/ptrace_syscall_info.c (print_ptrace_syscall_info): Likewise.
	Print "reserved" and "flags" fields when they are non-zero.
	* src/ptrace.c (decode_ptrace_exiting): Likewise.
	(decode_ptrace_entering): Handle PTRACE_SET_SYSCALL_INFO.

2025-02-14  Dmitry V. Levin  <ldv@strace.io>

	ptrace: update definitions for upcoming PTRACE_SET_SYSCALL_INFO API.
	* ptrace.h: [!PTRACE_SET_SYSCALL_INFO] (PTRACE_SET_SYSCALL_INFO): New
	macro.
	(struct ptrace_syscall_info): Split "pad" into "reserved" and "flags",
	add "reserved2" to "seccomp".
	* src/xlat/ptrace_cmds.in (PTRACE_SET_SYSCALL_INFO): New constant.

2025-02-14  Dmitry V. Levin  <ldv@strace.io>

	ptrace: use local definition of ptrace_syscall_info structure.
	This opens the way to support ptrace features ahead of the mainline
	linux kernel.

	* configure.ac (AC_CHECK_TYPES): Remove struct __ptrace_syscall_info
	and struct ptrace_syscall_info.
	* src/ptrace.h [HAVE_STRUCT_PTRACE_SYSCALL_INFO ||
	HAVE_STRUCT___PTRACE_SYSCALL_INFO]: Remove.
	(struct ptrace_syscall_info): Rename to struct strace_ptrace_syscall_info
	to avoid potential conflict with definitions from <sys/ptrace.h> and
	<linux/ptrace.h>.

2025-02-13  Dmitry V. Levin  <ldv@strace.io>

	Update decoding of statx syscall.
	* src/xlat/statx_masks.in (STATX_DIO_READ_ALIGN): New constant
	introduced by Linux kernel commit v6.14-rc1~210^2^2~3.
	* src/statx.h (struct_statx): Add stx_dio_read_offset_align,
	update reserved space.
	* src/statx.c (SYS_FUNC(statx)): Print stx_dio_read_offset_align member
	of struct statx when STATX_DIO_READ_ALIGN bit is set.
	* tests/xstatx.c (print_stat, main): Check it.
	* NEWS: Mention this change.

2025-02-12  Dmitry V. Levin  <ldv@strace.io>

	xlat: update SECBIT_* constants.
	* src/xlat/secbits.in (SECBIT_EXEC_RESTRICT_FILE,
	SECBIT_EXEC_RESTRICT_FILE_LOCKED, SECBIT_EXEC_DENY_INTERACTIVE,
	SECBIT_EXEC_DENY_INTERACTIVE_LOCKED): New constants introduced
	by Linux kernel commit v6.14-rc1~11^2~7.
	* tests/prctl-securebits.c (main): Update.
	* NEWS: Mention this change.

2025-02-11  Dmitry V. Levin  <ldv@strace.io>

	netlink_route: decode RTM_{NEW,DEL}MULTICAST and RTM_{NEW,DEL}ANYCAST messages
	* src/xlat/nl_route_types.in (RTM_NEWMULTICAST, RTM_DELMULTICAST):
	New constants introduced by Linux kernel commit v6.14-rc1~162^2~224.
	(RTM_NEWANYCAST, RTM_DELANYCAST): New constants introduced
	by Linux kernel commit v6.14-rc1~162^2~115.
	* src/netlink_route.c (route_decoders): Add them.
	* tests/netlink_route.c (test_rtnl_addr): Check them.
	* NEWS: Mention this change.

2025-02-10  Dmitry V. Levin  <ldv@strace.io>

	xlat: update NL80211_* constants.
	* src/xlat/genl_nl80211_cmd.in (NL80211_CMD_ASSOC_MLO_RECONF):
	New constant introduced by Linux kernel commit v6.14-rc1~162^2~20^2~22.
	(NL80211_CMD_EPCS_CFG): New constant introduced by Linux kernel commit
	v6.14-rc1~162^2~20^2~18.
	* tests/netlink_nlctrl.c (test_nla_ops_family): Update.
	* NEWS: Mention this change.

2025-02-09  Dmitry V. Levin  <ldv@strace.io>

	tests/gen_tests.sh: use run_strace_match_diff for syscall tampering -y.
	As strace -y nees /proc filesystem, all tests that use strace -y have to
	be skipped if /proc is unavailable.  This is usually done by the tests
	themselves returning 77 if /proc is unavailable.  However, in the
	generated tests that use both -y and syscall tampering the return code
	was ignored.

	* tests/gen_tests.sh: Generate run_strace_match_diff invocations
	for the tests that use both -y and syscall tampering.

2025-02-09  Dmitry V. Levin  <ldv@strace.io>

	tests/old_mmap-y: skip if /proc is unavailable.
	* tests/old_mmap.c (main) [PATH_TRACING]: Skip if /proc is unavailable.

	tests/ptrace-y: skip if /proc is unavailable.
	* tests/ptrace-y.c (SKIP_IF_PROC_IS_UNAVAILABLE): New macro.
	* tests/ptrace.c [!SKIP_IF_PROC_IS_UNAVAILABLE]
	(SKIP_IF_PROC_IS_UNAVAILABLE): Likewise.
	(main): Use it.

	tests/landlock_restrict_self-y: skip if /proc is unavailable.
	* tests/landlock_restrict_self-y.c (SKIP_IF_PROC_IS_UNAVAILABLE):
	New macro.

	tests/landlock_add_rule-y: skip if /proc is unavailable.
	* tests/landlock_add_rule-y.c (SKIP_IF_PROC_IS_UNAVAILABLE): New macro.

	tests/ioctl_seccomp-y: skip if /proc is unavailable.
	* tests/ioctl_seccomp-y.c (SKIP_IF_PROC_IS_UNAVAILABLE): New macro.
	* tests/ioctl_seccomp.c [!SKIP_IF_PROC_IS_UNAVAILABLE]
	(SKIP_IF_PROC_IS_UNAVAILABLE): Likewise.
	(main): Use it.

	tests/dup2-e-fd-0-P: skip if /proc is unavailable.
	* tests/dup2-e-fd-0-P.c: Include "dup-P.c" instead of "dup.c".
	(PATH_TRACING): Remove.

	tests/dup-trace-fds-0-P: skip if /proc is unavailable.
	* tests/dup-trace-fds-0-P.c: Include "dup-P.c" instead of "dup.c".
	(PATH_TRACING): Remove.

2025-02-08  Dmitry V. Levin  <ldv@strace.io>

	Make sure ptrace_sci.op is properly initialized before startup_tcb()
	Otherwise ptrace_sci.op could be set to 0, suppressing
	PTRACE_GET_SYSCALL_INFO invocation from startup_tcb().

	Currently, it makes no practical difference, but in the future
	PTRACE_GET_SYSCALL_INFO may return more useful information also
	for tracees in PTRACE_EVENT_STOP state.

	* src/strace.c (next_event): Invoke clear_regs() before startup_tcb().

2025-02-07  Dmitry V. Levin  <ldv@strace.io>

	strace.1: update "-b execve" description.
	* doc/strace.1.in: Note that "-b execve" includes both execve
	and execveat syscalls.

2025-02-06  Dmitry V. Levin  <ldv@strace.io>

	xlat: update IORING_FEAT_* constants.
	* src/xlat/uring_setup_features.in (IORING_FEAT_RW_ATTR): New constant
	introduced by Linux kernel commit v6.14-rc1~201^2~5.
	* NEWS: Mention this change.

	xlat: update KEY_* constants.
	* src/xlat/evdev_keycode.in (KEY_LINK_PHONE): New constant
	introduced by Linux kernel commit v6.14-rc1~117^2~33.
	* NEWS: Mention this change.

	xlat: update IPPROTO_* constants.
	* src/xlat/inet_protocols.in (IPPROTO_AGGFRAG): New constant introduced
	by Linux kernel commit v6.14-rc1~162^2~102^2~2^2~13.
	* tests/nlattr_inet_diag_req_v2.c (test_inet_diag_proto): Check it.
	* NEWS: Mention this change.

2025-02-05  Dmitry V. Levin  <ldv@strace.io>

	xlat: update RWF_* constants.
	* src/xlat/rwf_flags.in (RWF_DONTCACHE): New constant introduced
	by Linux kernel commit v6.14-rc1~216^2~6^2.
	* NEWS: Mention this change.

	Implement decoding of FRA_FLOWLABEL and FRA_FLOWLABEL_MASK netlink attributes
	* src/xlat/rtnl_rule_attrs.in (FRA_FLOWLABEL, FRA_FLOWLABEL_MASK):
	New constants introduced by Linux kernel commit v6.14-rc1~162^2~186^2~8.
	* src/rtnl_rule.c (fib_rule_hdr_nla_decoders): Add them.
	* NEWS: Mention this change.
	* src/nlattr.h (decode_nla_be32): New declaration, using DECL_NLA macro.
	* src/nlattr.c (decode_nla_be32): New function.
	* tests/nlattr_fib_rule_hdr.c: Include <arpa/inet.h>.
	(main): Check decoding of FRA_FLOWLABEL and FRA_FLOWLABEL_MASK.

2025-02-04  Dmitry V. Levin  <ldv@strace.io>

	xlat: update AT_* constants.
	* src/xlat/execveat_flags.in: New file.
	* src/execve.c: Include <linux/fcntl.h> and "xlat/execveat_flags.h".
	(SYS_FUNC(execveat)): Use execveat_flags for flags decoding.
	* tests/execveat.c: Check AT_EXECVE_CHECK decoding.
	* NEWS: Mention this change.

	tests/execveat: introduce execveat wrapper.
	* tests/execveat.c (k_execveat): New function.
	(tests_with_existing_file, main): Use it.

2025-02-04  Dmitry V. Levin  <ldv@strace.io>

	tests: assume __NR_execveat is always defined.
	It could be safely assumed that "scno.h" provides a definition.

	* tests/execveat.c [!__NR_execveat]: Remove.

2025-02-03  Dmitry V. Levin  <ldv@strace.io>

	xlat: update FAN_* constants.
	* src/xlat/fan_event_flags.in (FAN_PRE_ACCESS): New constant
	introduced by Linux kernel commit v6.14-rc1~129^2~11.
	* tests/fanotify_mark.c (main): Update expected output.
	* NEWS: Mention this change.

	xlat: update ETHTOOL_MSG_* constants.
	* src/xlat/genl_ethtool_msg_recv.in (ETHTOOL_MSG_TSCONFIG_GET_REPLY,
	ETHTOOL_MSG_TSCONFIG_SET_REPLY): New constants introduced by Linux
	kernel commit v6.14-rc1~162^2~211^2.
	* src/xlat/genl_ethtool_msg_send.in (ETHTOOL_MSG_TSCONFIG_GET,
	ETHTOOL_MSG_TSCONFIG_SET): Likewise.
	* tests/netlink_nlctrl.c (test_nla_ops_family): Check it.
	* NEWS: Mention this change.

	xlat: update AUDIT_* constants.
	* xlat/nl_audit_types.in (AUDIT_INTEGRITY_USERSPACE): New constant
	introduced by Linux kernel commit v6.14-rc1~11^2~1.
	* NEWS: Mention this change.

	bundled: update linux UAPI headers to v6.14-rc1.
	* bundled/linux/include/uapi/asm-generic/fcntl.h: Update to
	headers_install'ed Linux kernel v6.14-rc1.
	* bundled/linux/include/uapi/linux/dm-ioctl.h: Likewise.
	* bundled/linux/include/uapi/linux/ethtool.h: Likewise.
	* bundled/linux/include/uapi/linux/ethtool_netlink.h: Likewise.
	* bundled/linux/include/uapi/linux/fcntl.h: Likewise.
	* bundled/linux/include/uapi/linux/fib_rules.h: Likewise.
	* bundled/linux/include/uapi/linux/fiemap.h: Likewise.
	* bundled/linux/include/uapi/linux/fs.h: Likewise.
	* bundled/linux/include/uapi/linux/if_link.h: Likewise.
	* bundled/linux/include/uapi/linux/in.h: Likewise.
	* bundled/linux/include/uapi/linux/input-event-codes.h: Likewise.
	* bundled/linux/include/uapi/linux/io_uring.h: Likewise.
	* bundled/linux/include/uapi/linux/mptcp_pm.h: Likewise.
	* bundled/linux/include/uapi/linux/netfilter/nfnetlink_conntrack.h: Likewise.
	* bundled/linux/include/uapi/linux/nl80211.h: Likewise.
	* bundled/linux/include/uapi/linux/rtnetlink.h: Likewise.
	* bundled/linux/include/uapi/linux/securebits.h: Likewise.
	* bundled/linux/include/uapi/linux/stat.h: Likewise.
	* bundled/linux/include/uapi/linux/stddef.h: Likewise.
	* bundled/linux/include/uapi/linux/taskstats.h: Likewise.
	* bundled/linux/include/uapi/linux/thermal.h: Likewise.
	* bundled/linux/include/uapi/linux/version.h: Likewise.
	* bundled/linux/include/uapi/mtd/ubi-user.h: Likewise.
	* bundled/linux/include/uapi/linux/ethtool_netlink_generated.h: New
	file imported from headers_install'ed Linux kernel v6.14-rc1.
	* bundled/Makefile.am (EXTRA_DIST): Add
	/linux/include/uapi/linux/ethtool_netlink_generated.h.

2025-01-24  Dmitry V. Levin  <ldv@strace.io>

	Post-release administrivia.
	* NEWS: Add a header line for the next release.
	* debian/changelog.in: Add a changelog entry for 6.13-1.
	* strace.spec.in: Likewise.

2025-01-23  Dmitry V. Levin  <ldv@strace.io>

	Prepare for 6.13 release.
	* NEWS: Update for 6.13 release.

2025-01-22  Dmitry V. Levin  <ldv@strace.io>

	Update .mailmap.
	* .mailmap: Add both email addresses of dependabot to avoid duplication
	in CREDITS file.

	Update copyright headers.
	Headers updated automatically using maint/update_copyright_years.sh
	script.

2025-01-22  Dmitry V. Levin  <ldv@strace.io>

	Fix preprocessor indentation.
	Indent the C preprocessor directives to reflect their nesting
	using the following script:

	$ for f in tests/k_sockopt.[hc]; do
		cppi < "$f" > "$f".cppi; mv "$f".cppi "$f"
	done

2025-01-22  Dmitry V. Levin  <ldv@strace.io>

	Update copyright year number range.
	* COPYING: Update copyright year number range.
	* tests/COPYING: Likewise.
	* debian/copyright: Likewise.

	Fix a few typos found using codespell tool.
	* src/s390.c: Replace "valud" with "valid".
	* src/secontext.c: Replace "wihch" with "which".
	* tests/kill_child.c: Replace "unitialised" with "uninitialised".
	* tests/strace--tips.test: Replace "accross" with "across".

	tests: check decoding of removexattrat syscall.
	* tests/removexattrat.c: New file.
	* tests/removexattrat-P.c: Likewise.
	* tests/removexattrat-y.c: Likewise.
	* tests/removexattrat-yy.c: Likewise.
	* tests/pure_executables.list: Add removexattrat, removexattrat-P,
	removexattrat-y, and removexattrat-yy.
	* tests/.gitignore: Likewise.
	* tests/gen_tests.in (removexattrat, removexattrat-P, removexattrat-y,
	removexattrat-yy): New tests.

2025-01-22  Dmitry V. Levin  <ldv@strace.io>

	Implement decoding of removexattrat syscall.
	This new syscall was introduced by Linux kernel commit v6.13-rc1~217.

	* src/linux/generic/syscallent-common.h [BASE_NR + 466]: Wire up
	removexattrat.
	* src/xattr.c (SYS_FUNC(removexattrat)): New function.
	* src/pathtrace.c (pathtrace_match_set): Handle SEN_removexattrat.
	* NEWS: Mention this change.

2025-01-22  Dmitry V. Levin  <ldv@strace.io>

	tests: check decoding of listxattrat syscall.
	* tests/listxattrat.c: New file.
	* tests/listxattrat-P.c: Likewise.
	* tests/listxattrat-y.c: Likewise.
	* tests/listxattrat-yy.c: Likewise.
	* tests/pure_executables.list: Add listxattrat, listxattrat-P,
	listxattrat-y, and listxattrat-yy.
	* tests/.gitignore: Likewise.
	* tests/gen_tests.in (listxattrat, listxattrat-P, listxattrat-y,
	listxattrat-yy): New tests.

2025-01-22  Dmitry V. Levin  <ldv@strace.io>

	Implement decoding of listxattrat syscall.
	This new syscall was introduced by Linux kernel commit v6.13-rc1~217.

	* src/linux/generic/syscallent-common.h [BASE_NR + 465]: Wire up
	listxattrat.
	* src/xattr.c (SYS_FUNC(listxattrat)): New function.
	* src/pathtrace.c (pathtrace_match_set): Handle SEN_listxattrat.
	* NEWS: Mention this change.

